-- Travel reference plugin by David Down
-- coding: utf-8 'ä
import "Turbine"
import "Turbine.Gameplay"
import "Vinny.TravelRef.TR_Data"

function print(text) Turbine.Shell.WriteLine("<rgb=#00FFFF>TR:</rgb> "..text) end
function printh(text) print("<rgb=#00FF00>"..text.."</rgb>") end
function printe(text) print("<rgb=#FF6040>Error: "..text.."</rgb>") end
function printf(fmt, ...) print(string.format(fmt, ...)) end

import "Vinny.Common.Help"

local Coord = "^(%d+%.%d[NnSs]),(%d+%.%d[EeWw])$"
local RCoord = "^(%d) (%d+%.%d[NnSs]),(%d+%.%d[EeWw])$"
local Zloc = "^(.+): .+: (%d+%.%d[NS]), (%d+%.%d[EW])$"
xlink = "<Examine:IIDDID:0x0000000000000000:0x700%s>[%s]<\\Examine>"
local S0 = ", <rgb=#E01000>Req: Current or past subscriber</rgb>"
local Color = {"880088","FF0000","FF8C00","FFFF00","FFFFFF","1E90FF","00CED1","009800","707070"}
local Character = Turbine.DataScope.Character
player = Turbine.Gameplay.LocalPlayer.GetInstance()
plevel = player:GetLevel()
Race = player:GetRace()
PC = player:GetClass()
TR_req = Turbine.PluginData.Load(Character,"Travel_req")
if type(TR_req) ~= "table" then TR_req = {S0=true} end
if not TR_req.NV then TR_req.NV = {} end
local TRv = "Travel Ref. "..Plugins["TravelRef"]:GetVersion()

TR_Opt = Turbine.PluginData.Load(Turbine.DataScope.Server,"TravelRef_Opt")
if not TR_Opt then
    TR_Opt = { SE=true }
	printh(TRv..", settings initialized.")
else printh(TRv..", settings loaded.") end

function TR_Req( code,flag )
	local str = ""
	for s in string.gmatch(code,"%u%d+") do
		local c = string.sub(s,1,1)
		local txt = rType[c]..": "..Reqs[s]
		if flag and not TR_req[s] then
			str = str..", <rgb=#E01000>"..txt.."</rgb>"
		else str = str..", "..txt end
	end
	return str
end

import "Vinny.TravelRef.TR_Window"
Plugins.TravelRef.Open = function(sender,args)
	TR_window:SetVisible( true )
	TR_window:SetZOrder( 2 )
end

if TR_Opt and TR_Opt.auto then
	TR_window:SetPosition(TR_Opt.auto.x, TR_Opt.auto.y)
	TR_window:SetVisible( true )
end

local function distance(dy,dx) return math.sqrt(dy*dy+dx*dx) end

local function locV(str,neg)
    local nbr = tonumber(str:sub(1,-2))
    if neg:find(str:sub(-1)) then nbr = -nbr end
    return nbr
end

local function barter(name,s,lvl)
	local b,c = Barter[name],''
	if s=="L" then s = 'Level='..lvl
	elseif b then
		local bn,l = "Barter: Quartermaster",b
		if type(b)=="table" then
			l = b.l
			if b.n then
				if not l then bn = b.n
				else bn = (s and 'Quest: ' or 'Barter: ')..b.n end
			end
			if b.id then
				c = ' '..string.format(xlink,b.id,b.c..' '..Coin[b.id])
			elseif b.c then 
				bn= 'Shop: '..b.n
				c = ' '..b.c..'s'
			end
		end
		s = bn..(l and "@"..l or '')
	end
	return s and " ("..s..")"..c or ''
end

function TR_lvl( lvl,pl )
	if pl>=lvl then return ", Min Lvl: "..lvl end
	return ", <rgb=#E01000>Min Lvl: "..lvl.."</rgb>"
end

function TR_Time( secs )
	if not secs then return "" end
	local min = math.floor(secs/60)
	secs = secs - min*60
	return string.format(", Time=%d:%02d",min,secs)
end

local function d2(n)
	return math.floor(n*100+.5)/100
end

function TR_Dest( name,d,pl,flag,td )
	local tdr = TR_req[td] and TD_list[td] or 1
	if td=="R17" and TR_req.R18 then tdr = tdr-0.1 end -- special case
	if not Locs[name] then
		printe("Location entry for '"..name.."' is missing.")
		return
	end
	local n = Locs[name].n -- alternate name?
	if TR_req[name] then name="<rgb=#E01000>"..name.."</rgb>" end
	local str,l,c,t = n or name, d.l, d.c, d.t
	if l and (l<0 or not d.s) then
		if l<0 then l = -l end
		if TR_Opt.Hal and pl<l then 
			if not Turbine.UI.Control.IsShiftKeyDown() then return end
		end
		str = str..TR_lvl(l,pl)
	end
	if TR_req.S2 then tdr = tdr*0.8 end -- Global 20% discount?
	local dr = d.r
	if dr and dr:find(",") then -- req for c
		local i = dr:find(",")
		str=str..TR_Req(dr:sub(i+1),flag)
--		dr = dr:sub(1,i-1)
	end
	if d.n then -- special named instant travel
		l = d.nl and '('..d.nl..')' or ""
		print(str.."(ST): "..d.n..l)
		return
	end
	if d.s then
		if d.c and pl<=Max_lvl then print(str..", Cost="..d2(c*tdr).."s"..TR_Time(t)) end
		str,c,t = name.."(ST)", d.s, d.st
		if l then 
			if TR_Opt.Hal and pl<l then return end
			str=str..TR_lvl(l,pl) 
		end
		if dr then str=str..TR_Req(dr,flag) end
		if not TR_req.S0 and not d.S0 then str=str..S0 end
	end
	if c then print(str..", Cost="..d2(c*tdr).."s"..TR_Time(t)) end
	if d.mt then
		str=name.."(MT)"
		if dr then str=str..TR_Req(dr,flag) end
		print(str..TR_Time(d.mt))
	end
end

function Loc_Find(r, y, x, locs)
	local d1,y1,x1,ln = 999,locV(y,"Ss"), locV(x,"Ww"), ''
	local y2,x2,d,c
	for loc,t in pairs(locs) do
		if (flg or t.d) and t.r==r or not r then
			local y0,x0 = t.l:match(Coord)
			if not y0 then printe("Bad Loc for "..loc) return end
			y2,x2 = locV(y0,"Ss"), locV(x0,"Ww")
			d = distance(y1-y2,x1-x2)
			if d<d1 then d1 = d; ln = r and loc or t.n; c = t.l end
		end
	end
	return string.format("%s @ %s (%.1f units away).",ln,c,d1), ln
end

function TR_Find( args, locs, flg )
	local reg,y,x = args:match(Zloc)
	if y then
		local r = Region[reg]
		if not r then print("Unknown region: "..reg) return end
		local d,ln = Loc_Find(r, y, x, locs)
		local w = flg and "Recruiter " or ""
		print("The nearest "..w.."stable is "..d)
		TR_window.zoneMenu:SetText( locs[ln].z )
		TR_window.locMenu:SetText( ln )
	else printe("No location data in instance.") end
end

TR_Command = Turbine.ShellCommand()
function TR_Command:GetShortHelp() return Vinny.Common.Help(help,"??") end
function TR_Command:GetHelp() return Vinny.Common.Help(help,"help") end

function TR_Command:Execute( cmd,args,lvl,flag )
	if Vinny.Common.HelpCmd(cmd,args,help) then return end
	if cmd=="trl" then
		TR_Find( args, Locs )
		return
	end
	if cmd=="trc" then
		local r,y,x = args:match(RCoord)
		if r then r = tonumber(r) end
		if not r or r<1 or r>5 then printe("Invalid region/location.") return end
		local d = Loc_Find(r, y, x, Locs)
		print("Nearest stable: "..d)
		return
	end
	if cmd=="trf" then
		if args~="" then
			local str=args:lower()
			local ln
      		printh("Locations with matching names:")
			for name,loc in pairs(Locs) do
				if name:lower():find(str,1,true) then
					print(name.." in "..loc.z)
					if ln then ln = true
					else ln = name end
				end
			end
			if not ln then print("(none found)")
			elseif ln ~= true then
				TR_window.zoneMenu:SetText( Locs[ln].z )
				TR_window.locMenu:SetText( ln )
			end
		else printe("No location name.") end
		return
	end
	if cmd=="trv" then
		if args=="" then
			printh("Stables that haven't been visited:")
			for name,nv in pairs(TR_req) do
				if nv and Locs[name] then
					print(name.." in "..Locs[name].z)
				end
			end
			return
		end
		if Locs[args] then
			TR_req[args] = not TR_req[args]
			Turbine.PluginData.Save(Character,"Travel_req",TR_req)
			local str = TR_req[args] and "Not " or ""
			print(str.."Visited: "..args)
			return
		end
		local reg,y,x = args:match(Zloc)
		if not reg then printe("Unknown location") return end
		local locs = Vaults[reg]
		if not locs then printe("No vault found.") return end
		local d = Loc_Find(nil, y, x, locs)
		print("Nearest vault: "..d)
		return
	end
	if cmd=="trr" then
		if args=="" then
			printh("Recruiter stable locations:")
			for name,loc in pairs(WE_Locs) do
				print(name.." @ "..loc.l.." in "..loc.z)
			end
		else TR_Find( args, R_Locs, true ) end
		return
	end
	if args=="zones" then
		local cz,czt = Turbine.UI.Control.IsShiftKeyDown(),{}
		if cz then printh("Zones for XP:")
		else printh("Currently defined zones with stables:") end
		for i,name in ipairs(zones) do
			local lvl = Zlvl[name]
			local str = tostring(lvl+7)
			if plevel<lvl then str = "<rgb=#FF6040>"..str.."</rgb>"
			elseif plevel<lvl+18 then 
				str = "<rgb=#00FF00>"..str.."</rgb>" 
				if cz then table.insert(czt,name) end
			end
			if not cz then print(name.."("..Zones[name]..") = "..str..'+') end
		end
		if cz then
			table.sort(czt, function(a,b) return Zlvl[a]<Zlvl[b] end )
			for i,name in ipairs(czt) do
				print(name.." = "..(Zlvl[name]+7))
			end
		end
		return
	end
	if args=="areas" then
		printh("Known zone areas with stables:")
		local Loc_list = {}
		for name,z in pairs(Areas) do
			table.insert(Loc_list,name)
		end
		table.sort(Loc_list)
		for ix,name in ipairs(Loc_list) do
			print(name.." in "..Areas[name])
		end
		return
	end
	if args=="rt" then
		printh("Learnable Return to destinations:")
		local nr = 0
		local rt = TR_req.RT
		for name,t in pairs(Return) do
			local n= t.n or name
			if t.t and not rt[n] and t.tl<=plevel and (t.id or (t.r and t.r==Race)) then
				local s= (t.r==Race and " (Trait)") or barter(name)
				local id= t.id or t.d or t.rd
				print(string.format(xlink,id,"Return to "..n)..s)
				nr = nr+1
			end
		end
		if not rt["Ost Guruth"] then
			print("<rgb=#F000F0>[Return to Ost Guruth]</rgb> (Kindred with The Eglain)")
			nr = nr+1
		end
		if nr==0 then print("(None)") end
		return
	end
	if args=="gms" then
    	local tbl
		if PC==162 then tbl = Guide
    	elseif PC==194 then tbl = Muster
    	elseif PC==216 then tbl = Sail
		else printe("Must be Hunter, Warden or Mariner.") return end
		local rq = TR_req[tbl.tb]
		printh("Learnable "..tbl.nm.." destinations:")
		local nr = 0
		for name,t in pairs(tbl) do
			if #name>2 then
				local n,s= t.n or name
				local known = rq and rq[n]
				local id = t.id
				if t.q then id=t.q; s='Q'
				elseif #id<5 then
					s = id
					id = t.d
				end
				if t.id and t.tl<=plevel and not known then
					nr = nr+1
					s = barter(name,s,t.tl)
					print(string.format(xlink,id,tbl.nm.." "..n)..s)
				end
			end
		end
		if nr==0 then print("(None)") end
		return
	end
    if args=="ms" then
    	local cnt,tb = 0, TR_req.MS
    	print("Current milestone settings:")
    	for ix,ms in ipairs(Ms_list) do
    		if tb[ms] then
    			cnt = cnt+1
    			print("#"..ms..": Return to "..tb[ms])
    		end
    	end
    	if cnt==0 then print("(None set)") end
    	return
    end
	if args=="vaults" then
        local zone = TR_window.zoneMenu:GetText()
		if zone=="" then printe("No zone selected.") return end
		printh("Known vaults in "..zone..":")
		local n = 0
		for reg,t in pairs(Vaults) do
			for ix,loc in ipairs(t) do
				if loc.z==zone then
					print(loc.n.." @ "..loc.l)
					n = n+1
				end
			end
		end
		if n==0 then print("(None)") end
		return
	end
	-- Test for missing destinations
	if args=="dest" then
		printh("Undefined Destinations:")
		for name,l in pairs(Locs) do
			if l.d then
				for dest in pairs(l.d) do
					if not Locs[dest] then
						print( name.."->"..dest )
					end
				end
			end
		end
		return
	end
	-- Test for missing swift travel times
	if args=="st" then
		printh("Destinations without travel times:")
		for name,l in pairs(Locs) do
			if l.d and l.r==nil then
				for dest,t in pairs(l.d) do
					if t.s and not t.st then
						TR_Dest( name.."->"..dest,t,66,true )
					end
				end
			end
		end
		return
	end
	if Zones[args] then
		printh("Known stable locations in "..args..":")
		local Loc_list = {}
		for name,t in pairs(Locs) do
			if t.z==args and t.d then table.insert(Loc_list,name) end
		end
		table.sort(Loc_list)
		for ix,name in ipairs(Loc_list) do
				local sz,str = "",name
				if TR_req[name] then str="<rgb=#E01000>"..str.."</rgb>" end
				local t = Locs[name]
				if t.a then sz = " in "..t.a end
				local ql = t.ql
				if ql then
					local ld,cs = (plevel-ql)/2+4, Color[9]
					for i,cc in ipairs(Color) do
						if ld<i then cs = Color[i] break end
					end
					sz = sz..", QL=<rgb=#"..cs..">"..ql.."</rgb>"
				end
				print(str.." @ "..t.l..sz)
		end
		return
	end
	local t = Locs[args]
	if t then
		if not t.d then
			print(args.." is only a destination in "..t.z)
			return
		end
		if not lvl then lvl = plevel end
		local z, td = t.z, t.td 
		if t.r then
			if t.a then z = string.format("%s(%s)", t.a,z) end
			print(string.format("<rgb=#00FF00>%s @ %s in %s destinations:</rgb>",args,t.l,z))
		elseif args==Hs then printh("House stable travel destinations:")
		else printh("House boat travel destinations:") end
		dest = { }
		for name in pairs(t.d) do
			table.insert(dest,name)
		end
		table.sort(dest)
		for i,name in ipairs(dest) do
			TR_Dest( name,t.d[name],lvl,flag or false,td )
		end
		return
	end
	if Areas[args] then
		z = Areas[args]
		printh("Known stable locations in "..args.." (part of "..z.."):")
		local Loc_list = {}
		for name,t in pairs(Locs) do
			if t.a==args and t.d then table.insert(Loc_list,name) end
		end
		table.sort(Loc_list)
		for ix,name in ipairs(Loc_list) do
			local str = name
			if TR_req[name] then str="<rgb=#E01000>"..str.."</rgb>" end
			print(str.." @ "..Locs[name].l)
		end
		return
	end
    local y,x,d = args:match(Coord)
    if y then
		local d1,y1,x1,ln = 999,locV(y,"Ss"), locV(x,"Ww")
		for loc,t in pairs(Locs) do
			if t.d then
				y,x = t.l:match(Coord)
				local y2,x2 = locV(y,"Ss"), locV(x,"Ww")
				d = distance(y1-y2,x1-x2)
				if d<d1 then d1 = d; ln = loc end
			end
		end
		d = string.format(" (%.1f units away).",d1)
		local t = Locs[ln]
		print("The nearest stable to "..args.." is "..ln.." @ "..t.l..d)
		TR_window.zoneMenu:SetText( t.z )
		TR_window.locMenu:SetText( ln )
		TR_window:SetVisible( true )
		return
	end
	Vinny.Common.Help(help,args)
end

Turbine.Shell.AddCommand( "tr;trv;trl;trf;trr;trc;tr?",TR_Command )

Plugins.TravelRef.Unload = function(sender,args)
	pname = player:GetName()
	if pname:sub(1,1)=="~" then return end -- session play?
    Turbine.PluginData.Save(Turbine.DataScope.Server,"TravelRef_Opt",TR_Opt)
    print(TRv..", settings saved.")
end

-- Options panel
import "Vinny.Common.Options"
OP = Vinny.Common.Options_Init(print,TR_Opt,TR_window,"TravelRef_Opt")

local SE = Vinny.Common.Options_Box(OP,30," Default to Set End")
if TR_Opt.SE then SE:SetChecked(true) end
SE.CheckedChanged = function( sender, args )
	TR_Opt.SE = sender:IsChecked()
	print((TR_Opt.SE and "En" or "Dis").."abled Set End.")
end

local Hal = Vinny.Common.Options_Box(OP,50," Hide above level")
if TR_Opt.Hal then Hal:SetChecked(true) end
Hal.CheckedChanged = function( sender, args )
	TR_Opt.Hal = sender:IsChecked()
	print((TR_Opt.Hal and "En" or "Dis").."abled Hide above level.")
end

-- Help text
help = {
	pre = "tr",
	arg = {
		gms = "List learnable Guide/Muster/Sail skills.",
		rt = "List learnable 'Return to' skills.",
		ms = "List milestone settings.",
		zones = "List zones with stables.",
		["<area>"] = "List stables in <area>.",
		["<zone>"] = "List stables in <zone>.",
		["<name>"] = "Display location info and destination list.",
	},
	cmd = {
		trf = "Find a matching stable location name.",
		["trl ;loc"] = "Find the nearest stable.",
		trr = "List known recruiter stables.",
		trv = {
			[" "] = "List stables marked as not visited.",
			["<name>"] = "Toggle not visited status.",
			[";loc"] = "Find the nearest vault.",
		},
		trw = {
			[" "] = "Open Travel Ref. window.",
			ht = "Open House Travel window.",
			gm = "Open Guide/Muster window.",
			rt = "Open Return to window.",
			tr = "Open Travel Requirements window.",
			td = "Open Travel Discounts window.",
		},
	},
}
