-- Database for Travel locations
-- coding: utf-8 'ä
-- Loc. keys: d=destinations(nil if no stable), z=zone, a=area, l=location
--				t=milestone time, ml=minimum level (milestone)
-- Dest. keys: c=cost, s=ST cost, l=min level(+ if ST only), r=requires, t=time, st=ST time
Max_lvl = 150
Region = { Eriador=1, Rhovanion=2, ["Tales of Yore"]=2, Gondor=3, Mordor=4, Haradwaith=5 }
R_Dest = { -- Recruiter destinations
	["Trestlebridge(R)"] = { l=20, s=1, st=4, S0=true },
	["Annak-khurfu(I)"] = { l=20, s=1, st=6, S0=true },
	["Akraz-zahar(I)"] = { l=20, s=1, st=5, S0=true },
	["Steepset"] = { l=20, s=1, st=3, S0=true },
	}
R_Locs = { -- Recruiter stables
	["Thorin's Gate"] = {z="Ered Luin", r=1, l="15.0s,103.6w"},
	["Gondamon"] = {z="Ered Luin", r=1, l="20.4s,97.1w"},
	["Bree"] = { z="Bree-Land", r=1, a="Bree", l="31.0s,52.0w"},
	["Trestlebridge(R)"] = {z="North Downs", r=1, l="17.7s,54.3w"},
	["Othrikar"] = {z="North Downs", r=1, l="6.8s,44.9w"},
	["Gabilshathur"] = {z="Angmar", r=1, l="3.8s,26.6w"},
	["Gloin's Camp"] = {z="Misty Mountains", r=1, l="24.9s,4.0w"},
	["Hrimbarg"] = {z="Misty Mountains", r=1, l="24.5s,7.0e"},
	["Dolven-view"] = {z="Moria", r=2, l="8.4s,112.0w"},
	["Twenty-first Hall"] = {z="Moria", r=2, l="5.9s,105.2w"},
	["Galtrev"] = {z="Dubland", r=1, l="80.0s,16.6w"},
	["Magh Ashtu"] = {z="Gorgoroth", r=4, l="53.1s,10.6e"},
	["Jarnfast"] = {z="Dwarf-holds", r=2, l="28.3n,3.7w"},
	["Erebor"] = {z="Strongholds", r=2, l="28.9n,25.5w"},
	["Minas Tirith(M)"] = {z="Eastern Gondor", r=3, l="22.5n,53.7w"},
	["Annak-khurfu(I)"] = { z="Elderslade", r=2, l="32.8n,61.2w"},
	["Akraz-zahar(I)"] = {z="Strongholds", r=2, l="14.7n,136.1w"},
	["Steepset"] = {z="Gundabad", r=2, l="45.4s,115.0w"},
	}
Hs = "Homestead"
Dm = "Dock-master"
Locs = {
	[Hs] = { d={
		["Lond Cirion"] = { l=130, s=180, st=24 },
		["Minas Tirith(M)"] = { s=1, st=21, S0=true },
		["Osgiliath"] = { l=80, s=122, st=15 },
		["Breeland Festival Grounds"] = { s=1, st=10, S0=true },
		["Breeland Homesteads"] = { s=1, st=17, S0=true },
		["South Bree"] = { s=1, st=13 },
		["Galtrev"] = { l=50, s=122, st=12 },
		["Annak-khurfu(I)"] = { l=20, s=1, st=6, S0=true },
		["Abodes of Erebor"] = { l=130, s=1, st=13, S0=true },
		["Akraz-zahar(I)"] = { l=20, s=1, st=5, S0=true },
		["Celondim"] = { s=1, st=7, S0=true },
		["Falathorn Homesteads"] = { s=1, st=15, S0=true },
		["Thorin's Gate"] = { s=1, st=13, S0=true },
		["Thorin's Hall Homesteads"] = { s=5, st=9, S0=true },
		["Steepset"] = { l=20, s=1, st=3, S0=true },
		["Estolad Lan"] = { l=110, s=147.5, st=7 },
		["Dol Amroth(KG)"] = { l=135, s=180, st=36, S0=tru },
		["Pelargir West Gate"] = { l=130, s=161.35, st=16, S0=tru },
		["Caras Galadhon"] = { l=50, s=45, st=8, r="D14" },
		["Magh Ashtu"] = { l=80, s=122, st=10 },
		["Twenty-first Hall"] = { l=50, s=45, st=8 },
		["Snowbourn"] = { l=50, s=71.5, st=11 },
		["Aldburg"] = { l=50, s=71.5, st=16 },
		["Eastfold Hills Homesteads"] = { s=1, st=8, S0=true },
		["Edoras"] = { l=50, s=71.5, st=15 },
		["Kingstead Meadows Homesteads"] = { s=1, st=47, S0=true },
		["Erebor"] = { l=80, s=93.5, st=7 },
		["Felegoth"] = { l=80, s=93.5, st=7 },
		["Mossward"] = { s=5, st=28 },
		["Skarhald"] = { l=100, s=122, st=15 },
		["Ettenmoors"] = { l=20, s=1, st=30, S0=true },
		["Trestlebridge(R)"] = { l=20, s=1, st=4, S0=true },
		["Michel Delving"] = { s=1, st=10, S0=true },
		["Shire Homesteads"] = { s=1, st=10, S0=true },
		["The Party Tree"] = { s=1, st=5, S0=true },
		["Rivendell Stables"] = { s=20, l=20, st=10 },
		["Cape of Belfalas Housing"] = { s=10, st=5, S0=true },
		}, z=Hs, l="0.0n,0.0e" },
	[Dm] = { d={
		["Buckland(B)"] = { l=15, s=15, st=5 },
		["King's Crossing(B)"] = { l=35, s=25, st=5 },
		["Lothlorien(B)"] = { l=45, s=180, st=5 },
		["Pelargir(B)"] = { l=130, s=161.35, st=5 },
		["The Harlond(B)"] = { l=130, s=161.35, st=5  },
		["Dol Amroth(B)"] = { l=135, s=180, st=5 },
		["Lond Cirion(B)"] = { l=135, s=180, st=5 },
		["Halrax(B)"] = { l=135, s=180, st=5 },
		["Umbar Baharbel(B)"] = { l=135, s=180, st=5 },
		}, z=Hs, l="0.0n,0.0e" },
	-- Ered Luin starts here
	["Thorin's Gate"] = { t=41, ql=4, d={
		["Minas Tirith(M)"] = { s=1, st=3, S0=true },
		["Combe"] = { s=1, st=24 },
		["West Bree"] = { s=1, st=28, S0=true },
		["Annak-khurfu(I)"] = { s=0, l=115, st=34 },
		["Celondim"] = { s=1, st=24, S0=true },
		["Duillond"] = { c=1, t=307 },
		["Gondamon"] = { c=1, t=180 },
		["Noglond"] = { c=1, t=114 },
		["Thorin's Hall Homesteads"] = { c=1, t=30, s=5, st=17, S0=true },
		["Trestlebridge(R)"] = { l=20, s=1, st=4, S0=true },
		["Mossward"] = { s=5, st=28 },
		["Ettenmoors"] = { s=1, l=40, st=30, S0=true },
		["Michel Delving"] = { s=1, st=24, S0=true },
		}, z="Ered Luin", r=1, a="Thorin's Gate", td="R9", l="15.0s,103.6w" },
	["Thorin's Hall Homesteads"] = { z="Ered Luin", r=1, a="Thorin's Gate", l="15.3s,107.8w" },
	["Noglond"] = { ql=7, d={ --
		["Thorin's Gate"] = { c=1, t=114 },
		["Gondamon"] = { c=1, t=84 },
		}, z="Ered Luin", r=1, td="R9", l="19.4s,100.6w" },
	["Gondamon"] = { t=7, ql=10, d={
		["Thorin's Gate"] = { c=1, t=180 },
		["Duillond"] = { c=1, t=154 },
		["Noglond"] = { c=1, t=84 },
		["Thrasi's Lodge"] = { c=1, t=90 },
		}, z="Ered Luin", r=1, td="R9", l="20.4s,97.1w" },
	["Thrasi's Lodge"] = { ql=10, d={ --
		["Gondamon"] = { c=1, t=90 },
		["Duillond"] = { c=1, t=84 },
		}, z="Ered Luin", r=1, l="21.6s,94.1w" },
	["Falathorn Homesteads"] = { z="Ered Luin", r=1, l="25.9s,90.7w" },
	["Duillond"] = { t=1, ql=9, d={
		["Buckland"] = { s=5, st=21 },
		["Celondim"] = { c=1, t=79 },
		["Falathorn Homesteads"] = { c=1, t=114, s=5, st=25, S0=true },
		["Gondamon"] = { c=1, t=154 },
		["Thorin's Gate"] = { c=1, t=307 },
		["Thrasi's Lodge"] = { c=1, t=84 },
		["Oatbarton"] = { l=20, s=5, st=24 },
		["Brockenborings"] = { s=5, st=18 },
		["Bullroarer's Way"] = { c=1, t=417, l=-20, s=5, st=22 },
		["Foxden Road"] = { c=1, t=353, l=-20, s=5, st=19 },
		["Gamwich"] = { c=1, t=277, l=-20, s=5, st=24 },
		["Hobbiton"] = { s=5, st=18 },
		["Long Cleeve"] = { c=1, t=400, l=-20, s=5, st=21 },
		["Michel Delving"] = { c=1, t=476, s=5, st=20 },
		["Needlehole"] = { c=5, t=150, s=5, st=22  },
		["Nobottle"] = { c=1, t=317, l=-20, s=5, st=21 },
		["Stock"] = { s=5, st=24 },
		["Tighfield"] = { c=1, t=264, l=-20, s=5, st=24 },
		}, z="Ered Luin", r=1, l="24.4s,93.2w" },
	["Celondim"] = { t=11, ql=6, d={
		["Combe"] = { s=1, st=18 },
		["West Bree"] = { s=1, st=20, S0=true },
		["Duillond"] = { c=1, t=79 },
		["Falathorn Homesteads"] = { c=1, t=168, s=5, st=23, S0=true },
		["Thorin's Gate"] = { s=1, st=24, S0=true },
		["Mossward"] = { s=5, st=20 },
		["Michel Delving"] = { s=1, st=19, S0=true },
		}, z="Ered Luin", r=1, l="28.1s,92.4w" },
	-- The Shire starts here
	["Brockenborings"] = { t=14, ql=10, d={
		["Buckland"] = { s=5, st=19 },
		["Duillond"] = { s=5, st=18  },
		["Oatbarton"] = { c=15, t=77, s=25, st=15 },
		["Bullroarer's Way"] = { l=20, s=5, st=17 },
		["Foxden Road"] = { l=20, s=5, st=20 },
		["Gamwich"] = { l=20, s=5, st=20 },
		["Hobbiton"] = { c=1, t=104, s=5, st=17 },
		["Long Cleeve"] = { l=20, s=5, st=16 },
		["Michel Delving"] = { s=5, st=16 },
		["Needlehole"] = { s=5, st=16 },
		["Nobottle"] = { l=20, s=5, st=21 },
		["Stock"] = { c=1, t=128, s=5, st=18 },
		["Tighfield"] = {  l=20, s=5, st=16 },
		}, z="The Shire", r=1, l="27.4s,68.1w" },
	["Hobbiton"] = { t=3, ql=7, d={
		["Buckland"] = { s=5, st=18 },
		["West Bree"] = { c=5, t=337 },
		["Duillond"] = { s=5, st=18  },
		["Oatbarton"] = { l=20, s=5, st=16 }, 
		["Brockenborings"] = { c=1, t=104, s=5, st=17 },
		["Bullroarer's Way"] = { l=20, s=5, st=19 },
		["Foxden Road"] = { l=20, s=5, st=17 },
		["Gamwich"] = { l=20, s=5, st=22 },
		["Long Cleeve"] = { l=20, s=5, st=18 },
		["Michel Delving"] = { c=1, t=102, s=5, st=21 },
		["Needlehole"] = { c=1, t=166, s=5, st=20 },
		["Nobottle"] = { l=20, s=5, st=23 },
		["Shire Homesteads"] = { c=1, t=118, s=5, st=18, S0=true },
		["Stock"] = { c=1, t=131, s=5, st=18 },
		["Tighfield"] = {  l=20, s=5, st=16 },
		}, z="The Shire", r=1, td="R10", l="31.5s,71.2w" },
	["Michel Delving"] = { t=18, ql=5, d={
		["Minas Tirith(M)"] = { s=1, st=28, S0=true },
		["Buckland"] = { s=5, st=20 },
		["Combe"] = { s=1, st=19 },
		["West Bree"] = { s=1, st=22, S0=true },
		["Sarn Ford"] = { l=10, s=25, st=22 },
		["Celondim"] = { s=1, st=19, S0=true },
		["Duillond"] = { c=1, t=476, l=-20, s=5, st=20  },
		["Thorin's Gate"] = { s=1, st=24, S0=true },
		["Oatbarton"] = { l=20, s=5, st=16 }, 
		["Tinnudir"] = { s=35, st=38 },
		["Mossward"] = { s=5, st=21 },
		["Ettenmoors"] = { s=1, l=20, st=30, S0=true },
		["Brockenborings"] = { s=5, st=16 },
		["Bullroarer's Way"] = { c=1, t=272, l=-20, s=5, st=21 },
		["Foxden Road"] = { c=1, t=127, l=-20, s=5, st=17 },
		["Gamwich"] = { c=1, t=269, l=-20, s=5, st=22 },
		["Hobbiton"] = { c=1, t=102, s=5, st=21 },
		["Long Cleeve"] = { c=1, t=256, l=-20, s=5, st=19 },
		["Needlehole"] = { s=5, st=18 },
		["Nobottle"] = { c=1, t=176, l=-20, s=5, st=26 },
		["Shire Homesteads"] = { c=1, t=112, s=5, st=18, S0=true },
		["Stock"] = { s=5, st=19 },
		["Tighfield"] = { c=1, t=234, l=-20, s=5, st=17 },
		}, z="The Shire", r=1, td="R10", l="34.2s,75.5w" },
	["Shire Homesteads"] = { z="The Shire", r=1, l="36.8s,73.8w" },
	["The Party Tree"] = { z="The Shire", r=1, l="29.8s,71.5w" },
	["Needlehole"] = { ql=7, d={
		["Buckland"] = { s=5, st=19 },
		["Duillond"] = { c=5, t=150, s=5, st=22 },
		["Oatbarton"] = { l=20, s=20, st=15 },
		["Brockenborings"] = { s=5, st=16 },
		["Bullroarer's Way"] = { l=20, s=5, st=15 },
		["Foxden Road"] = { l=20, s=5, st=16 },
		["Gamwich"] = { l=20, s=5, st=18 },
		["Hobbiton"] = { c=1, t=166, s=5, st=20 },
		["Long Cleeve"] = { l=20, s=5, st=19 },
		["Michel Delving"] = { s=5, st=18 },
		["Nobottle"] = { l=20, s=5, st=19 },
		["Stock"] = { s=5, st=19 },
		["Tighfield"] = { l=20, s=5, st=12 },
		}, z="The Shire", r=1, td="R10", l="27.9s,76.1w" },
	["Stock"] = { ql=9, d={
		["Buckland"] = { c=1, t=69, s=5, st=17 },
		["Duillond"] = { s=5, st=24 },
		["Oatbarton"] = { l=20, s=20, st=18 },
		["Brockenborings"] = { c=1, t=128, s=5, st=18 },
		["Bullroarer's Way"] = { l=20, s=5, st=22 },
		["Foxden Road"] = { l=20, s=5, st=23 },
		["Gamwich"] = { l=20, s=5, st=23 },
		["Hobbiton"] = { c=1, t=131, s=5, st=18 },
		["Long Cleeve"] = { l=20, s=5, st=20 },
		["Michel Delving"] = { s=5, st=19 },
		["Needlehole"] = { s=5, st=19 },
		["Nobottle"] = { l=20, s=5, st=23 },
		["Tighfield"] = { l=20, s=5, st=18 },
		}, z="The Shire", r=1, td="R10", l="32.1s,64.1w" },
	-- Bree-Land starts here
	["Combe"] = { t=5, ql=5, d={
		["South Bree"] = { c=1, t=90 },
		["Celondim"] = { s=1, st=18 },
		["Thorin's Gate"] = { s=1, st=24 },
		["Michel Delving"] = { s=1, st=19 },
		}, z="Bree-Land", r=1, l="28.6s,49.5w" },
	["West Bree"] = { t=16, ql=14, d={
		["Adso's Camp"] = { c=1, t=67 },
		["Buckland"] = { c=1, t=211 },
		["Hengstacer Farm"] = { c=1, t=160 },
		["South Bree"] = { mt=75, s=1, st=18 },
		["Bree(R)"] = { mt=35 },
		["Andrath"] = { c=1500, t=161, l=-10, st=2500, t=14 },
		["Herne"] = { c=1500, t=418, l=-10, st=2500, t=30 },
		["Celondim"] = { s=1, st=20, S0=true },
		["Thorin's Gate"] = { s=1, st=28, S0=true },
		["Ost Forod"] = { s=35, l=30, st=36 },
		["Tinnudir"] = { s=35, st=40 },
		["Suri-kyla"] = { s=35, l=40, st=39, r="R3" },
		["Mossward"] = { st=500, t=23 },
		["Esteldin"] = { s=35, l=30, st=33 },
		["Trestlebridge"] = { c=5, t=209 },
		["Hobbiton"] = { c=5, t=337 },
		["Michel Delving"] = { s=1, st=22, S0=true },
		}, z="Bree-Land", r=1, a="Bree", td="R11", l="29.5s,52.6w" },
	["Lalia's Market"] = { ql=14, d={
		["Bree(R)"] = { mt=35 },
		["Combe"] = { mt=71 },
		["South Bree"] = { mt=52 },
		["West Bree"] = { mt=50 },
		}, z="Bree-Land", r=1, l="30.2s,51.3w" },
	["Bree(R)"] = { ql=15, d={
		["Annak-khurfu(I)"] = { l=20, s=1, st=5, S0=true },
		["Akraz-zahar(I)"] = { l=20, s=1, st=5, S0=true },
		["Trestlebridge(R)"] = { l=20, s=1, st=3, S0=true },
		["Steepset"] = { l=20, s=1, st=4, S0=true },
		}, z="Bree-Land", r=1, a="Bree", l="31.0s,52.0w" },
	["South Bree"] = { t=60, ql=14, d={
		["Lond Cirion"] = { l=130, s=180, st=24 },
		["Minas Tirith(M)"] = { s=1, st=31, S0=true },
		["Osgiliath"] = { l=90, s=122, st=18 },
		["Breeland Homesteads"] = { c=1, t=107, s=5, st=27 },
		["Combe"] = { c=1, t=90 },
		["Bree(R)"] = { mt=43 },
		["West Bree"] = { mt=75, s=1, st=18 },
		["Galtrev"] = { l=65, s=45, st=22 },
		["Annak-khurfu"] = { l=115, s=147.5, st=32 },
		["Lhanuch"] = { l=50, s=45, st=28, r="D6" },
		["Celondim"] = { s=1, st=25 },
		["Thorin's Gate"] = { s=1, st=24 },
		["Stangard"] = { s=45, l=70, st=20 },
		["Zidir-nesad"] = { l=130, s=161.35, st=24 },
		["Linhir(KG)"] = { s=162.25, l=130, st=24 },
		["Pelargir East Gate"] = { s=162.25, l=130, st=17 },
		["Pelargir West Gate"] = { s=162.25, l=130, st=15 },
		["Magh Ashtu"] = { l=90, s=122, st=25 },
		["Minas Tirith"] = { s=115, l=90, st=30 },
		["Snowbourn"] = { l=75, s=71.5, st=42 },
		["Aldburg"] = { l=85, s=71.5, st=24 },
		["Helm's Deep"] = { l=85, s=71.5, st=19 },
		["Forlaw"] = { l=75, s=71.5, st=19 },
		["Dale"] = { l=90, s=122, st=18 },
		["Lake-town"] = { l=90, s=122, st=17 },
		["Jarnfast"] = { l=90, s=122, st=35 },
		["Skarhald"] = { l=90, s=122, st=30 },
		["Ettenmoors"] = { l=20, s=1, st=30, S0=true },
		["Ost Guruth"] = { l=15, s=20, st=24 },
		["The Forsaken Inn"] = { c=5, t=190 },
		["Michel Delving"] = { s=1, st=24 },
		["Rivendell Stables"] = { l=40, s=35, st=21 },
		["Hultvis"] = { l=90, s=122, st=22 },
		["Dol Amroth"] = { l=90, s=115, st=24 },
		}, z="Bree-Land", r=1, a="Bree", td="R11", l="31.9s,50.4w" },
	["Breeland Homesteads"] = { z="Bree-Land", r=1, l="36.1s,47.1w" },
	["Breeland Festival Grounds"] = { d={
		["West Bree"] = { s=0, st=2, S0=true },
    }, z="Bree-Land", r=1, l="24.3s,51.3w" },
	["Adso's Camp"] = { ql=15, d={ --
		["Buckland"] = { c=1, t=144 },
		["West Bree"] = { c=1, t=67 },
		}, z="Bree-Land", r=1, td="R11", l="29.2s,56.6w" },
	["Buckland"] = { t=22, d={
		["Adso's Camp"] = { c=1, t=144 },
		["West Bree"] = { c=1, t=211 },
		["Buckland(B)"] = { mt=40 },
		["Duillond"] = { s=5, st=21  },
		["Oatbarton"] = { l=20, s=5, st=18 }, 
		["Brockenborings"] = { s=5, st=19 },
		["Bullroarer's Way"] = { l=20, s=5, st=20 },
		["Foxden Road"] = { l=20, s=5, st=18 },
		["Gamwich"] = { l=20, s=5, st=23 },
		["Hobbiton"] = { s=5, st=18 },
		["Long Cleeve"] = { l=20, s=5, st=20 },
		["Michel Delving"] = { s=5, st=20 },
		["Needlehole"] = { s=5, st=19 },
		["Nobottle"] = { l=20, s=5, st=23 },
		["Stock"] = { c=1, t=69, s=5, st=17 },
		["Tighfield"] = { l=20, s=5, st=17 },
		}, z="Bree-Land", r=1, l="29.2s,56.6w" },
	["Hengstacer Farm"] = { ql=20, d={ --
		["Trestlebridge"] = { c=1, t=140 },
		["West Bree"] = { c=1, t=160 },
		}, z="Bree-Land", r=1, td="R11", l="22.3s,52.3w" },
	-- Lone-lands starts here
	["The Forsaken Inn"] = { t=12, ql=22, d={
		["Breeland Homesteads"] = { c=1, t=108, s=5, st=31 },
		["South Bree"] = { c=5, t=190 },
		["Caranost"] = { c=15, t=222, l=-10, st=25, t=35 },
		["Herne"] = { c=15, t=380, l=-10, st=25, t=26 },
		["Scurloc Farm"] = { c=15, t=295, l=-10, st=25, t=21 },
		["Ost Guruth"] = { c=15, t=203 },
		}, z="Lone-lands", r=1, l="34.4s,40.6w" },
	["Ost Guruth"] = { t=26, ql=26, d={
		["The Forsaken Inn"] = { c=15, t=203 },
		["The Last Bridge"] = { c=15, t=128, l=-20, s=25, st=27 },
		["Rivendell Stables"] = { c=15, t=609, l=-20, s=25, st=24 },
		["South Bree"] = { l=15, s=25, st=24 },
		}, z="Lone-lands", r=1, td="R13", l="32.1s,29.8w" },
	-- Swanfleet starts here
	["Caras Gelebren"] = { t=4, ql=12, d={
		["Echad Mirobel"] = { c=25, t=155, l=-40, s=35, st=39 },
		["Clegur"] = { c=1, t=297, s=5, st=22 },
		["Glyn Helyg"] = { c=1, t=215, s=5, st=21 },
		["Lhan Garan"] = { c=1, t=1000, s=5, st=26 },
		["Lintrev"] = { c=1, t=242, s=450, st=21 },
		["Mossward"] = { c=1, t=289, s=5, st=23 },
		["Western Eregion"] = { c=1, t=135, s=5, st=15 },
		}, z="Swanfleet", r=1, td="R11", l="52.7s,22.4w" },
	["Clegur"] = { t=2, ql=7, d={ -- Delving
		["Caras Gelebren"] = { c=1, t=297, s=5, st=22 },
		["Glyn Helyg"] = { c=1, t=105, s=5, st=27 },
		["Lhan Garan"] = { c=1, t=231, s=5, st=32 },
		["Lintrev"] = { c=1, t=126, s=5, st=27 },
		["Mossward"] = { c=1, t=125, s=5, st=31 },
		["Western Eregion"] = { c=1, t=417, s=5, st=20 },
		}, z="Swanfleet", r=1, td="R11", l="64.9s,29.3w" },
	["Glyn Helyg"] = { t=1, ql=5, d={
		["Caras Gelebren"] = { c=1, t=215, s=5, st=21 },
		["Clegur"] = { c=1, t=105, s=32, st=29 },
		["Lhan Garan"] = { c=1, t=149, s=5, st=29 },
		["Lintrev"] = { c=1, t=48, s=450, st=25 },
		["Mossward"] = { c=1, t=232, s=5, st=27 },
		["Western Eregion"] = { c=1, t=336, s=5, st=18 },
		}, z="Swanfleet", r=1, td="R11", l="62.3s,25.9w" },
	["Lhan Garan"] = { t=4, ql=10, d={ -- Delving
		["Herne"] = { c=15, t=412, l=-10, st=25, t=33 },
		["Tharbad"] = { c=15, t=323, l=-10, s=25, st=33 },
		["Lhanuch"] = { c=25, t=350, l=-55, s=35, st=32 },
		["Caras Gelebren"] = { c=1, t=100, s=5, st=26 },
		["Clegur"] = { c=1, t=231, s=32, st=32 },
		["Glyn Helyg"] = { c=1, t=149, s=5, st=29 },
		["Lintrev"] = { c=1, t=175, s=450, st=30 },
		["Mossward"] = { c=1, t=222, s=5, st=30 },
		["Western Eregion"] = { c=1, t=220, s=5, st=23 },
		}, z="Swanfleet", r=1, td="R11", l="55.2s,27.1w" },
	["Lintrev"] = { t=2, ql=6, d={
		["Lhanuch"] = { c=25, t=262, l=55, s=35, st=28 },
		["Maur Tulhau"] = { c=25, t=51,l=55, s=35, st=20 },
		["Caras Gelebren"] = { c=1, t=242, s=5, st=21 },
		["Clegur"] = { c=1, t=126, s=32, st=27 },
		["Glyn Helyg"] = { c=1, t=48, s=5, st=25 },
		["Lhan Garan"] = { c=1, t=175, s=5, st=330 },
		["Mossward"] = { c=1, t=253, s=5, st=27 },
		["Western Eregion"] = { c=1, t=352, s=5, st=30 },
		}, z="Swanfleet", r=1, td="R11", l="61.7s,24.2w" },
	["Mossward"] = { t=3, ql=3, d={
		["West Bree"] = { s=5, st=23 },
		["Herne"] = { c=15, t=277, l=-10, s=25, st=28 },
		["Tharbad"] = { c=15, t=180, l=-10, s=25, st=28 },
		["Lhanuch"] = { l=55, s=35, st=27 },
		["Celondim"] = { s=5, st=20 },
		["Thorin's Gate"] = { s=5, st=28 },
		["Caras Gelebren"] = { c=1, t=289, s=5, st=23 },
		["Clegur"] = { c=1, t=125, s=5, st=31 },
		["Glyn Helyg"] = { c=1, t=232, s=5, st=27 },
		["Lhan Garan"] = { c=1, t=222, s=5, st=30 },
		["Lintrev"] = { c=1, t=253, s=5, st=27 },
		["Western Eregion"] = { c=1, t=410, s=5, st=23 },
		["Michel Delving"] = { s=5, st=21 },
		["Rivendell Stables"] = { s=25, st=22 },
		}, z="Swanfleet", r=1, td="R11", l="60.8s,34.7w" },
	["Western Eregion"] = { t=0, ql=15, d={ -- Idhobel
		["Echad Mirobel"] = { c=25, t=150, l=-40, s=35, st=37 },
		["Caras Gelebren"] = { c=1, t=135, s=5, st=15 },
		["Clegur"] = { c=1, t=417, s=5, st=20 },
		["Glyn Helyg"] = { c=1, t=336, s=5, st=18 },
		["Lhan Garan"] = { c=1, t=220, s=5, st=23 },
		["Lintrev"] = { c=1, t=352, s=5, st=30 },
		["Mossward"] = { c=1, t=410, s=5, st=23 },
		}, z="Swanfleet", r=1, td="R11", l="47.2s,19.0w" },
	-- Cardolan starts here
	["Andrath"] = { t=6, ql=15, d={ -- Delving
		["West Bree"] = { c=1, t=161, l=-10, s=5, st=14 },
		["Caranost"] = { c=15, t=453, l=-10, s=25, st=30 },
		["Herne"] = { c=15, t=267, l=-10, s=25, st=19 },
		["Sarn Ford"] = { c=15, t=407, l=-10, s=25, st=16 },
		["Scurloc Farm"] = { c=15, t=527, l=-10, s=25, st=15 },
		["Tharbad"] = { c=15, t=371, l=-10, s=25, st=20 },
		}, z="Cardolan", r=1, td="R11", l="37.6s,49.8w" },
	["Caranost"] = { t=5, ql=23, d={ -- qUARTERMASTER
		["Andrath"] = { c=15, t=453, l=-10, s=25, st=30 },
		["Herne"] = { c=15, t=207, s=25, l=-10, st=38 },
		["Sarn Ford"] = { c=15, t=432, l=-10, s=25, st=38 },
		["Scurloc Farm"] = { c=15, t=116, l=-10, s=25, st=35 },
		["Tharbad"] = { c=15, t=260, l=-10, s=25, st=37 },
		["The Forsaken Inn"] = { c=15, t=222, s=25, st=35 },
		}, z="Cardolan", r=1, td="R11", l="44.7s,39.5w" },
	["Herne"] = { t=2, ql=20, d={ -- Delving
		["West Bree"] = { c=1, t=418, s=5, st=14 },
		["Andrath"] = { c=15, t=267, l=-10, s=25, st=19 },
		["Caranost"] = { c=15, t=207, l=-10, s=25, st=38 },
		["Sarn Ford"] = { c=15, t=228, l=-10, s=25, st=32 },
		["Scurloc Farm"] = { c=15, t=262, l=-10, s=25, st=26 },
		["Tharbad"] = { c=15, t=122, l=-10, s=25, st=30 },
		["Lhan Garan"] = { c=1, t=412, s=5, st=33 },
		["Mossward"] = { c=1, t=277, s=5, st=28 },
		["The Forsaken Inn"] = { c=15, t=380, l=-10, s=25, st=26 },
		["Rivendell Stables"] = { s=25, l=-20, st=25 },
		}, z="Cardolan", r=1, td="R11", l="50.1s,44.7w" },
	["Sarn Ford"] = { t=5, ql=23, d={
		["Andrath"] = { c=15, t=407, l=-10, s=25, st=16 },
		["Caranost"] = { c=15, t=432, l=-10, s=25, st=38 },
		["Herne"] = { c=15, t=228, l=-10, s=25, st=32 },
		["Scurloc Farm"] = { c=15, t=491, l=-10, s=25, st=21 },
		["Tharbad"] = { c=15, t=319, l=-10, s=25, st=26 },
		["Michel Delving"] = { s=5, st=22 },
		}, z="Cardolan", r=1, l="48.1s,55.8w" },
	["Scurloc Farm"] = { t=4, td="R11", ql=20, d={
		["Andrath"] = { c=15, t=527, l=-10, s=25, st=15 },
		["Caranost"] = { c=15, t=116, l=-10, s=25, st=35 },
		["Herne"] = { c=15, t=262, l=-10, s=25, st=26 },
		["Sarn Ford"] = { c=15, t=491, l=-10, s=25, st=21 },
		["Tharbad"] = { c=15, t=315, l=-10, s=25, st=24 },
		["The Forsaken Inn"] = { c=15, t=295, s=25, st=21 },
		}, z="Cardolan", r=1, td="R11", l="43.3s,33.8w" },
	["Tharbad"] = { t=3, ql=16, d={
		["Andrath"] = { c=15, t=371, l=-10, s=25, st=20 },
		["Caranost"] = { c=15, t=260, l=-10, s=25, st=37 },
		["Herne"] = { c=15, t=122, l=-10, s=25, st=30 },
		["Sarn Ford"] = { c=15, t=319, l=-10, s=25, st=25 },
		["Scurloc Farm"] = { c=15, t=315, l=-10, s=25, st=24 },
		["Lhan Garan"] = { c=1, t=323, st=5, t=33 },
		["Mossward"] = { c=1, t=180, s=5, st=28 },
		}, z="Cardolan", r=1, td="R11", l="54.2s,40.3w" },
		-- Yondershire starts here
	["Bullroarer's Way"] = { d={
		["Buckland"] = { l=35, s=5, st=20 },
		["Duillond"] = { c=1, t=417, l=-20, s=5, st=22 },
		["Oatbarton"] = { c=1, t=118, l=-20, s=5, st=18},
		["Brockenborings"] = { l=20, s=5, st=17 },
		["Foxden Road"] = { c=1, t=148, l=-20, s=5, st=21 },
		["Gamwich"] = { c=1, t=210, l=-20, s=5, st=22 },
		["Hobbiton"] = { l=20, s=5, st=19 },
		["Long Cleeve"] = { c=1, t=158, l=-20, s=5, st=18 },
		["Michel Delving"] = { c=1, t=272, l=-20, s=5, st=21 },
		["Needlehole"] = { l=20, s=5, st=15 },
		["Nobottle"] = { c=1, t=99, l=-20, s=5, st=22 },
		["Stock"] = { l=20, s=5, st=22 },
		["Tighfield"] = { c=1, t=157, l=-20, s=5, st=16 },
		}, z="Yondershire", r=1, td="R44", l="24.1s,74.1w" },
	["Foxden Road"] = { d={
		["Buckland"] = { l=35, s=5, st=18 },
		["Duillond"] = { c=1, t=353, l=-20, s=5, st=19 },
		["Oatbarton"] = { c=1, t=264, l=-20, s=5, st=21 },
		["Brockenborings"] = { l=20, s=5, st=20 },
		["Bullroarer's Way"] = { c=1, t=148, l=-20, s=5, st=21 },
		["Gamwich"] = { c=1, t=144, l=-20, s=5, st=20 },
		["Hobbiton"] = { l=20, s=5, st=17 },
		["Long Cleeve"] = { c=1, t=135, l=-20, s=5, st=22 },
		["Michel Delving"] = { c=1, t=127, l=-20, s=5, st=17 },
		["Needlehole"] = { l=20, s=5, st=16 },
		["Nobottle"] = { c=1, t=52, l=-20, s=5, st=23 },
		["Stock"] = { l=20, s=5, st=23 },
		["Tighfield"] = { c=1, t=111, l=-20, s=5, st=19 },
		}, z="Yondershire", r=1, td="R44", l="22.3s,78.4w" },
	["Gamwich"] = { t=1, ql=20, d={
		["Buckland"] = { l=35, s=5, st=23 },
		["Duillond"] = { c=1, t=277, l=-20, s=5, st=24 },
		["Oatbarton"] = { c=1, t=325, l=-20, s=5, st=21 },
		["Brockenborings"] = { l=20, s=5, st=20 },
		["Bullroarer's Way"] = { c=1, t=210, l=-20, s=5, st=22 },
		["Foxden Road"] = { c=1, t=144, l=-20, s=5, st=20 },
		["Hobbiton"] = { l=20, s=5, st=22 },
		["Long Cleeve"] = { c=1, t=197, l=-20, s=5, st=22 },
		["Michel Delving"] = { c=1, t=269, l=-20, s=5, st=22 },
		["Needlehole"] = { l=20, s=5, st=18 },
		["Nobottle"] = { c=1, t=113, l=-20, s=5, st=20 },
		["Stock"] = { l=20, s=5, st=23 },
		["Tighfield"] = { c=1, t=55, l=-20, s=5, st=23 },
		}, z="Yondershire", r=1, td="R44", l="24.1s,82.6w" },
	["Long Cleeve"] = { t=1, ql=20, d={
		["Buckland"] = { l=35, s=5, st=20 },
		["Duillond"] = { c=1, t=400, l=-20, s=5, st=21 },
		["Oatbarton"] = { c=1, t=274, l=-20, s=5, st=19 },
		["Brockenborings"] = { l=20, s=5, st=16 },
		["Bullroarer's Way"] = { c=1, t=158, l=-20, s=5, st=19 },
		["Foxden Road"] = { c=1, t=135, l=-20, s=5, st=22 },
		["Gamwich"] = { c=1, t=197, l=-20, s=5, st=22 },
		["Hobbiton"] = { l=20, s=5, st=18 },
		["Michel Delving"] = { c=1, t=256, l=-20, s=5, st=19 },
		["Needlehole"] = { l=20, s=5, st=19 },
		["Nobottle"] = { c=1, t=85, l=-20, s=5, st=22 },
		["Stock"] = { l=20, s=5, st=20 },
		["Tighfield"] = { c=1, t=143, l=-20, s=5, st=20 },
		}, z="Yondershire", r=1, td="R44", l="27.0s,79.0w" },
	["Nobottle"] = { t=1, ql=20, d={
		["Buckland"] = { l=35, s=5, st=23 },
		["Duillond"] = { c=1, t=317, l=-20, s=5, st=21 },
		["Oatbarton"] = { c=1, t=214, l=-20, s=5, st=23 },
		["Brockenborings"] = { l=20, s=5, st=21 },
		["Bullroarer's Way"] = { c=1, t=99, l=-20, s=5, st=22 },
		["Foxden Road"] = { c=1, t=52, l=-20, s=5, st=23 },
		["Gamwich"] = { c=1, t=113, l=-20, s=5, st=20 },
		["Hobbiton"] = { l=20, s=5, st=23 },
		["Long Cleeve"] = { c=1, t=85, l=-20, s=5, st=22 },
		["Michel Delving"] = { c=1, t=176, l=-20, s=5, st=26 },
		["Needlehole"] = { l=20, s=5, st=19 },
		["Stock"] = { l=20, s=5, st=22 },
		["Tighfield"] = { c=1, t=59, l=-20, s=5, st=16 },
		}, z="Yondershire", r=1, td="R44", l="27.0s,79.0w" },
	["Tighfield"] = { t=1, ql=20, d={
		["Buckland"] = { l=35, s=5, st=17 },
		["Duillond"] = { c=1, t=264, l=-20, s=5, st=24 },
		["Oatbarton"] = { c=1, t=272, l=-20, s=5, st=14 },
		["Brockenborings"] = { l=20, s=5, st=16 },
		["Bullroarer's Way"] = { c=1, t=157, l=-20, s=5, st=16 },
		["Foxden Road"] = { c=1, t=111, l=-20, s=5, st=19 },
		["Gamwich"] = { c=1, t=55, l=-20, s=5, st=23 },
		["Hobbiton"] = { l=20, s=5, st=16 },
		["Long Cleeve"] = { c=1, t=143, l=-20, s=5, st=20 },
		["Michel Delving"] = { c=1, t=234, l=-20, s=5, st=17 },
		["Needlehole"] = { l=20, s=5, st=12 },
		["Nobottle"] = { c=1, t=59, l=-20, s=5, st=16 },
		["Stock"] = { l=20, s=5, st=18 },
		}, z="Yondershire", r=1, td="R44", l="26.3s,82.5w" },
	-- North Downs starts here
	["Trestlebridge"] = { t=3, ql=24, d={
		["West Bree"] = { c=15, t=209 },
		["Amon Raith"] = { c=15, t=142 },
		["Esteldin"] = { c=15, t=320 },
		["Tinnudir"] = { c=15, t=363 },
		["Ost Forod"] = { c=15, t=373 },
		["Hengstacer Farm"] = { c=1, t=160 },
		["Trestlebridge(R)"] = { mt=20 },
		}, z="North Downs", r=1, td="R12", l="18.0s,53.6w" },
	["Trestlebridge(R)"] = { ql=24, d={
		["Annak-khurfu(I)"] = { l=20, s=1, st=5, S0=true },
		["Akraz-zahar(I)"] = { l=20, s=1, st=5, S0=true },
		["Steepset"] = { l=20, s=1, st=4, S0=true },
		["Trestlebridge"] = { mt=20 },
		}, z="North Downs", r=1, l="17.7s,54.3w" },
	["Amon Raith"] = { ql=25, d={ --
		["Trestlebridge"] = { c=15, t=142 },
		["Esteldin"] = { c=15, t=190 },
		}, z="North Downs", r=1, td="R12", l="12.3s,52.5w" },
	["Meluinen"] = { ql=28, d={ --
		["Esteldin"] = { c=15, t=120 },
		["Othrikar"] = { c=15, t=130 },
		}, z="North Downs", r=1, l="13.6s,44.5w" },
	["Othrikar"] = { ql=27, d={ --
		["Meluinen"] = { c=15, t=130 },
		["Esteldin"] = { c=15, t=100 },
		}, z="North Downs", r=1, l="6.9s,45.0w" },
	["Esteldin"] = { t=2, ql=26, d={
		["Aughaire"] = { c=25, t=220 },
		["Bail Avarc"] = { l=20, s=35, st=15, S0=true },
		["Gath Forthnir"] = { s=35, l=40, st=40, r="Q1R4" },
		["West Bree"] = { s=35, l=30, st=33 },
		["Tinnudir"] = { c=15, t=510, s=35, l=30, st=50 },
		["Amon Raith"] = { c=15, t=190 },
		["Meluinen"] = { c=15, t=120 },
		["Othrikar"] = { c=15, t=100 },
		["Trestlebridge"] = { c=15, t=320 },
		["Rivendell Stables"] = { s=20, l=40, st=41 },
		}, z="North Downs", r=1, td="R12", l="9.6s,42.1w" },
	-- Trollshaws starts here
	["Barachen's Camp"] = { ql=35, d={
		["Echad Candelleth"] = { c=15, t=266, l=-20, s=25, st=23 },
		["Gaerond"] = { c=15, t=76, l=-20, s=25, st=30 },
		["High Moor"] = { c=15, t=261, l=-20, s=25, st=29 },
		["Last Homely House"] = { c=15, t=427, l=-20, s=25, st=35 },
		["Nan Tornaeth"] = { c=15, t=212, l=-20, s=25, st=29 },
		["North Trollshaws"] = { c=15, t=110, l=20, s=25, st=13 },
		["Rivendell Stables"] = { c=15, t=462, l=-20, s=25, st=99 },
		["The Last Bridge"] = { c=15, t=71, l=-20, s=25, st=48 },
		["Tham Lumren"] = { c=15, t=214, l=-20, s=25, st=31 },
		["Thorenhad"] = { c=15, t=160, l=-20, s=25, st=13 },
		["Tornhad"] = { c=15, t=219, l=-20, s=25, st=28 },
		}, z="Trollshaws", r=1, td="R7", l="28.2s,15.3w" },
	["Echad Candelleth"] = { t=20, ql=38, d={
		["Gwingris"] = { c=25, t=162, l=35, s=25, st=44 },
		["Barachen's Camp"] = { c=15, t=266, l=-20, s=25, st=23 },
		["Gaerond"] = { c=15, t=255, l=-20, s=25, st=22 },
		["High Moor"] = { c=15, t=184, l=-20, s=25, st=20 },
		["Last Homely House"] = { c=15, t=361, l=-20, s=25, st=28 },
		["Nan Tornaeth"] = { c=15, t=262, l=-20, s=25, st=26 },
		["North Trollshaws"] = { c=15, t=330, l=-20, s=25, st=25 },
		["Rivendell Stables"] = { c=15, t=392, l=-20, s=25, st=23 },
		["Tham Lumren"] = { c=15, t=101, l=-20, s=25, st=22 },
		["The Last Bridge"] = { c=15, t=288, l=-20, s=25, st=38 },
		["Thorenhad"] = { c=15, t=206, l=-20, s=25, st=22 },
		["Tornhad"] = { c=15, t=274, l=-20, s=25, st=28 },
		}, z="Trollshaws", r=1, td="R7", l="36.8s,14.2w" },
	["High Moor"] = { ql=39, d={
		["Barachen's Camp"] = { c=15, t=261, l=-20, s=25, st=29 },
		["Echad Candelleth"] = { c=15, t=184, l=-20, s=25, st=20 },
		["Gaerond"] = { c=15, t=281, l=-20, s=25, st=12 },
		["Last Homely House"] = { c=15, t=184, l=-20, s=25, st=14 },
		["Nan Tornaeth"] = { c=15, t=247, l=-20, s=25, st=10 },
		["North Trollshaws"] = { c=15, t=324, l=-20, s=25, st=11 },
		["The Last Bridge"] = { c=15, t=286, l=-20, s=25, st=14 },
		["Rivendell Stables"] = { c=15, t=217, l=-20, s=25, st=14 },
		["Tham Lumren"] = { c=15, t=257, l=-20, s=25, st=10 },
		["Thorenhad"] = { c=15, t=192, l=-20, s=25, st=23 },
		["Tornhad"] = { c=15, t=438, l=-20, s=25, st=16 },
		}, z="Trollshaws", r=1, td="R7", l="34.7s,9.7w" },
	["Last Homely House"] = { t=13, ql=35, d={
		["Barachen's Camp"] = { c=15, t=427, l=-20, s=25, st=35 },
		["Echad Candelleth"] = { c=15, t=361, l=-20, s=25, st=28 },
		["Gaerond"] = { c=15, t=458, l=-20, s=25, st=17 },
		["High Moor"] = { c=15, t=184, l=-20, s=25, st=14 },
		["Nan Tornaeth"] = { c=15, t=424, l=-20, s=25, st=14 },
		["North Trollshaws"] = { c=15, t=492, l=-20, s=25, st=17 },
		["Rivendell Stables"] = { c=15, t=65, l=-20, s=25, st=18 },
		["Tham Lumren"] = { c=15, t=437, l=-20, s=25, st=15 },
		["The Last Bridge"] = { c=15, t=451, l=-20, s=25, st=35 },
		["Thorenhad"] = { c=15, t=367, l=-20, s=25, st=28 },
		["Tornhad"] = { c=15, t=600, l=-20, s=25, st=24 },
		}, z="Trollshaws", r=1, td="R7", l="29.8s,4.1w" },
	["Nan Tornaeth"] = { ql=37, d={
		["Barachen's Camp"] = { c=15, t=212, l=-20, s=25, st=29 },
		["Echad Candelleth"] = { c=15, t=262, l=-20, s=25, st=26 },
		["Gaerond"] = { c=15, t=242, l=-20, s=25, st=14 },
		["High Moor"] = { c=15, t=247, l=-20, s=25, st=10 },
		["Last Homely House"] = { c=15, t=424, l=-20, s=25, st=14 },
		["North Trollshaws"] = { c=15, t=115, l=-20, s=25, st=11 },
		["Rivendell Stables"] = { c=15, t=455, l=-20, s=25, st=35 },
		["Tham Lumren"] = { c=15, t=346, l=-20, s=25, st=12 },
		["The Last Bridge"] = { c=15, t=235, l=-20, s=25, st=48 },
		["Thorenhad"] = { c=15, t=91, l=-20, s=25, st=13, S0=true },
		["Tornhad"] = { c=15, t=503, l=-20, s=25, st=16 },
		}, z="Trollshaws", r=1, td="R7", l="28.2s,15.3w" },
	["North Trollshaws"] = { ql=35, d={
		["Barachen's Camp"] = { c=15, t=110, l=-20, s=25, st=13 },
		["Echad Candelleth"] = { c=15, t=330, l=-20, s=25, st=25 },
		["Gaerond"] = { c=15, t=220, l=-20, s=25, st=12 },
		["High Moor"] = { c=15, t=324, l=-20, s=25, st=11 },
		["Last Homely House"] = { c=15, t=492, l=-20, s=25, st=17 },
		["Nan Tornaeth"] = { c=15, t=115, l=-20, s=25, st=12 },
		["Rivendell Stables"] = { c=15, t=533, l=-20, s=25, st=17 },
		["Tham Lumren"] = { c=15, t=278, l=-20, s=25, st=15 },
		["The Last Bridge"] = { c=15, t=134, l=-20, s=25, st=30 },
		["Thorenhad"] = { c=15, t=196, l=-20, s=25, st=26 },
		["Tornhad"] = { c=15, t=290, l=-20, s=25, st=18 },
		}, z="Trollshaws", r=1, td="R7", l="28.6s,19.4w" },
	["Rivendell Stables"] = { ql=45, d={
		["Gath Forthnir"] = { l=-20, s=35, st=33, r="Q1R4" },
		["Minas Tirith(M)"] = { s=1, st=27 },
		["South Bree"] = { s=25, st=28 },
		["Annak-khurfu"] = { l=120, s=147.5, st=32 },
		["Lhanuch"] = { l=55, s=45, st=27, r="D6" },
		["Echad Dunnan"] = { l=35, s=35, st=22, r="D3" },
		["Gwingris"] = { c=25, t=543, l=-35, s=35, st=38, r="D1" },
		["Suri-kyla"] = { l=35, s=35, st=37, r="R3" },
		["Zidir-nesad"] = { l=125, s=161.35, st=20 },
		["Caras Galadhon"] = { l=55, s=40.5, st=18, r="D14" },
		["Ettenmoors"] = { l=20, s=1, st=30 },
		["Ost Guruth"] = { c=15, t=609, l=-15, s=25, st=26 },
		["Gloin's Camp"] = { c=15, t=150, l=-30, s=35, st=18 },
		["Esteldin"] = { l=20, s=20, st=41 },
		["Barachen's Camp"] = { c=15, t=462, l=-20, s=25, st=99 },
		["Echad Candelleth"] = { c=25, t=392, l=-20, s=25, st=23, S0=true },
		["Gaerond"] = { c=15, t=493, l=-20, s=25, st=15 },
		["High Moor"] = { c=15, t=217, l=-20, s=25, st=14 },
		["Last Homely House"] = { c=15, t=65, l=-20, s=25, st=18 },
		["Nan Tornaeth"] = { c=15, t=455, l=-20, s=25, st=15 },
		["North Trollshaws"] = { c=15, t=533, l=-20, s=25, st=17 },
		["Tham Lumren"] = { c=15, t=470, l=-20, s=25, st=14 },
		["The Last Bridge"] = { c=15, t=482, l=-20, s=25, st=34 },
		["Thorenhad"] = { c=15, t=405, l=-20, s=25, st=15 },
		["Tornhad"] = { c=15, t=633, l=-20, s=25, st=23 },
		["Vegbar"] = { l=115, s=122, st=32 },
		-- Assistant
		["Lond Cirion"] = { l=130, s=180, st=19 },
		["Bail Avarc"] = { s=45, st=14 },
		["Herne"] = { l=10, s=25, st=25 },
		["Linhir(KG)"] = { s=162.25, l=130, st=26 },
		["Pelargir East Gate"] = { s=162.25, l=130, st=18 },
		["Pelargir West Gate"] = { s=162.25, l=130, st=18 },
		["Mossward"] = { l=20, s=1, st=22 },
		}, z="Trollshaws", r=1, a="Rivendell", td="R7", l="29.3s,6.7w" },
	["The Last Bridge"] = { ql=35, d={
		["Ost Guruth"] = { c=15, t=128, l=-15, c=25, t=27 },
		["Barachen's Camp"] = { c=15, t=71, l=-20, s=25, st=48 },
		["Echad Candelleth"] = { c=15, t=288, l=-20, s=25, st=42 },
		["Gaerond"] = { c=15, t=56, l=-20, s=25, st=28 },
		["High Moor"] = { c=15, t=286, l=-20, s=25, st=14 },
		["Last Homely House"] = { c=15, t=451, l=-20, s=25, st=35 },
		["Nan Tornaeth"] = { c=15, t=235, l=-20, s=25, st=13 },
		["North Trollshaws"] = { c=15, t=134, l=-20, s=25, st=24 },
		["Rivendell Stables"] = { c=15, t=482, l=-20, s=25, st=34 },
		["Tham Lumren"] = { c=15, t=190, l=-20, s=25, st=32 },
		["Thorenhad"] = { c=25, t=180, l=-20, s=25, st=44 },
		["Tornhad"] = { c=15, t=195, l=-20, s=25, st=38 },
		}, z="Trollshaws", r=1, td="R7", l="33.4s,23.0w" },
	["Thorenhad"] = { t=1, ml=15, ql=36, d={
		["Barachen's Camp"] = { c=15, t=160, l=-20, s=25, st=23 },
		["Echad Candelleth"] = { c=15, t=207, l=-20, s=25, st=22 },
		["Gaerond"] = { c=15, t=186, l=-20, s=25, st=99 },
		["High Moor"] = { c=15, t=192, l=-20, s=25, st=23 },
		["Last Homely House"] = { c=15, t=367, l=-20, s=25, st=28 },
		["Nan Tornaeth"] = { c=15, t=91, l=-20, s=25, st=13 },
		["North Trollshaws"] = { c=15, t=196, l=-20, s=25, st=25 },
		["Rivendell Stables"] = { c=15, t=405, l=-20, s=25, st=15 },
		["The Last Bridge"] = { c=15, t=180, l=-20, s=25, st=44 },
		["Tham Lumren"] = { c=15, t=280, l=-20, s=25, st=24 },
		["Tornhad"] = { c=15, t=450, l=-20, s=25, st=32 },
		}, z="Trollshaws", r=1, td="R7", l="31.7s,15.0w" },
	-- Angle of Mitheithel starts here
	["Gaerond"] = { t=1, ml=35, ql=40, d={
		["Barachen's Camp"] = { c=15, t=76, l=-20, s=25, st=30 },
		["Echad Candelleth"] = { c=15, t=255, l=-20, s=25, st=22 },
		["High Moor"] = { c=15, t=289, l=-20, s=25, st=12 },
		["Last Homely House"] = { c=15, t=458, l=-20, s=25, st=17 },
		["Nan Tornaeth"] = { c=15, t=242, l=-20, s=25, st=14 },
		["North Trollshaws"] = { c=15, t=220, l=-20, s=25, st=12 },
		["Rivendell Stables"] = { c=15, t=493, l=-20, s=25, st=15 },
		["The Last Bridge"] = { c=15, t=235, l=-20, s=25, st=48 },
		["Tham Lumren"] = { c=15, t=151, l=-20, s=25, st=14 },
		["Thorenhad"] = { c=15, t=186, l=-20, s=25, st=99 },
		["Tornhad"] = { c=15, t=157, l=-20, s=25, st=20 },
		}, z="Trollshaws", a="Angle of Mitheithel", r=1, td="R7", l="34.7s,22.1w" },
	["Tham Lumren"] = { t=3, ml=35, ql=40, d={
		["Barachen's Camp"] = { c=15, t=214, l=-20, s=25, st=31 },
		["Echad Candelleth"] = { c=15, t=101, l=-20, s=25, st=22 },
		["Gaerond"] = { c=15, t=151, l=-20, s=25, st=14 },
		["High Moor"] = { c=15, t=257, l=-20, s=25, st=10 },
		["Last Homely House"] = { c=15, t=437, l=-20, s=25, st=15 },
		["Nan Tornaeth"] = { c=15, t=346, l=-20, s=25, st=12 },
		["North Trollshaws"] = { c=15, t=278, l=-20, s=25, st=15 },
		["Rivendell Stables"] = { c=15, t=470, l=-20, s=25, st=13 },
		["The Last Bridge"] = { c=15, t=190, l=-20, s=25, st=32 },
		["Thorenhad"] = { c=15, t=280, l=-20, s=25, st=24 },
		["Tornhad"] = { c=15, t=170, l=-20, s=25, st=18 },
		}, z="Trollshaws", a="Angle of Mitheithel", r=1, td="R7", l="34.7s,22.1w" },
	["Tornhad"] = { t=0, ml=35, ql=32, d={
		["Barachen's Camp"] = { c=15, t=219, l=-20, s=25, st=99 },
		["Echad Candelleth"] = { c=15, t=274, l=-20, s=25, st=28 },
		["Gaerond"] = { c=15, t=157, l=-20, s=25, st=20 },
		["High Moor"] = { c=15, t=438, l=-20, s=25, st=18 },
		["Last Homely House"] = { c=15, t=600, l=-20, s=25, st=24 },
		["Nan Tornaeth"] = { c=15, t=503, l=-20, s=25, st=16 },
		["North Trollshaws"] = { c=15, t=290, l=-20, s=25, st=18 },
		["Rivendell Stables"] = { c=15, t=633, l=-20, s=25, st=23 },
		["The Last Bridge"] = { c=15, t=195, l=-20, s=25, st=38 },
		["Tham Lumren"] = { c=15, t=170, l=-20, s=25, st=18 },
		["Thorenhad"] = { c=15, t=450, l=-20, s=25, st=32 },
		}, z="Trollshaws", a="Angle of Mitheithel", r=1, td="R7", l="42.4s,23.3w" },
	-- Evendim starts here
	["Oatbarton"] = { t=7, ml=10, ql=20, d={
		["Buckland"] = { s=5, st=18 },
		["Duillond"] = { s=5, st=25  },
		["Dwaling"] = { c=15, t=68, s=25, st=10 },
		["High King's Crossing"] = { c=15, t=244, s=25, st=11 },
		["Tinnudir"] = { c=15, t=358, s=25, st=32 },
		["Ost Forod"] = { c=15, t=363, s=25, st=25 },
		["Brockenborings"] = { c=15, t=77, s=5, st=15 },
		["Bullroarer's Way"] = { c=1, t=118, s=5, st=18 },
		["Foxden Road"] = { c=1, t=264, s=5, st=21 },
		["Gamwich"] = { c=1, t=325, s=5, st=21 },
		["Hobbiton"] = { s=5, st=16 },
		["Long Cleeve"] = { c=1, t=274, s=5, st=19 },
		["Michel Delving"] = { s=5, st=16 },
		["Needlehole"] = { s=5, st=15 },
		["Nobottle"] = { c=1, t=214, s=5, st=23 },
		["Stock"] = { s=5, st=18 },
		["Tighfield"] = { c=1, t=272, s=5, st=14 },
		}, z="Evendim", r=1, td="R10", l="23.4s,67.4w" },
	["Dwaling"] = { t=14, ml=10, ql=31, d={
		["Oatbarton"] = { c=15, t=68, s=25, st=10 },
		["High King's Crossing"] = { c=15, t=174, s=25, st=11 },
		["Tinnudir"] = { c=15, t=288, s=25, st=32 },
		["Ost Forod"] = { c=15, t=300, s=25, st=21 },
		}, z="Evendim", r=1, td="R10", l="20.8s,64.7w" },
	["High King's Crossing"] = { t=3, ml=15, ql=32, d={
		["Oatbarton"] = { c=15, t=244, s=25, st=12 },
		["Dwaling"] = { c=15, t=174, s=25, st=11 },
		["Tinnudir"] = { c=15, t=118, s=25, st=31 },
		["Ost Forod"] = { c=15, t=127, s=25, st=21 },
		["King's Crossing(B)"] = { mt=13 },
		}, z="Evendim", r=1, l="13.8s,64.1w" },
	["Tinnudir"] = { t=10, ml=15, ql=32, d={
		["West Bree"] = { s=35, st=40 },
		["Annuminas"] = { s=20, l=35, st=40, r="R6" },
		["Dwaling"] = { c=15, t=288, s=25, st=32 },
		["High King's Crossing"] = { c=15, t=118, s=25, st=31 },
		["Oatbarton"] = { c=15, t=358, s=25, st=32 },
		["Ost Forod"] = { c=15, t=111, s=25, st=41 },
		["Esteldin"] = { c=15, t=510, s=35, l=30, st=50 },
		["Trestlebridge"] = { c=15, t=363 },
		["Michel Delving"] = { s=35, st=38 },
		["Tinnudir(B)"] = { mt=15 },
		}, z="Evendim", r=1, td="R6", l="12.4s,67.2w" },
	["Ost Forod"] = { t=25, ml=15, ql=35, d={
		["West Bree"] = { s=35, l=30, st=36 },
		["Dwaling"] = { c=15, t=300, s=25, st=21 },
		["High King's Crossing"] = { c=15, t=127, s=25, st=21 },
		["Oatbarton"] = { c=15, t=363, s=25, st=25 },
		["Trestlebridge"] = { c=15, t=373 },
		["Kauppa-kohta"] = { c=25, t=300, l=-40, s=25, st=70 },
		["Pynti-peldot"] = { c=25, t=625, l=-40, s=25, st=48, r="R3" },
		["Suri-kyla"] = { s=25, l=40, st=72, r="R3" },
		["Tinnudir"] = { c=15, t=111, s=25, st=41 },
		}, z="Evendim", r=1, l="8.2s,64.3w" },
	["Annuminas"] = { t=6, ms=35, ql=39, d={
		["Tinnudir"] = { s=20, l=35, st=40, r="R6" },
		}, z="Evendim", r=1, a="Annuminas", td="R6", l="19.1s,70.9w" },
	-- Boat travel on Lake Evendim and Brandywine River
	["Buckland(B)"] = { ql=16, d={
		["King's Crossing(B)"] = { c=25, t=6 },
		["Tinnudir(B)"] = { c=25, t=4 },
		["Trader's Wharf(B)"] = { c=25, t=6 },
		["Buckland"] = { mt=40 },
		}, z="Bree-Land", r=1, l="31.9s,62.8w" },
	["Tinnudir(B)"] = { ql=32, d={
		["Buckland(B)"] = { c=25, t=4 },
		["King's Crossing(B)"] = { c=25, t=6 },
		["Men Erain(B)"] = { c=25, t=4 },
		["The Eavespires(B)"] = { c=25, t=6 },
		["Trader's Wharf(B)"] = { c=25, t=6 },
		["Tyl Ruinen(B)"] = { c=25, t=6 },
		["Tinnudir"] = { mt=15 },
		}, z="Evendim", r=1, td="R6", l="12.6s,67.5w" },
	["The Eavespires(B)"] = { ql=36, d={
		["Tinnudir(B)"] = { c=25, t=6 },
		["Men Erain(B)"] = { c=25, t=6 },
		["Tyl Ruinen(B)"] = { c=25, t=6 },
		}, z="Evendim", r=1, l="6.0s,71.8w" },
	["Men Erain(B)"] = { ql=32, d={
		["Tinnudir(B)"] = { c=25, t=4 },
		["The Eavespires(B)"] = { c=25, t=6 },
		["Tyl Ruinen(B)"] = { c=25, t=4 },
		}, z="Evendim", r=1, td="R6", l="15.4s,66.3w" },
	["Tyl Ruinen(B)"] = { ql=33, d={
		["Tinnudir(B)"] = { c=25, t=6 },
		["The Eavespires(B)"] = { c=25, t=6 },
		["Men Erain(B)"] = { c=25, t=4 },
		}, z="Evendim", r=1, td="R6", l="12.9s,70.7w" },
	["King's Crossing(B)"] = { ql=32, d={
		["Buckland(B)"] = { c=25, t=4 },
		["Tinnudir(B)"] = { c=25, t=4 },
		["Trader's Wharf(B)"] = { c=25, t=6 },
		}, z="Evendim", r=1, l="13.6s,63.9w" },
	["Trader's Wharf(B)"] = { ql=45, d={
		["Buckland(B)"] = { c=25, t=4 },
		["King's Crossing(B)"] = { c=25, t=6 },
		["Tinnudir(B)"] = { c=25, t=4 },
		}, z="Evendim", r=1, l="21.3s,61.4w" },
	-- Forochel
	["Kauppa-kohta"] = { t=14, ml=29, ql=44, d={
		["Ost Forod"] = { c=25, l=40, t=300, s=35, st=70 },
		["Pynti-peldot"] = { c=25, l=40, t=326 },
		}, z="Forochel", r=1, td="R14", l="2.6n,58.0w" },
	["Pynti-peldot"] = { t=11, ml=29, ql=45, d={
		["Ost Forod"] = { c=25, t=625, l=-40, s=25, st=56, r="R3" },
		["Kauppa-kohta"] = { c=25, l=40, t=326 },
		["Zigilgund"] = { c=25, l=40, t=248 },
		["Suri-kyla"] = { c=25, l=40, t=303 },
		}, z="Forochel", r=1, td="R14", l="11.3n,69.4w" },
	["Zigilgund"] = { t=9, l=29, ql=46, d={
		["Pynti-peldot"] = { c=25, l=40, t=248 },
		["Suri-kyla"] = { c=25, t=538, l=-40, s=25, st=55, r="R3" },
		}, z="Forochel", r=1, td="R14", l="9.6n,81.1w" },
	["Suri-kyla"] = { t=4, ml=29, ql=47, d={
		["Ost Forod"] = { s=25, l=40, st=72 },
		["Pynti-peldot"] = { c=25, l=40, t=303 },
		["Zigilgund"] = { c=25, t=538, l=-40, s=25, st=55, r="R3" },
		["Kuru-leiri"] = { s=25, l=40, st=35, r="Q2" },
		["West Bree"] = { s=35, l=40, st=38, r="R1" },
		["Gath Forthnir"] = { s=35, l=40, st=45, r="Q1R4" },
		["Rivendell Stables"] = { s=35, l=40, st=37, r="R2" },
		}, z="Forochel", r=1, td="R14", l="19.1n,70.8w" },
	["Kuru-leiri"] = { ql=49, d={
		["Suri-kyla"] = { s=25, l=40, st=35, r="Q2" },
		}, z="Forochel", r=1, td="R14", l="19.5n,83.7w" },
	-- Angmar
	["Aughaire"] = { t=20, ml=15, ql=40, d={
		["Esteldin"] = { c=25, t=220 },
		["Gabilshathur"] = { s=25, st=35, r="Q1" },
		["Gath Forthnir"] = { s=25, st=29, r="Q1R4" },
		["Iorelen's Camp"] = { s=25, st=24, r="Q1R4" },
		}, z="Angmar", r=1, l="0.2s,39.3w" },
	["Bail Avarc"] = { t=2, ml=30, ql=140, d={ 
		["Gath Forthnir"] = { l=20, s=35, st=22, S0=true },
		["Esteldin"] = { l=20, s=35, st=15, S0=true },
		["Rivendell Stables"] = { l=20, s=35, st=14, S0=true },
		}, z="Angmar", a="Ephel Angren", r=1, l="70.3n,27.8w" },
	["Gabilshathur"] = { t=3, ml=25, ql=46, d={
		["Aughaire"] = { s=25, st=35, r="Q1" },
		["Gath Forthnir"] = { s=25, st=35, r="Q1R4" },
		["Iorelen's Camp"] = { s=25, st=26, r="Q1R4" },
		}, z="Angmar", r=1, l="3.6s,26.6w" },
	["Gath Forthnir"] = { t=23, ql=48, d={
		["Aughaire"] = { s=25, st=29, r="Q1R4" },
		["Bail Avarc"] = { s=35, st=21, S0=true },
		["Gabilshathur"] = { s=25, st=35, r="Q1R4" },
		["Iorelen's Camp"] = { s=25, st=27, r="Q1R4" },
		["Suri-kyla"] = { s=35, l=40, st=45, r="Q1R3" },
		["Esteldin"] = { s=35, l=40, st=39, r="R5" },
		["Rivendell Stables"] = { s=35, l=40, st=33, r="Q1R2" },
		}, z="Angmar", r=1, td="R15", l="10.4n,24.0w" },
	["Iorelen's Camp"] = { t=2, ml=35, ql=50, d={
		["Aughaire"] = { s=25, st=22, r="Q1R4" },
		["Gabilshathur"] = { s=25, st=26, r="Q1R4" },
		["Gath Forthnir"] = { s=25, st=27, r="Q1R4" }
		}, z="Angmar", r=1, l="10.6n,15.5w" },
	-- Misty Mountains
	["Gloin's Camp"] = { t=4, ml=20, ql=40, d={
		["Rivendell Stables"] = { c=15, t=150, l=-20, s=35, st=18 },
		["Hrimbarg"] = { s=25, st=23 },
		["High Crag"] = { s=25, st=15, S0=true },
		["Vindurhal"] = { s=25, st=15, S0=true },
		}, z="Misty Mountains", r=1, l="24.9s,4.0w" },
	["High Crag"] = { ql=45, d={ --
		["Gloin's Camp"] = { s=25, st=15, S0=true },
		["Hrimbarg"] = { s=25, st=15, S0=true },
		["Vindurhal"] = { s=25, st=11, S0=true },
		}, z="Misty Mountains", r=1, l="24.6s,1.3e" },
	["Hrimbarg"] = { ql=44, d={ --
		["Gloin's Camp"] = { s=25, st=23 },
		["High Crag"] = { s=25, st=15, S0=true },
		["Vindurhal"] = { s=25, st=11, S0=true },
		["Rivendell Stables"] = { s=35, st=23 },
		["Vegbar"] = { c=25, t=275, l=-90, s=122, st=32 },
		}, z="Misty Mountains", r=1, l="24.4s,7.0e" },
	["Vindurhal"] = { t=2, ml=25, ql=43, d={ --
		["Gloin's Camp"] = { s=25, st=15, S0=true },
		["High Crag"] = { s=25, st=11, S0=true },
		["Hrimbarg"] = { s=25, st=11, S0=true },
		}, z="Misty Mountains", r=1, l="23.3s,4.3e" },
	-- Ettenmoors
	["Glan Vraig"] = { ql=150, d={
		["Rivendell Stables"] = { l=20, s=35, st=30 },
		["South Bree"] = { s=35, st=30 },
		["Michel Delving"] = { s=35, st=30 },
		["Thorin's Gate"] = { s=35, st=30 },
		}, z="Ettenmoors", l="21.1s,13.4w" },
	["Ettenmoors"] = { z="Ettenmoors", r=1, n="Glan Vraig" },
	-- Eregion starts here
	["Gwingris"] = { t=7, ml=33, ql=48, d={
		["Echad Candelleth"] = { c=25, t=162, l=20, s=35, st=44 },
		["Rivendell Stables"] = { c=25, t=543, l=-20, s=35, st=38, r="D1" },
		["Echad Eregion"] = { c=25, t=150, l=-40, s=35, st=40, r="D2" },
		["Echad Dunnan"] = { c=25, t=327, l=-45, s=35, st=40, r="D3" },
		["Echad Mirobel"] = { c=25, t=378, l=-45, s=35, st=62, r="D4" },
		}, z="Eregion", r=1, l="40.2s,16.0w" },
	["Echad Eregion"] = { t=4, ml=34, ql=49, d={
		["Gwingris"] = { c=25, t=150, s=35, st=40, r="D1" },
		["Echad Dunnan"] = { c=25, t=180, l=-45, s=35, st=22, r="D3" },
		["Echad Mirobel"] = { c=25, t=228, l=-45, s=35, st=40, r="D4" },
		}, z="Eregion", r=1, l="47.0s,12.6w" },
	["Echad Dunnan"] = { t=4, ml=35, ql=50, d={
		["Rivendell Stables"] = { c=25, t=712, l=-35, s=35, st=22, r="D3" },
		["Echad Eregion"] = { c=25, t=180, l=-45, s=35, st=22, r="D2" },
		["Echad Mirobel"] = { c=25, t=210, l=-45, s=35, st=48, r="D4" },
		["Echad Dagoras"] = { c=25, t=242, l=-50, s=35, st=28 },
		["Durin's Threshold"] = { mt=180 },
		}, z="Eregion", r=1, l="50.6s,7.8w" },
	["Echad Mirobel"] = { t=24, ml=35, ql=51, d={
		["Echad Dagoras"] = { c=25, t=292, l=-50, s=35, st=42 },
		["Echad Dunnan"] = { c=25, t=210, l=-45, s=35, st=48, r="D3" },
		["Echad Eregion"] = { c=25, t=228, l=-45, s=35, st=40, r="D2" },
		["Gwingris"] = { c=25, t=378, l=-45, s=35, st=62, r="D1" },
		["Caras Gelebren"] = { c=1, t=155, s=5, st=39 },
		["Western Eregion"] = { c=1, t=150, s=5, st=37 },
		}, z="Eregion", r=1, l="52.3s,17.0w" },
	-- Moria locations start here
	["Durin's Threshold"] = { t=5, ml=35, ql=51, d={
		["Dolven-view"] = { c=35, l=-45, t=120 },
		["Chamber of the Crossroads"] = { c=35, l=-45, t=215 },
		["The Deep Descent"] = { c=35, l=-45, t=148 },
		["Echad Dunnan"] = { mt=180 },
		}, z="Moria", r=2, td="R17", a="the Great Delving", l="7.9s,116.1w"  },
	["Dolven-view"] = { t=6, ml=35, ql=51, d={
		["Durin's Threshold"] = { c=35, l=-45, t=120 },
		["Chamber of the Crossroads"] = { c=35, l=-45, t=94 },
		["The Deep Descent"] = { c=35, l=-45, t=34 },
		["Twenty-first Hall"] = { c=35, l=-45, t=254, s=45, st=15 },
		["First Hall"] = { c=35, l=-45, t=413, s=45, st=47 },
		["The Orc-watch"] = { c=35, l=-45, t=436 },
		["Anazarmekhem"] = { c=35, l=-45, t=256 },
		}, z="Moria", r=2, td="R17", a="the Great Delving", l="8.4s,112.4w"  },
	["The Deep Descent"] = { t=8, ml=37, ql=53, d={
		["Durin's Threshold"] = { c=35, l=-45, t=148 },
		["The Rotting Cellar"] = { c=35, l=-45, t=180 },
		["Dolven-view"] = { c=35, l=-45, t=34 },
		}, z="Moria", r=2, td="R17", a="the Silvertine Lodes", l="9.8s,112.5w"  },
	["The Rotting Cellar"] = { t=4, ml=39, ql=54, d={
		["The Orc-watch"] = { c=35, l=-45, t=244 },
		["Anazarmekhem"] = { c=35, l=-45, t=164 },
		["The Deep Descent"] = { c=35, l=-45, t=180 },
		["The Vile Maw"] = { c=35, l=-45, t=148 },
		}, z="Moria", r=2, td="R17", a="the Water-works", l="15.1s,111.9w"  },
	["The Vile Maw"] = { ql=56, d={ --
		["The Rotting Cellar"] = { c=35, l=-45, t=148 },
		}, z="Moria", r=2, td="R17", a="the Silvertine Lodes", l="17.6s,116.9w"  },
	["Chamber of the Crossroads"] = { t=5, ml=36, ql=52, d={ --
		["Durin's Threshold"] = { c=35, l=-45, t=215 },
		["Dolven-view"] = { c=35, l=-45, t=94 },
		["Twenty-first Hall"] = { c=35, l=-45, t=190, s=35, st=20, r="Q4" },
		}, z="Moria", r=2, td="R17", a="Durin's Way", l="5.2s,112.1w"  },
	["Zirakzigil"] = { ql=54, d={ --
		["Jazargund"] = { c=35, l=-45, t=98 },
		}, z="Moria", r=2, td="R17", a="Durin's Way", l="2.9s,110.8w"  },
	["Tharakh Bazan"] = { ql=53, d={ --
		["Twenty-first Hall"] = { s=35, l=-45, st=14 },
		}, z="Moria", r=2, td="R17", a="Durin's Way", l="3.2s,108.6w"  },
	["Jazargund"] = { t=9, ml=36, ql=53, d={
		["Twenty-first Hall"] = { c=35, l=-45, t=48 },
		["Zirakzigil"] = { c=35, l=-45, t=98 },
		}, z="Moria", r=2, td="R17", a="Durin's Way", l="3.7s,106.0w"  },
	["Great Hall of Durin"] = { ql=55, d={
		["Twenty-first Hall"] = { st=4 },
		}, z="Moria", r=2, a="Zelem-melek", l="7.7s,105.6w"  },
	["Hall of Flowing Water"] = { ql=55, d={
		["Twenty-first Hall"] = { st=4 },
		}, z="Moria", r=2, a="Zelem-melek", l="8.9s,107.7w"  },
	["Twenty-first Hall"] = { t=5, ml=39, ql=54, d={
		["Lond Cirion"] = { l=130, s=180, st=17 },
		["Osgiliath"] = { l=90, s=122, st=19 },
		["Galtrev"] = { s=45, l=65, st=20 },
		["Annak-khurfu"] = { s=147.5, l=115, st=30 },
		["Stangard"] = { s=45, l=70, st=32 },
		["Linhir(KG)"] = { s=162.25, l=130, st=24 },
		["Pelargir East Gate"] = { s=162.25, l=130, st=17 },
		["Pelargir West Gate"] = { s=162.25, l=130, st=15 },
		["Inner Caras Galadhon"] = { s=25, l=50, st=17, r="Q3" },
		["Magh Ashtu"] = { l=90, s=122, st=26 },
		["Anazarmekhem"] = { c=35, l=-45, t=306 },
		["Chamber of the Crossroads"] = { c=35, l=-45, t=190, s=35, st=20, r="Q5" },
		["Dolven-view"] = { c=35, l=-45, t=254, s=45, st=15 },
		["Great Hall of Durin"] = { st=4 },
		["Hall of Flowing Water"] = { st=4 },
		["First Hall"] = { c=35, l=-45, t=345, s=45, st=46 },
		["Jazargund"] = { c=35, l=-45, t=48 },
		["Shadowed Refuge"] = { c=35, l=-45, t=366, s=45, st=31 },
		["Tharakh Bazan"] = { s=35, l=45, st=14 },
		["The Fanged Pit"] = { s=35, l=45, st=13 },
		["The Orc-watch"] = { c=35, l=-45, t=306 },
		["Minas Tirith"] = { s=115, l=90, st=30 },
		["Snowbourn"] = { l=-75, s=71.5, st=40 },
		["Aldburg"] = { l=85, s=71.5, st=28 },
		["Helm's Deep"] = { l=85, s=71.5, st=23 },
		["Forlaw"] = { l=75, s=71.5, st=18 },
		["Dale"] = { l=90, s=122, st=18 },
		["Jarnfast"] = { l=90, s=122, st=20 },
		["Skarhald"] = { l=90, s=122, st=32 },
		["Hultvis"] = { l=90, s=122, st=25 },
		["Dol Amroth"] = { l=90, s=115, st=23 },
		}, z="Moria", r=2, td="R17", a="Zelem-melek", l="5.7s,105.3w"  },
	["The Fanged Pit"] = { t=1, ml=42, ql=53, d={
		["Twenty-first Hall"] = { s=35, l=-45, st=13 },
		}, z="Moria", r=2, td="R17", a="Durin's Way", l="3.5s,103.3w"  },
	["The Orc-watch"] = { t=9, ml=39, ql=56, d={
		["Twenty-first Hall"] = { c=35, l=-45, t=306 },
		["Anazarmekhem"] = { c=35, l=-45, t=83 },
		["Auti's Camp"] = { st=1 },
		["Shadowed Refuge"] = { c=35, l=-45, t=182 },
		["Dolven-view"] = { c=35, l=-45, t=436 },
		["The Rotting Cellar"] = { c=35, l=-45, t=244 },
		}, z="Moria", r=2, td="R17", a="Redhorn Lodes", l="11.1s,106.9w"  },
	["Auti's Camp"] = { ql=56, d={
		["The Orc-watch"] = { st=1 },
		}, z="Moria", r=2, a="Redhorn Lodes", l="13.3s,104.6w"  },
	["Knakk's Camp"] = { ql=56, d={
		["The Orc-watch"] = { st=1 },
		}, z="Moria", r=2, a="Redhorn Lodes", l="11.0s,103.7w"  },
	["Anazarmekhem"] = { t=3, ml=41, ql=56, d={
		["The Orc-watch"] = { c=35, l=-45, t=83 },
		["The Rotting Cellar"] = { c=35, l=-45, t=164 },
		["Twenty-first Hall"] = { c=35, l=-45, t=306 },
		["Dolven-view"] = { c=35, l=-45, t=256 },
		["Cross-roads of Ash"] = { st=1 },
		["Durin's Court"] = { st=1 },
		}, z="Moria", r=2, td="R17", a="The Flaming Deeps", l="13.2s,108.2w"  },
	["Cross-roads of Ash"] = { ql=56, d={
		["Anazarmekhem"] = { st=1 },
		}, z="Moria", r=2, a="Redhorn Lodes", l="16.2s,109.7w"  },
	["Durin's Court"] = { ql=56, d={
		["Anazarmekhem"] = { st=1 },
		}, z="Moria", r=2, a="Redhorn Lodes", l="16.2s,107.4w"  },
	["Shadowed Refuge"] = { t=14, ml=43, ql=58, d={
		["The Orc-watch"] = { c=35, l=-45, t=182 },
		["Twenty-first Hall"] = { c=35, l=-45, t=366, s=45, st=31 },
		["First Hall"] = { c=35, l=-45, t=344, s=45, st=57 },
		}, z="Moria", r=2, td="R17", a="Foundations of Stone", l="13.1s,101.2w"  },
	["First Hall"] = { d={ -- no ms
		["Shadowed Refuge"] = { c=35, l=-45, t=344, s=45, st=57 },
		["Twenty-first Hall"] = { c=35, l=-45, t=345, s=45, st=46 },
		["Dolven-view"] = { c=35, l=-45, t=413, s=45, st=47 },
		["Mekhem-bizru"] = { mt=38 },
		}, z="Moria", r=2, td="R17", a="Nud-Melek", l="8.0s,95.3w"  },
	-- Lothlorien locations start here
	["Mekhem-bizru"] = { t=8, ml=39, td="R8", ql=59, d={ --
		["Echad Andestel"] = { c=25, t=133, l=-50, s=25, st=24, r="D13" },
		["Cerin Amroth"] = { c=25, t=238, l=-50, s=25, st=12, r="D14" },
		["Caras Galadhon"] = { c=25, t=255, l=-50, s=25, st=16, r="D14" },
		["The Vinyards of Lorien"] = { c=25, t=278, l=-50, s=25, st=12, r="D15" },
		["First Hall"] = { mt=38 },
		}, z="Lothlorien", r=2, td="R8", l="11.5s,78.6w"  },
	["Echad Andestel"] = { t=8, ml=39, td="R8", ql=60, d={
		["Mekhem-bizru"] = { c=25, t=133, l=-50, s=35, st=24 },
		["Cerin Amroth"] = { c=25, t=140, l=-50, s=35, st=24, r="D14" },
		["The Vinyards of Lorien"] = { c=25, t=182, l=-50, s=35, st=24, r="D15" },
		["Caras Galadhon"] = { c=25, t=258, l=-50, s=35, st=24, r="D14" },
		}, z="Lothlorien", r=2, td="R8", l="14.4s,73.1w"  },
	["Cerin Amroth"] = { td="R8", ql=60, d={ --
		["Mekhem-bizru"] = { c=25, t=238, l=-50, s=35, st=12 },
		["Echad Andestel"] = { c=25, t=140, l=-50, s=35, st=24, r="D13" },
		["Caras Galadhon"] = { c=25, t=133, l=-50, s=35, st=12, r="D14" },
		["The Vinyards of Lorien"] = { c=25, t=190, l=-50, s=35, st=14, r="D15" },
		}, z="Lothlorien", r=2, td="R8", l="11.7s,69.1w"  },
	["Caras Galadhon"] = { td="R8", ql=60, d={ --
		["Minas Tirith(M)"] = { s=1, st=35, S0=true },
		["Annak-khurfu"] = { s=147.5, l=115, st=29 },
		["Zidir-nesad"] = { l=130, s=161.35, st=16 },
		["Cerin Amroth"] = { c=25, l=-50, t=133, s=35, st=12, r="D14" },
		["Echad Andestel"] = { c=25, t=258, l=-50, s=35, st=24, r="D13" },
		["Mekhem-bizru"] = { c=25, t=255, l=-50, s=35, st=16 },
		["The Vinyards of Lorien"] = { c=25, t=68, l=-50, s=35, st=12, r="D15" },
		["Inner Caras Galadhon"] = { mt=65, r="Q3" },
		["Arhaim"] = { c=85, t=288, l=-90, s=120, st=30 },
		}, z="Lothlorien", r=2, td="R8", l="16.7s,67.5w" },
	["Inner Caras Galadhon"] = { t=30, td="R8", ql=60, d={
		["Galtrev"] = { s=45, l=65, st=26 },
		["Lhanuch"] = { s=45, l=50, st=28, r="R8D6" },
		["Stangard"] = { s=45, l=70, st=20 },
		["Ost Galadh"] = { s=25, l=50, st=27, r="D12" },
		["Twenty-first Hall"] = { l=50, s=25, st=17, r="Q3" },
		["Snowbourn"] = { l=-75, s=71.5, st=17 },
		["Rivendell Stables"] = { s=45, l=50, st=17, r="R7Q3" },
		["Caras Galadhon"] = { mt=65 },
		}, z="Lothlorien", r=2, td="R8", a="Caras Galadhon", l="15.1s,68.2w" },
	["The Vinyards of Lorien"] = { t=31, ml=39, td="R8", ql=60, d={
		["Mekhem-bizru"] = { c=25, t=278, l=-50, s=35, st=12 },
		["Echad Andestel"] = { c=25, t=182, l=-50, s=35, st=24, r="D13" },
		["Caras Galadhon"] = { c=25, t=68, l=-50, s=35, st=12, r="D14" },
		["Cerin Amroth"] = { c=25, t=190, l=-50, s=35, st=14, r="D14" },
		["Thinglad"] = { c=25, t=70,  l=70, s=35, st=20 },
		["Lothlorien(B)"] = { mt=28 },
		}, z="Lothlorien", r=2, td="R8", l="18.3s,64.2w"  },
	["Lothlorien(B)"] = { t=31, ml=39, ql=60, d={
		["The Vinyards of Lorien"] = { mt=28 },
		["Echad Sirion"] = { mt=26, r="D12", n="Boat to Mirkwood" },
		}, z="Lothlorien", r=2, l="17.6s,64.6w"  },
	-- Mirkwood locations start here
	["Echad Sirion"] = { t=1, ml=37, ql=61, d={
		["The Haunted Inn"] = { c=25, t=110, l=-50, s=35, st=28, r="D16" },
		["Ost Galadh"] = { c=25, t=200, l=-50, s=35, st=18, r="D17" },
		["Estolad Mernael"] = { c=25, t=223, l=-50, s=35, st=12, r="D17" },
		["Thangulhad"] = { c=25, t=340, l=-50, s=35, st=31, r="D18" },
		["Mithechad"] = { c=25, t=279, l=-50, s=35, st=12, r="D18" },
		["Helethir"] = { c=25, t=385, l=-50, s=35, st=12, r="D18" },
		["Lothlorien(B)"] = { mt=20, r="D12", n="Boat to Lothlorien" },
		}, z="Mirkwood", r=2, td="R19", l="15.3s,61.3w" },
	["The Haunted Inn"] = { t=5, ml=37, ql=62, d={
		["Echad Sirion"] = { c=25, t=110, l=-50, s=35, st=28 },
		["Ost Galadh"] = { c=25, t=126, l=-50, s=35, st=35, r="D17" },
		["Estolad Mernael"] = { c=25, t=150, l=-50, s=35, st=30, r="D18" },
		["Thangulhad"] = { c=25, t=274, l=-50, s=35, st=40, r="D18" },
		["Mithechad"] = { c=25, t=214, l=-50, s=35, st=27, r="D18" },
		["Helethir"] = { c=25, t=330, l=-50, s=35, st=30, r="D18" },
		}, z="Mirkwood", r=2, td="R19", l="13.4s,56.2w" },
	["Ost Galadh"] = { t=0, ml=37, ql=63, d={
		["Inner Caras Galadhon"] = { s=35, l=50, st=27, r="Q3" },
		["Echad Sirion"] = { c=25, t=200, l=-50, s=35, st=18 },
		["Estolad Mernael"] = { c=25, t=130, l=-50, s=35, st=18, r="D17" },
		["Helethir"] = { c=25, t=192, l=-50, s=35, st=23, r="D18" },
		["Mithechad"] = { c=25, t=87, l=-50, s=35, st=17, r="D18" },
		["Thangulhad"] = { c=25, t=148, l=-50, s=35, st=36, r="D18" },
		["The Haunted Inn"] = { c=25, t=126, l=-50, s=35, st=35, r="D16" },
		["Tham Taerdol"] = { l=90, s=122, st=18 },
		}, z="Mirkwood", r=2, td="R19", l="14.3s,51.2w" },
	["Estolad Mernael"] = { t=16, ml=37, ql=63, d={
		["Echad Sirion"] = { c=25, t=223, l=-50, s=35, st=12 },
		["The Haunted Inn"] = { c=25, t=150, l=-50, s=35, st=30, r="D16" },
		["Ost Galadh"] = { c=25, t=130, l=-50, s=35, st=18, r="D17" },
		["Thangulhad"] = { c=25, t=280, l=-50, s=35, st=27, r="D18" },
		["Mithechad"] = { c=25, t=123, l=-50, s=35, st=14, r="D18" },
		["Helethir"] = { c=25, t=326, l=-50, s=35, st=41, r="D18" },
		}, z="Mirkwood", r=2, td="R19", l="16.8s,54.6w" },
	["Mithechad"] = { t=3, ml=37, ql=65, d={
		["Echad Sirion"] = { c=25, t=279, l=-50, s=28, st=12 },
		["The Haunted Inn"] = { c=25, t=214, l=-50, s=35, st=27, r="D16" },
		["Ost Galadh"] = { c=25, t=87, l=-50, s=35, st=17, r="D17" },
		["Estolad Mernael"] = { c=25, t=123, l=-50, s=35, st=15, r="D17" },
		["Thangulhad"] = { c=25, t=230, l=-50, s=35, st=26, r="D18" },
		["Helethir"] = { c=25, t=277, l=-50, s=35, st=14, r="D18" },
		}, z="Mirkwood", r=2, td="R19", l="17.6s,48.3w" },
	["Thangulhad"] = { t=6, ml=37, ql=65, d={
		["Echad Sirion"] = { c=25, t=340, l=-50, s=35, st=31 },
		["Estolad Mernael"] = { c=25, t=280, l=-50, s=35, st=27, r="D17" },
		["Helethir"] = { c=25, t=82, l=-50, s=35, st=26, r="D18" },
		["Mithechad"] = { c=25, t=230, l=-50, s=35, st=26, r="D18" },
		["Ost Galadh"] = { c=25, t=148, l=-50, s=35, st=36, r="D17" },
		["The Haunted Inn"] = { c=25, t=274, l=-50, s=35, st=40, r="D16" },
		["Tham Taerdol"] = { l=90, s=122, st=25 },
		}, z="Mirkwood", r=2, td="R19", l="12.8s,46.1w" },
	["Helethir"] = { ql=65, d={ --
		["Echad Sirion"] = { c=25, t=385, l=-50, s=35, st=12 },
		["The Haunted Inn"] = { c=25, t=330, l=-50, s=35, st=30, r="D16" },
		["Ost Galadh"] = { c=25, t=192, l=-50, s=35, st=23, r="D17" },
		["Estolad Mernael"] = { c=25, t=326, l=-50, s=35, st=41, r="D17" },
		["Thangulhad"] = { c=25, t=82, l=-50, s=35, st=26, r="D18" },
		["Mithechad"] = { c=25, t=277, l=-50, s=35, st=14, r="D18" },
		}, z="Mirkwood", r=2, td="R19", l="16.1s,44.6w" },
	-- Enedwaith locations start here
	["Echad Dagoras"] = { t=2, ml=40, ql=61, d={
		["Maur Tulhau"] = { c=25, t=305, l=-50, s=35, st=28, r="D5" },
		["Lhanuch"] = { c=25, t=244, l=-50, s=35, st=25, r="D6" },
		["Harndirion"] = { c=25, t=303, l=-50, s=35, st=17, r="D7" },
		["Echad Daervunn"] = { c=25, t=288, l=-50, s=35, st=12, r="D6" },
		["Echad Mirobel"] = { c=25, t=292, l=-50, s=35, st=42 },
		["Echad Dunnan"] = { c=25, t=242, l=-50, s=35, st=28 },
		}, z="Enedwaith", r=1, td="R16", l="58.5s,14.5w" },
	["Maur Tulhau"] = { t=19, ml=40, ql=62, d={
		["Echad Daervunn"] = { c=25, t=90, l=-50, s=35, st=15, r="D6" },
		["Echad Dagoras"] = { c=25, t=305, l=-50, s=35, st=28 },
		["Harndirion"] = { c=25, t=270, l=-50, s=35, st=20, r="D7" },
		["Lhanuch"] = { c=25, t=214, l=-50, s=35, st=32, r="D6" },
		["Lintrev"] = { c=1, t=51, s=5, st=20 },
		}, z="Enedwaith", r=1, l="62.9s,23.2w" },
	["Echad Daervunn"] = { t=0, ml=40, ql=65, d={
		["Echad Dagoras"] = { c=25, t=288, l=50, s=35, st=12 },
		["Maur Tulhau"] = { c=25, t=90, l=-50, s=35, st=16, r="D5" },
		["Lhanuch"] = { c=25, t=132, l=-50, s=35, st=22, r="D6" },
		["Harndirion"] = { c=25, t=189, l=-50, s=35, st=12, r="D7" },
		["Lhan Tarren"] = { c=25, t=178, l=65, s=35, st=12 },
		}, z="Enedwaith", r=1, td="R16", l="66.6s,21.5w" },
	["Lhanuch"] = { t=19, ml=40, ql=63, d={
		["South Bree"] = { s=45, l=50, st=28 },
		["Galtrev"] = { s=45, st=24, l=65 },
		["Echad Dagoras"] = { c=25, t=244, l=-50, s=35, st=25 },
		["Maur Tulhau"] = { c=25, t=214, l=-50, s=35, st=32, r="D5" },
		["Harndirion"] = { c=25, t=83, l=-50, s=35, st=25, r="D7" },
		["Echad Daervunn"] = { c=25, t=132, l=-50, s=35, st=22, r="D6" },
		["Inner Caras Galadhon"] = { s=45, l=50, st=28, r="Q3R8" },
		["Lhan Garan"] = { c=1, t=350, s=5, st=32 },
		["Lintrev"] = { c=1, t=262, s=5, st=28 },
		["Mossward"] = { s=5, st=27 },
		["Rivendell Stables"] = { s=45, l=20, st=27, r="R7" },
		}, z="Enedwaith", r=1, td="R21", l="66.9s,16.9w" },
	["Harndirion"] = { t=1, ml=40, ql=63, d={
		["Echad Dagoras"] = { c=25, t=303, l=-50, s=35, st=17 },
		["Maur Tulhau"] = { c=25, t=270, l=-50, s=35, st=20, r="D5" },
		["Lhanuch"] = { c=25, t=83, l=-50, s=35, st=25, r="D6" },
		["Echad Daervunn"] = { c=25, t=189, l=-50, s=35, st=12, r="D6" },
		["Echad Naeglanc"] = { c=25, t=250, l=65, s=35, st=19 },
		}, z="Enedwaith", r=1, td="R16", l="69.4s,13.7w" },
	-- Dunland locations start here
	["Echad Naeglanc"] = { t=5, ml=46, ql=66, d={
		["Lhan Tarren"] = { c=25, t=165, l=6-5, s=35, st=15 },
		["Galtrev"] = { c=25, t=190, l=-65, s=35, st=15 },
		["Harndirion"] = { c=25, t=250, l=-65, s=35, st=19 },
		}, z="Dunland", r=1, td="R20", l="77.3s,15.8w" },
	["Lhan Tarren"] = { t=4, ml=46, ql=66, d={
		["Echad Naeglanc"] = { c=25, t=165, l=-65, s=35, st=15 },
		["Galtrev"] = { c=25, t=190, l=-65, s=35, st=17 },
		["Echad Daervunn"] = { c=25, t=178, l=-65, s=35, st=12 },
		}, z="Dunland", r=1, td="R20", l="75.3s,22.4w" },
	["Galtrev"] = { t=7, ml=47, ql=67, d={
		["Lond Cirion"] = { l=130, s=180, st=31 },
		["Minas Tirith(M)"] = { s=1, st=28, S0=true },
		["Osgiliath"] = { l=90, s=122, st=22 },
		["South Bree"] = { s=45, st=22, l=-65 },
		["Avardin"] = { c=25, t=123, l=-65, s=35, st=16 },
		["Barnavon"] = { c=25, t=158, l=-65, s=35, st=18 },
		["Dagoras' Camp"] = { c=25, t=396, l=-65, s=35, st=20 },
		["Echad Naeglanc"] = { c=25, t=190, l=-65, s=35, st=15 },
		["Forthbrond"] = { c=25, t=270, l=-65, s=35, st=16 },
		["Grimbold's Camp"] = { c=25, t=348, l=-65, s=35, st=18 },
		["Lhan Rhos"] = { c=25, t=214, l=-65, s=35, st=16 },
		["Lhan Tarren"] = { c=25, t=190, l=-65, s=35, st=17 },
		["Rohirrim Scout-camp"] = { c=25, t=160, l=-65, s=35, st=20 },
		["Tal Methedras Gate"] = { c=25, t=112, l=-65, s=35, st=21 },
		["Annak-khurfu(I)"] = { l=20, s=1, st=2 },
		["Lhanuch"] = { s=45, st=24, l=-65 },
		["Zidir-nesad"] = { l=130, s=161.35, st=19 },
		["Linhir(KG)"] = { s=162.25, l=130, st=28 },
		["Pelargir East Gate"] = { s=162.25, l=130, st=19 },
		["Pelargir West Gate"] = { s=162.25, l=130, st=18 },
		["Inner Caras Galadhon"] = { s=45, l=50, st=21, r="Q3" },
		["Magh Ashtu"] = { l=90, s=122, st=30 },
		["Twenty-first Hall"] = { s=45, st=20, l=-65 },
		["Trestlebridge(R)"] = { l=20, s=1, st=4, S0=true },
		["Dale"] = { l=90, s=122, st=27 },
		["Jarnfast"] = { l=90, s=122, st=27 },
		["Skarhald"] = { l=90, s=122, st=27 },
		["Hultvis"] = { l=90, s=122, st=30 },
		}, z="Dunland", r=1, td="R20", a="Galtrev", l="79.9s,16.7w" },
	["Tal Methedras Gate"] = { t=32, ml=48, ql=68, d={
		["Galtrev"] = { c=25, t=112, l=-65, s=35, st=21 },
		}, z="Dunland", r=1, td="R20", l="78.3s,11.2w" },
	["Rohirrim Scout-camp"] = { t=1, ml=48, ql=72, d={
		["Forthbrond"] = { c=25, t=70, l=-65, s=35, st=18 },
		["Galtrev"] = { c=25, t=160, l=-65, s=35, st=20 },
		["Barnavon"] = { c=25, t=156, l=-65, s=35, st=16 },
		}, z="Dunland", r=1, td="R22", l="80.9s,10.6w" },
	["Barnavon"] = { t=15, ml=48, ql=71, d={
		["Lhan Rhos"] = { c=25, t=162, l=-65, s=35, st=12 },
		["Galtrev"] = { c=25, st=158, l=-65, s=35, st=18 },
		["Rohirrim Scout-camp"] = { c=25, t=156, l=-65, s=35, st=16 },
		}, z="Dunland", r=1, td="R20", l="84.7s,16.3w" },
	["Avardin"] = { t=12, ml=47, ql=69, d={
		["Galtrev"] = { c=25, t=123, l=-65, s=35, st=16 },
		["Lhan Rhos"] = { c=25, t=103, l=-65, s=35, st=10 },
		}, z="Dunland", r=1, td="R20", l="83.5s,20.5w" },
	["Lhan Rhos"] = { t=16, ml=55, ql=70, d={
		["Avardin"] = { c=25, t=103, l=-65, s=35, st=10 },
		["Galtrev"] = { c=25, t=214, l=-65, s=35, st=16 },
		["Barnavon"] = { c=25, t=162, l=-65, s=35, st=12 },
		}, z="Dunland", r=1, td="R20", l="86.8s,23.0w" },
	["Wulf's Cleft Overlook"] = { ql=69, d={
		["Barnavon"] = { s=0, l=65, st=12 },
		}, z="Dunland", a="Gap of Rohan", r=1, l="87.7s,16.2w" },
	["Forthbrond"] = { t=3, ml=49, ql=73, d={
		["Rohirrim Scout-camp"] = { c=25, t=70, l=-65, s=35, st=18 },
		["Galtrev"] = { c=25, t=270, l=-65, s=35, st=16 },
		["Grimbold's Camp"] = { c=25, t=80, l=-65, s=35, st=15 },
		}, z="Dunland", a="Gap of Rohan", r=1, l="86.9s,7.6w" },
	["Grimbold's Camp"] = { t=2, ml=49, ql=74, d={
		["Forthbrond"] = { c=25, t=80, l=-65, s=35, st=15 },
		["Galtrev"] = { c=25, t=348, l=-65, s=35, st=18 },
		["Dagoras' Camp"] = { c=25, t=67, l=-65, s=35, st=15 },
		}, z="Dunland", a="Gap of Rohan", r=1, l="87.8s,3.9w" },
	["Dagoras' Camp"] = { t=0, ml=50, ql=75, d={
		["Grimbold's Camp"] = { c=25, t=67, l=-65, s=35, st=15 },
		["Galtrev"] = { c=25, t=396, l=-65, s=35, st=20 },
		}, z="Dunland", a="Nan Curunir", r=1, l="84.9s,3.5w" },
	-- the Great River locations start here
	["Thinglad"] = { t=2, ml=50, td="R8", ql=70, d={
		["The Vinyards of Lorien"] = { c=25, t=70,  l=-70, s=35, st=20 },
		["Stangard"] = { c=25, t=80,  l=-70, s=35, st=20 },
		["Limlight Gorge"] = { s=35, l=70, st=13 },
		["Parth Celebrant"] = { s=35, l=70, st=20 },
		["Rushgore"] = { s=35, l=70, st=15 },
		["Brown Lands"] = { s=35, l=70, st=20 },
		}, z="Great River", r=2, l="21.4s,63.4w" },
	["Limlight Gorge"] = { td="R26", ql=75, d={ --
		["Brown Lands"] = { s=35, l=70, st=11 },
		["Parth Celebrant"] = { c=25, t=170, l=-70, s=35, st=14 },
		["Rushgore"] = { s=35, l=70, st=10 },
		["Stangard"] = { c=25, t=80,  l=-70, s=35, st=18 },
		["Thinglad"] = { s=35, l=70, st=13 },
		}, z="Great River", r=2, l="25.6s,67.0w" },
	["Stangard"] = { t=35, ml=50, td="R26", ql=75, d={
		["South Bree"] = { s=45, l=70, st=20 },
		["Brown Lands"] = { c=25, t=240,  l=-70, s=35, st=18 },
		["Limlight Gorge"] = { c=25, t=80,  l=-70, s=35, st=18 },
		["Parth Celebrant"] = { c=25, t=95,  l=-70, s=35, st=16 },
		["Rushgore"] = { c=25, t=166,  l=-70, s=35, st=23 },
		["Thinglad"] = { c=25, t=80,  l=-70, s=35, st=20 },
		["Inner Caras Galadhon"] = { s=45, l=50, st=21, r="Q3" },
		["Twenty-first Hall"] = { s=45, l=70, st=32 },
		["Harwick"] = { c=66, t=315, l=-75, s=71.5, st=25 },
		["Snowbourn"] = { l=-75, s=71.5, st=19 },
		}, z="Great River", r=2, l="25.6s,62.9w" },
	["Parth Celebrant"] = { t=1, ml=50, td="R26", ql=73, d={
		["Brown Lands"] = { s=35, l=70, st=11 },
		["Limlight Gorge"] = { c=25, t=170,  l=-70, s=35, st=14 },
		["Rushgore"] = { c=25, t=140,  l=-70, s=35, st=10 },
		["Stangard"] = { c=25, t=95,  l=-70, s=35, st=16 },
		["Thinglad"] = { s=35, l=70, st=20 },
		}, z="Great River", r=2, l="26.6s,58.3w" },
	["Rushgore"] = { t=2, ml=50, td="R26", ql=74, d={
		["Brown Lands"] = { c=25, t=133,  s=35, l=70, st=14 },
		["Parth Celebrant"] = { c=25, t=140,  l=-70, s=35, st=10 },
		["Stangard"] = { c=25, t=166,  l=-70, s=35, st=23 },
		["Thinglad"] = { s=35, l=70, st=15 },
		["Limlight Gorge"] = { s=35, l=70, st=10 },
		}, z="Great River", r=2, l="29.2s,55.2w" },
	["Brown Lands"] = { t=7, ml=50, td="R26", ql=75, d={
		["Rushgore"] = { c=25, t=133,  l=-70, s=35, st=14 },
		["Stangard"] = { c=25, t=240,  l=-70, s=35, st=18 },
		["Thinglad"] = { s=35, l=70, st=20 },
		["Limlight Gorge"] = { s=35, l=70, st=11 },
		["Parth Celebrant"] = { s=35, l=70, st=11 },
		}, z="Great River", r=2, l="31.2s,52.0w" },
	-- the East Rohan locations start here
	["Harwick"] = { t=7, ml=60, td="R23", ql=76, d={
		["Stangard"] = { c=60, t=315, l=-75, s=71.5, st=25 },
		["Cliving"] = { c=60, t=238, l=-75, s=66, st=40 },
		["Eaworth"] = { c=60, t=380, l=-75, s=66, st=25 },
		["Elthengels"] = { c=60, t=269, l=-75, s=66, st=44 },
		["Floodwend"] = { c=60, t=178, l=-75, s=66, st=30 },
		["Hytbold"] = { c=65, t=492, l=-84, s=71.5, st=42, r="R28,Q6" },
		["Parth Galen"] = { c=60, t=492, l=-75, s=66, st=28 },
		["Snowbourn"] = { c=60, t=546, l=-75, s=66, st=24 },
		["Forlaw"] = { l=-75, s=71.5, st=25 },
		["Scylfig"] = { c=60, t=221, l=-75, s=71.5, st=22 },
		}, z="East Rohan", r=2, a="the Wold", l="39.0s,52.3w" },
	["Floodwend"] = { t=5, ml=60, td="R23", ql=77, d={
		["Elthengels"] = { c=60, t=127, l=-75, s=66, st=45 },
		["Harwick"] = { c=60, t=178, l=-75, s=66, st=30 },
		["Mansig's Encampment"] = { c=60, t=173, l=-75, s=66, st=39 },
		["Parth Galen"] = { c=60, t=345, l=-75, s=66, st=29 },
		}, z="East Rohan", r=2, a="the Wold", l="45.3s,48.2w" },
	["Mansig's Encampment"] = { t=7, ml=60, ql=76, d={
		["Elthengels"] = { c=60, t=214, l=-75, s=66, st=53 },
		["Floodwend"] = { c=60, t=173, l=-75, s=66, st=39 },
		["Parth Galen"] = { c=60, t=215, l=-75, s=66, st=35 },
		}, z="East Rohan", r=2, a="the East Wall", l="52.2s,51.3w" },
	["Parth Galen"] = { t=3, ml=60, ql=77, d={
		["Cliving"] = { c=60, t=502, l=-75, s=66, st=37 },
		["Eaworth"] = { c=60, t=644, l=-75, s=66, st=22 },
		["Elthengels"] = { c=60, t=390, l=-75, s=66, st=42 },
		["Floodwend"] = { c=60, t=345, l=-75, s=66, st=29 },
		["Harwick"] = { c=60, t=492, l=-75, s=66, st=28 },
		["Mansig's Encampment"] = { c=60, t=215, l=-75, s=66, st=35 },
		["Snowbourn"] = { c=60, t=327, l=-75, s=66, st=22 },
		["Walstow"] = { c=60, t=194, l=-75, s=66, st=19 },
		}, z="East Rohan", r=2, a="the East Wall", l="58.7s,47.8w" },
	["Cliving"] = { t=3, ml=60, td="R24", ql=79, d={
		["Eaworth"] = { c=60, t=181, l=-75, s=66, st=32 },
		["Elthengels"] = { c=60, t=144, l=-75, s=66, st=35 },
		["Faldham"] = { c=60, t=226, l=-75, s=66, st=33 },
		["Harwick"] = { c=60, t=238, l=-75, s=66, st=40 },
		["Hytbold"] = { c=65, t=300, l=-84, s=71.5, st=48, r="R29,Q6" },
		["Parth Galen"] = { c=60, t=502, l=-75, s=66, st=37 },
		["Snowbourn"] = { c=60, t=354, l=-75, s=66, st=33 },
		}, z="East Rohan", r=2, a="Norcrofts", l="43.3s,56.6w" },
	["Elthengels"] = { t=36, ml=60, td="R24", ql=78, d={
		["Cliving"] = { c=60, t=144, l=-75, s=66, st=35 },
		["Faldham"] = { c=60, t=176, l=-75, s=66, st=25 },
		["Floodwend"] = { c=60, t=127, l=-75, s=66, st=45 },
		["Harwick"] = { c=60, t=269, l=-75, s=66, st=44 },
		["Hytbold"] = { c=65, t=248, l=-84, s=71.5, st=39, r="R29,Q6" },
		["Mansig's Encampment"] = { c=60, t=214, l=-75, s=66, st=53 },
		["Parth Galen"] = { c=60, t=390, l=-75, s=66, st=42 },
		}, z="East Rohan", r=2, a="Norcrofts", l="48.9s,52.9w" },
	["Faldham"] = { t=12, ml=60, td="R24", ql=79, d={
		["Cliving"] = { c=60, t=226, l=-75, s=66, st=33 },
		["Elthengels"] = { c=60, t=176, l=-75, s=66, st=24 },
		["Garsfeld"] = { c=60, t=92, l=-75, s=66, st=31 },
		["Hytbold"] = { c=65, t=76, l=-84, s=71.5, st=41, r="R29,Q6" },
		["Snowbourn"] = { c=60, t=128, l=-75, s=66, st=22 },
		["Walstow"] = { c=60, t=146, l=-75, s=66, st=20 },
		}, z="East Rohan", r=2, a="Norcrofts", l="54.8s,57.2w" },
	["Eaworth"] = { t=11, ml=60, td="R27", ql=80, d={
		["Cliving"] = { c=60, t=181, l=-75, s=66, st=32 },
		["Garsfeld"] = { c=60, t=130, l=-75, s=66, st=34 },
		["Harwick"] = { c=60, t=380, l=-75, s=66, st=25 },
		["Hytbold"] = { c=65, t=292, l=-84, s=71.5, st=44, r="R31,Q6" },
		["Parth Galen"] = { c=60, t=644, l=-75, s=66, st=22 },
		["Snowbourn"] = { c=60, t=244, l=-75, s=66, st=48 },
		["Thornhope"] = { c=60, t=117, l=-75, s=66, st=27 },
		}, z="East Rohan", r=2, a="Entwash Vale", l="47.7s,63.6w" },
	["Thornhope"] = { t=0, ml=60, td="R27", ql=81, d={
		["Eaworth"] = { c=60, t=117, l=-75, s=66, st=27 },
		}, z="East Rohan", r=2, a="Entwash Vale", l="47.7s,63.6w" },
	["Garsfeld"] = { t=4, ml=60, td="R25", ql=83, d={
		["Eaworth"] = { c=60, t=130, l=-75, s=66, st=34 },
		["Faldham"] = { c=60, t=92, l=-75, s=66, st=31 },
		["Hytbold"] = { c=65, t=166, l=-84, s=71.5, st=42, r="R30,Q6" },
		["Snowbourn"] = { c=60, t=116, l=-75, s=66, st=46 },
		["Walstow"] = { c=60, t=288, l=-75, s=66, st=24 },
		}, z="East Rohan", r=2, a="Sutcrofts", l="54.7s,61.8w" },
	["Hytbold"] = { t=1, ml=60, vr="Q6", td="R25", ql=85, d={
		["Cliving"] = { c=65, t=300, l=-84, s=71.5, st=48, r="R29,Q6" },
		["Elthengels"] = { c=65, t=248, l=-84, s=71.5, st=39, r="R29,Q6" },
		["Eaworth"] = { c=65, t=292, l=-84, s=71.5, st=44, r="R31,Q6" },
		["Faldham"] = { c=65, t=76, l=-84, s=71.5, st=41, r="R29,Q6" },
		["Garsfeld"] = { c=65, t=166, l=-84, s=71.5, st=42, r="R30,Q6" },
		["Harwick"] = { c=65, t=492, l=-84, s=71.5, st=42, r="R28,Q6" },
		["Snowbourn"] = { c=65, t=200, l=-84, s=71.5, st=34, r="R30,Q6" },
		["Walstow"] = { c=65, t=120, l=-84, s=71.5, st=34, r="R30,Q6" },
		}, z="East Rohan", r=2, a="Sutcrofts", l="57.3s,55.4w" },
	["Snowbourn"] = { t=12, ml=60, td="R25", ql=84, d={
		["South Bree"] = { l=-75, s=71.5, st=42 },
		["Stangard"] = { l=-75, s=71.5, st=19 },
		["Inner Caras Galadhon"] = { l=-75, s=71.5, st=40 },
		["Twenty-first Hall"] = { l=-75, s=71.5, st=40 },
		["Cliving"] = { c=60, t=354, l=-75, s=66, st=33 },
		["Eaworth"] = { c=60, t=246, l=-75, s=66, st=48 },
		["Faldham"] = { c=60, t=128, l=-75, s=66, st=22 },
		["Garsfeld"] = { c=60, t=116, l=-75, s=66, st=46 },
		["Harwick"] = { c=60, t=546, l=-75, s=66, st=24 },
		["Hytbold"] = { c=65, t=200, l=-84, s=71.5, st=34, r="R30,Q6" },
		["Parth Galen"] = { c=60, t=327, l=-75, s=66, st=22 },
		["Walstow"] = { c=60, t=143, l=-75, s=66, st=14 },
		["Entwade"] = { c=60, t=128, l=-85, s=66, st=38 },
		["Forlaw"] = { l=75, s=71.5, st=40 },
		["Hultvis"] = { l=90, s=122, st=26 },
		}, z="East Rohan", r=2, a="Sutcrofts", l="60.5s,61.3w" },
	["Walstow"] = { t=20, ml=60, td="R25", ql=84, d={
		["Faldham"] = { c=60, t=146, l=-75, s=66, st=20 },
		["Garsfeld"] = { c=60, t=288, l=-75, s=66, st=24 },
		["Hytbold"] = { c=65, t=120, l=-84, s=71.5, st=34, r="R30,Q6" },
		["Parth Galen"] = { c=60, t=194, l=-75, s=66, st=19 },
		["Snowbourn"] = { c=60, t=143, l=-75, s=66, st=14 },
		}, z="East Rohan", r=2, a="Sutcrofts", l="61.9s,54.4w" },
	-- the Wildermore locations start here
	["Cerdic's Camp"] = { t=4, ml=70, ql=85, d={ -- td="R32"
		["Forlaw"] = { c=60, t=190, l=-75, s=66, st=21 },
		["Byre Tor"] = { c=60, t=150, l=-75, s=66, st=20 },
		["Dunfast's Refugees"] = { c=60, t=160, l=-75, s=66, st=20 },
		}, z="Wildermore", r=2, l="35.4s,69.9w" },
	["Forlaw"] = { t=3, ml=70, ql=85, d={ -- td="R32"
		["South Bree"] = { l=-75, s=71.5, st=19 },
		["Twenty-first Hall"] = { l=-75, s=71.5, st=16 },
		["Harwick"] = { l=-75, s=71.5, st=25 },
		["Snowbourn"] = { l=-75, s=71.5, st=40 },
		["Cerdic's Camp"] = { c=60, t=190, l=-75, s=66, st=21 },
		["Byre Tor"] = { c=60, t=174, l=-75, s=66, st=11 },
		["Dunfast's Refugees"] = { c=60, t=125, l=-75, s=66, st=13 },
		["Scylfig"] = { c=60, t=142, l=-75, s=66, st=15 },
		}, z="Wildermore", r=2, l="39.4s,60.9w" },
	["Byre Tor"] = { td="R32", ql=85, d={
		["Cerdic's Camp"] = { c=60, t=150, l=-75, s=66, st=20 },
		["Forlaw"] = { c=60, t=174, l=-75, s=66, st=11 },
		["Dunfast's Refugees"] = { c=60, t=160, l=-75, s=66, st=12 },
		}, z="Wildermore", r=2, l="33.0s,66.6w" },
	["Dunfast's Refugees"] = { td="R32", ql=85, d={
		["Cerdic's Camp"] = { c=60, t=160, l=-75, s=66, st=20 },
		["Forlaw"] = { c=60, t=125, l=-75, s=66, st=13 },
		["Byre Tor"] = { c=60, t=160, l=-75, s=66, st=12 },
		}, z="Wildermore", r=2, l="38.7s,67.2w" },
	["Scylfig"] = { t=5, ml=70, ql=85, d={ -- td="R32"
		["Harwick"] = { c=60, t=221, l=-75, s=71.5, st=22 },
		["Forlaw"] = { c=60, t=142, l=-75, s=66, st=15 },
		}, z="Wildermore", r=2, l="33.7s,60.2w" },
	-- West Rohan starts here
	["Aldburg"] = { t=1, ml=70, td="R33", ql=88, d={
		["Osgiliath"] = { l=90, s=122, st=22 },
		["South Bree"] = { l=75, s=71.5, st=24 },
		["Ost Rimmon"] = { l=85, s=115, st=35 },
		["Magh Ashtu"] = { l=90, s=122, st=35 },
		["Twenty-first Hall"] = { l=75, s=71.5, st=29 },
		["Minas Tirith"] = { s=115, l=90, st=30 },
		["Beaconwatch"] = { c=60, t=302, l=-85, s=66, st=30 },
		["Edoras"] = { c=60, t=331, l=-85, s=66, st=25 },
		["Fenmarch"] = { c=60, t=156, l=-85, s=66, st=33 },
		["Helm's Deep"] = { c=60, t=631, l=-85, s=66, st=28 },
		["Isengard"] = { l=85, s=66, st=21 },
		["Eastfold Hills Homesteads"] = { c=60, t=194, l=-85, s=24, st=20 },
		["Kingstead Meadows Homesteads"] = { c=60, t=290, l=-85, s=66, st=64 },
		["Stoke"] = { c=60, t=492, l=-85, s=66, st=26 },
		["Woodhurst"] = { c=60, t=572, l=-85, s=66, st=21 },
		["Dale"] = { l=90, s=122, st=24 },
		["Jarnfast"] = { l=90, s=122, st=28 },
		["Skarhald"] = { l=90, s=122, st=28 },
		["Dol Amroth"] = { l=90, s=115, st=30 },
		}, z="West Rohan", r=2, a="Eastfold", l="68.7s,63.9w" },
	["Eastfold Hills Homesteads"] = { td="R33", d={
		["Aldburg"] = { c=60, t=194, l=-85, s=66, st=20 },
		["Edoras"] = { c=60, t=188, l=-85, s=24, st=18 },
		}, z="West Rohan", r=2, a="Eastfold", l="63.6s,68.2w" },
	["Fenmarch"] = { t=13, ml=70, td="R33", ql=88, d={--
		["Aldburg"] = { c=60, t=156, l=-85, s=66, st=33 },
		["Beaconwatch"] = { c=60, t=87, l=-85, s=66, st=36 },
		}, z="West Rohan", r=2, a="Eastfold", l="66.5s,57.8w" },
	["Beaconwatch"] = { t=10, ml=70, td="R33", ql=89, d={--
		["Aldburg"] = { c=60, t=302, l=-85, s=66, st=30 },
		["Fenmarch"] = { c=60, t=87, l=-85, s=66, st=36 },
		}, z="West Rohan", r=2, a="Eastfold", l="69.6s,57.4w" },
	["Brockbridge"] = { t=1, ml=70, td="R34", ql=92, d={--
		["Gapholt"] = { c=60, t=211, l=-85, s=66, st=18 },
		["Woodhurst"] = { c=60, t=62, l=-85, s=66, st=17 },
		}, z="West Rohan", r=2, a="Stonedeans", l="50.8s,77.7w" },
	["Derndingle"] = { ql=92, d={--
		["Woodhurst"] = { mt=180 },
		}, z="West Rohan", r=2, a="Entwood", l="42.1s,79.1w" },
	["Edoras"] = { t=4, ml=70, td="R33", ql=86, d={--
		["Lond Cirion"] = { l=130, s=180, st=21 },
		["Minas Tirith(M)"] = { s=1, st=32, S0=true },
		["Zidir-nesad"] = { l=130, s=161.35, st=22 },
		["Linhir(KG)"] = { s=162.25, l=130, st=24 },
		["Pelargir East Gate"] = { s=162.25, l=130, st=19 },
		["Pelargir West Gate"] = { s=162.25, l=130, st=18 },
		["Aldburg"] = { c=60, t=331, l=-85, s=66, st=25 },
		["Entwade"] = { c=60, t=236, l=-85, s=66, st=25 },
		["Helm's Deep"] = { c=60, t=319, l=-85, s=66, st=27 },
		["Eastfold Hills Homesteads"] = { c=60, t=188, l=-85, s=24, st=18 },
		["Kingstead Meadows Homesteads"] = { c=60, t=178, l=-85, s=58, st=56 },
		["Middlemead"] = { c=60, t=343, l=-85, s=66, st=21 },
		["Stoke"] = { c=60, t=421, l=-85, s=66, st=22 },
		["Underharrow"] = { c=60, t=143, l=-85, s=66, st=20 },
		["Woodhurst"] = { c=60, t=337, l=-85, s=66, st=19 },
		}, z="West Rohan", r=2, a="Kingstead", l="60.8s,74.3w" },
	["Kingstead Meadows Homesteads"] = { td="R33", d={
		["Aldburg"] = { c=60, t=290, l=-85, s=66, st=64 },
		["Edoras"] = { c=60, t=178, l=-85, s=58, st=56 },
		}, z="West Rohan", r=2, a="Kingstead", l="59.0s,67.5w" },
	["Entwade"] = { t=4, ml=70, td="R33", ql=86, d={--
		["Edoras"] = { c=60, t=236, l=-85, s=66, st=25 },
		["Middlemead"] = { c=60, t=132, l=-85, s=66, st=24 },
		["Underharrow"] = { c=60, t=354, l=-85, s=66, st=23 },
		["Snowbourn"] = { c=60, t=128, l=75, s=66, st=38 },
		}, z="West Rohan", r=2, a="Kingstead", l="56.0s,65.8w" },
	["Gapholt"] = { t=13, ml=70, td="R34", ql=92, d={--
		["Brockbridge"] = { c=60, t=211, l=-85, s=66, st=18 },
		["Woodhurst"] = { c=60, t=150, l=-85, s=66, st=19 },
		}, z="West Rohan", r=2, a="Stonedeans", l="53.7s,83.7w" },
	["Grimslade"] = { t=5, ml=70, td="R34", ql=94, d={--
		["Helm's Deep"] = { c=60, t=250, l=-85, s=66, st=13 },
		}, z="West Rohan", r=2, a="Westfold", l="62.3s,82.0w" },
	["Helm's Deep"] = { t=48, ml=70, td="R34", ql=94, d={--
		["South Bree"] = { l=75, s=71.5, st=19 },
		["Twenty-first Hall"] = { l=-85, s=71.5, st=23 },
		["Aldburg"] = { c=60, t=631, l=-85, s=66, st=28 },
		["Edoras"] = { c=60, t=319, l=-85, s=66, st=27 },
		["Grimslade"] = { c=60, t=250, l=-85, s=66, st=13 },
		["Isengard"] = { l=-85, s=66, st=16 },
		["Stoke"] = { c=60, t=547, l=-85, s=66, st=23 },
		["Woodhurst"] = { c=60, t=285, l=-85, s=66, st=15 },
		}, z="West Rohan", r=2, a="Helm's Deep", l="61.4s,88.8w" },
	["Isengard"] = { t=0, ml=70, td="R34", ql=75, d={--
		["Aldburg"] = { l=85, s=66, st=21 },
		["Helm's Deep"] = { l=85, s=66, st=16 },
		}, z="West Rohan", r=2, a="Nan Curunir", l="47.7s,89.7w" },
	["Middlemead"] = { t=13, ml=70, td="R33", ql=86, d={--
		["Edoras"] = { c=60, t=343, l=-85, s=66, st=21 },
		["Entwade"] = { c=60, t=132, l=-85, s=66, st=24 },
		["Underharrow"] = { c=60, t=463, l=-85, s=66, st=18 },
		}, z="West Rohan", r=2, a="Kingstead", l="53.7s,72.5w" },
	["Oserley"] = { t=21, ml=70, td="R33", ql=89, d={--
		["Stoke"] = { c=60, t=77, l=-85, s=66, st=17 },
		}, z="West Rohan", r=2, a="Broadacres", l="45.9s,67.0w" },
	["Stoke"] = { t=6, ml=70, td="R33", ql=90, d={--
		["Aldburg"] = { c=60, t=492, l=-85, s=66, st=26 },
		["Edoras"] = { c=60, t=421, l=-85, s=66, st=22 },
		["Helm's Deep"] = { c=60, t=547, l=-85, s=66, st=23 },
		["Oserley"] = { c=60, t=77, l=-85, s=66, st=17 },
		["Woodhurst"] = { c=60, t=200, l=-85, s=66, st=18 },
		}, z="West Rohan", r=2, a="Broadacres", l="49.3s,69.6w" },
	["Underharrow"] = { t=1, ml=70, td="R33", ql=87, d={
		["Edoras"] = { c=60, t=143, l=-85, s=66, st=20 },
		["Entwade"] = { c=60, t=354, l=-85, s=66, st=23 },
		["Middlemead"] = { c=60, t=463, l=-85, s=66, st=18 },
		["Morlad"] = { l=90, s=115, st=20 },
		}, z="West Rohan", r=2, a="Kingstead", l="67.3s,73.7w" },
	["Woodhurst"] = { t=1, ml=70, td="R34", ql=91, d={ --
		["Aldburg"] = { c=60, t=572, l=-85, s=66, st=21 },
		["Brockbridge"] = { c=60, t=62, l=-85, s=66, st=17 },
		["Derndingle"] = { mt=180 },
		["Edoras"] = { c=60, t=337, l=-85, s=66, st=19 },
		["Gapholt"] = { c=60, t=150, l=-85, s=66, st=19 },
		["Helm's Deep"] = { c=60, t=285, l=-85, s=66, st=15 },
		["Stoke"] = { c=60, t=200, l=-85, s=66, st=18 },
		}, z="West Rohan", r=2, a="Stonedeans", l="47.6s,79.1w" },
	-- Strongholds of the North
	["Dale"] = { t=30, ml=90, td="R41", ql=115, d={
		["South Bree"] = { l=90, s=122, st=17 },
		["Galtrev"] = { l=90, s=122, st=16 },
		["Twenty-first Hall"] = { l=90, s=122, st=18 },
		["Minas Tirith"] = { l=90, s=122, st=24 },
		["Aldburg"] = { l=90, s=122, st=24 },
		["Erebor"] = { c=85, t=116, l=-90, s=93.5, st=16 },
		["Felegoth"] = { c=85, t=426, l=-90, s=93.5, st=11 },
		["Lake-town"] = { c=85, t=127, l=-90, s=93.5, st=12 },
		["Tham Taerdol"] = { c=85, t=636, l=-90, s=93.5, st=11 },
		["Dom Goru"] = { c=85, t=307, l=-90, s=93.5, st=35 },
		["Hammerstead"] = { c=85, t=360, l=-90, s=93.5, st=13 },
		["Jarnfast"] = { c=85, t=407, l=-90, s=93.5, st=20 },
		["Skald's Drop"] = { c=85, t=268, l=-90, s=93.5, st=26 },
		["Skarhald"] = { c=85, t=462, l=-90, s=93.5, st=26 },
		["Dol Amroth"] = { l=90, s=122, st=22 },
		}, z="Strongholds", r=2, a="The Dale-lands", l="24.0n,26.1w" },
	["Erebor"] = { t=1, ml=90, td="R41", ql=115, d={
		["Erebor(R)"] = { mt=7 },
		["Lond Cirion"] = { l=130, s=180, st=16 },
		["Minas Tirith(M)"] = { s=1, st=28, S0=true },
		["Annak-khurfu"] = { s=147.5, l=115, st=32 },
		["Zidir-nesad"] = { l=130, s=161.35, st=17 },
		["Linhir(KG)"] = { s=162.25, l=130, st=23 },
		["Pelargir East Gate"] = { s=162.25, l=130, st=17 },
		["Pelargir West Gate"] = { s=162.25, l=130, st=15 },
		["Dale"] = { c=85, t=116, l=-90, s=93.5, st=16 },
		["Felegoth"] = { c=85, t=518, l=-90, s=93.5, st=12 },
		["Lake-town"] = { c=85, t=237, l=-90, s=93.5, st=13 },
		["Tham Taerdol"] = { c=85, t=746, l=-90, s=93.5, st=12 },
		["Dom Goru"] = { c=85, t=338, l=-90, s=93.5, st=23 },
		["Hammerstead"] = { c=85, t=252, l=-90, s=93.5, st=19 },
		["Jarnfast"] = { c=85, t=510, l=-90, s=93.5, st=22 },
		["Skald's Drop"] = { c=85, t=372, l=-90, s=93.5, st=12 },
		["Skarhald"] = { c=85, t=494, l=-90, s=93.5, st=22 },
		["Hultvis"] = { l=90, s=122, st=16 },
		}, z="Strongholds", r=2, a="The Dale-lands", l="29.0n,25.7w" },
	["Erebor(R)"] = { ql=115, d={
		["Annak-khurfu(I)"] = { l=20, s=1, st=5, S0=true },
		["Akraz-zahar(I)"] = { l=20, s=1, st=5, S0=true },
		["Trestlebridge"] = { l=20, s=1, st=3, S0=true },
		["Steepset"] = { l=20, s=1, st=3, S0=true },
		}, z="Strongholds", r=2, a="The Dale-lands", l="28.9n,25.5w" },
	["Abodes of Erebor"] = { z="Strongholds", r=2, a="Erebor", l="13.7n,137.3w" },
	["Akraz-zahar(I)"] = { t=17, ml=5, ql=130, d={
		["Annak-khurfu(I)"] = { l=20, s=1, st=3, S0=true },
		["Trestlebridge(R)"] = { l=20, s=1, st=3, S0=true },
		["Steepset"] = { l=20, s=1, st=3, S0=true },
		["Gabilthurkhu"] = { mt=9 },
		}, z="Strongholds", a="Erebor", r=2, l="14.7n,136.1w"},
	["Felegoth"] = { t=3, ml=90, td="R41", d={
		["Lond Cirion"] = { l=130, s=180, st=15 },
		["Minas Tirith(M)"] = { s=1, st=25, S0=true },
		["Annak-khurfu"] = { s=147.5, l=115, st=29 },
		["Zidir-nesad"] = { l=130, s=161.35, st=16 },
		["Linhir(KG)"] = { s=162.25, l=130, st=23 },
		["Pelargir East Gate"] = { s=162.25, l=130, st=17 },
		["Pelargir West Gate"] = { s=162.25, l=130, st=15 },
		["Dale"] = { c=85, t=426, l=-90, s=93.5, st=11 },
		["Erebor"] = { c=85, t=518, l=-90, s=93.5, st=12 },
		["Lake-town"] = { c=85, t=290, l=-90, s=93.5, st=12 },
		["Tham Taerdol"] = { c=85, t=344, l=-90, s=93.5, st=12 },
		["Beorninghus"] = { c=25, t=448, l=-90, s=122, st=20 },
		}, z="Strongholds", r=2, a="Eryn Lasgalen", l="20.3n,36.9w" },
	["Lake-town"] = { t=14, ml=90, td="R41", ql=115, d={
		["South Bree"] = { l=90, s=122, st=18 },
		["Dale"] = { c=85, t=127, l=-90, s=93.5, st=12 },
		["Erebor"] = { c=85, t=237, l=-90, s=93.5, st=13 },
		["Felegoth"] = { c=85, t=290, l=-90, s=93.5, st=12 },
		["Tham Taerdol"] = { c=85, t=520, l=-90, s=93.5, st=11 },
		}, z="Strongholds", r=2, a="The Dale-lands", l="17.2n,27.9w" },
	["Tham Taerdol"] = { t=3, ml=90, td="R41", d={
		["Ost Galadh"] = { s=122, l=90, st=18 },
		["Thangulhad"] = { s=122, l=90, st=25 },
		["Dale"] = { c=85, t=636, l=-90, s=93.5, st=11 },
		["Erebor"] = { c=85, t=746, l=-90, s=93.5, st=12 },
		["Felegoth"] = { c=85, t=344, l=-90, s=93.5, st=12 },
		["Lake-town"] = { c=85, t=520, l=-90, s=93.5, st=11 },
		["Ruins of Dol Guldur"] = { l=90, s=0, st=3 },
		}, z="Strongholds", r=2, a="Eryn Lasgalen", l="12.1n,46.1w" },
	["Ruins of Dol Guldur"] = { ql=115, d={
		["Tham Taerdol"] = { l=90, s=0, st=3 },
		}, z="Strongholds", r=2, a="Dol Guldur", l="12.7s,15.1w" },
	-- Dwarf-holds starts here
	["Dom Goru"] = { td="R42", ql=117, d={
		["Dale"] = { c=85, t=307, l=-90, s=93.5,st=35 },
		["Erebor"] = { c=85, t=338, l=-90, s=93.5, st=23 },
		["Hammerstead"] = { c=85, t=668, l=-90, s=93.5, st=21 },
		["Jarnfast"] = { c=85, t=712, l=-90, s=93.5, st=17 },
		["Skald's Drop"] = { c=85, t=575, l=-90, s=93.5, st=20 },
		["Skarhald"] = { c=85, t=175, l=-90, s=93.5, st=23 },
		}, z="Dwarf-holds", r=2, a="Ered Mithrin", l="33.1n,38.6w" },
	["Hammerstead"] = {  t=2, ml=100, td="R42", ql=116, d={
		["Dale"] = { c=85, t=360, l=90, s=122, st=13 },
		["Erebor"] = { c=85, t=252, l=-90, s=93.5, st=19 },
		["Dom Goru"] = { c=85, t=668, l=-90, s=93.5, st=20 },
		["Jarnfast"] = { c=85, t=285, l=-90, s=93.5, st=18 },
		["Skald's Drop"] = { c=85, t=218, l=-90, s=93.5, st=14 },
		["Skarhald"] = { c=85, t=826, l=-90, s=93.5, st=22 },
		}, z="Dwarf-holds", r=2, a="Iron Hills", l="30.9n,12.1w" },
	["Jarnfast"] = { t=2, ml=100, td="R42", ql=116, d={
		["South Bree"] = { l=90, s=122, st=35 },
		["Galtrev"] = { l=90, s=122, st=27 },
		["Twenty-first Hall"] = { l=90, s=122, st=20 },
		["Minas Tirith"] = { l=90, s=122, st=32 },
		["Aldburg"] = { l=90, s=122, st=28 },
		["Dale"] = { c=85, t=407, l=90, s=122, st=20 },
		["Erebor"] = { c=85, t=510, l=-90, s=93.5, st=22 },
		["Dom Goru"] = { c=85, t=712, l=-90, s=93.5, st=17 },
		["Hammerstead"] = { c=85, t=285, l=-90, s=93.5, st=18 },
		["Skald's Drop"] = { c=85, t=263, l=-90, s=93.5, st=15 },
		["Skarhald"] = { c=85, t=870, l=-90, s=93.5, st=30 },
		["Dol Amroth"] = { l=90, s=122, st=26 },
		}, z="Dwarf-holds", r=2, a="Iron Hills", l="28.4n,3.7w" },
	["Skald's Drop"] = { td="R42", ql=116, d={
		["Dale"] = { c=85, t=268, l=90, s=122, st=26 },
		["Erebor"] = { c=85, t=372, l=-90, s=93.5, st=12 },
		["Dom Goru"] = { c=85, t=575, l=-90, s=93.5, st=20 },
		["Hammerstead"] = { c=85, t=218, l=-90, s=93.5, st=14 },
		["Jarnfast"] = { c=85, t=263, l=-90, s=93.5, st=15 },
		["Skarhald"] = { c=85, t=732, l=-90, s=93.5, st=24 },
		}, z="Dwarf-holds", r=2, a="Iron Hills", l="21.2n,15.7w" },
	["Skarhald"] = { t=13, ml=100, td="R42", ql=118, d={
		["Minas Tirith(M)"] = { s=1, st=50 },
		["South Bree"] = { l=10, s=122, st=30 },
		["Galtrev"] = { l=90, s=122, st=27 },
		["Annak-khurfu"] = { c=95, t=358, l=-115, s=147.5, st=37 },
		["Zidir-nesad"] = { l=130, s=161.35, st=22 },
		["Twenty-first Hall"] = { l=90, s=122, st=32 },
		["Minas Tirith"] = { l=90, s=122, st=36 },
		["Aldburg"] = { l=90, s=122, st=28 },
		["Dale"] = { c=85, t=462, l=90, s=122, st=26 },
		["Erebor"] = { c=85, t=494, l=-90, s=93.5, st=22 },
		["Dom Goru"] = { c=85, t=175, l=-90, s=93.5, st=23 },
		["Hammerstead"] = { c=85, t=826, l=-90, s=93.5, st=22 },
		["Jarnfast"] = { c=85, t=870, l=-90, s=93.5, st=30 },
		["Skald's Drop"] = { c=85, t=732, l=-90, s=93.5, st=24 },
		["Hultvis"] = { l=90, s=122, st=21 },
		["Hlithseld"] = { c=95, t=395, l=-115, s=147.5, st=32 },
		["Dol Amroth"] = { l=90, s=122, st=28 },
		}, z="Dwarf-holds", r=2, a="Ered Mithrin", l="34.7n,45.4w" },
	-- West Gondor starts here
	["Calembel"] = { t=35, ml=85, td="R35", ql=98, d={
		["Ethring"] = { c=97.7, t=170, l=-90, s=122, st=25 },
		["Minas Tirith"] = { s=122, l=90, st=28 },
		["Dol Amroth"] = { c=80, t=395, l=-90, s=88, st=25 },
		["Morlad"] = { c=80, t=310, l=-90, s=88, st=19 },
		["Tadrent"] = { c=80, t=245, l=-90, s=88, st=24 },
		}, z="West Gondor", r=3, a="Lamedon", l="67.2s,55.1w" },
	["Dol Amroth"] = { t=10, ml=85, td="R35", ql=99, d={
		["Osgiliath"] = { l=90, s=122, st=22 },
		["South Bree"] = { l=90, s=115, st=24 },
		["East Pelargir"] = { l=90, s=122, st=30 },
		["Ethring"] = { l=90, s=122, st=28 },
		["Linhir"] = { l=90, s=122, st=24 },
		["Ost Anglebed"] = { l=90, s=93.5, st=26 },
		["West Pelargir"] = { l=90, s=122, st=24 },
		["Arnach"] = { l=90, s=122, st=26 },
		["Bar Hurin"] = { l=90, s=122, st=28 },
		["Faramir's Lookout"] = { l=90, s=122, st=26 },
		["Glaniath"] = { l=90, s=122, st=28 },
		["Magh Ashtu"] = { l=90, s=122, st=32 },
		["Twenty-first Hall"] = { l=90, s=115, st=23 },
		["Minas Tirith"] = { s=122, l=90, st=30 },
		["North-Gate"] = { s=122, l=90, st=28 },
		["Aldburg"] = { l=90, s=115, st=30 },
		["Dale"] = { l=90, s=122, st=22 },
		["Jarnfast"] = { l=90, s=122, st=26 },
		["Skarhald"] = { l=90, s=122, st=28 },
		["Calembel"] = { c=80, t=395, l=-90, s=88, st=24 },
		["Morlad"] = { c=80, t=676, l=-90, s=88, st=24 },
		["Tadrent"] = { c=80, t=234, l=-90, s=88, st=26 },
		["Cape of Belfalas"] = { s=0, st=26, n="To the Cape of Belfalas" },
		["Dol Amroth(D)"] = { mt=86 },
		}, z="West Gondor", r=3, a="havens of Belfalas", l="75.5s,72.5w" },
	["Dol Amroth(D)"] = { d={
		["Dol Amroth"] = { mt=86 },
		}, z="West Gondor", r=3, a="havens of Belfalas", l="75.7s,69.8w" },
	["Morlad"] = { t=1, ml=85, td="R35", ql=95, d={
		["Minas Tirith"] = { s=122, l=90, st=29 },
		["Underharrow"] = { l=90, s=115, st=20 },
		["Calembel"] = { c=80, t=310, l=-90, s=88, st=19 },
		["Dol Amroth"] = { c=80, t=676, l=-90, s=88, st=24 },
		["Tadrent"] = { c=80, t=472, l=-90, s=88, st=23 },
		}, z="West Gondor", r=3, a="Blackroot Vale", l="56.9s,67.5w" },
	["Tadrent"] = { t=1, ml=85, td="R35", ql=98, d={
		["Minas Tirith"] = { s=122, l=90, st=34 },
		["Calembel"] = { c=80, t=245, l=-90, s=88, st=24 },
		["Dol Amroth"] = { c=80, t=234, l=-90, s=88, st=26 },
		["Morlad"] = { c=80, t=472, l=-90, s=88, st=23 },
		}, z="West Gondor", r=3, a="havens of Belfalas", l="74.0s,62.4w" },
	["Cape of Belfalas Housing"] = { z="West Gondor", r=3, a="Cape of Belfalas", l="84.3s,69.3w" },
	["Cape of Belfalas"] = { d={
		["Dol Amroth"] = { s=0, st=8, n="Travel to Dol Amroth" },
		}, z="West Gondor", r=3, a="Cape of Belfalas", l="84.1s,69.2w" },
	-- Central Gondor starts here
	["Ethring"] = { t=7, ml=85, td="R36", ql=100, d={
		["Ost Anglebed"] = { c=85, t=437, l=-90, s=93.5, st=22 },
		["West Pelargir"] = { c=85, t=426, l=-90, s=93.5, st=19 },
		["Minas Tirith"] = { s=122, l=90, st=29 },
		["Calembel"] = { c=97.7, t=170, l=-90, s=122, st=25 },
		["Dol Amroth"] = { l=90, s=122, st=28 },
		["Linhir"] = { c=85, t=216, l=-90, s=93.5, st=22 },
		}, z="Central Gondor", r=3, a="Ringlo Vale", l="72.2s,50.1w" },
	["Linhir"] = { t=4, ml=85, td="R36", ql=100, d={
		["Ethring"] = { c=85, t=216, l=-90, s=93.5, st=22 },
		["Ost Anglebed"] = { c=85, t=218, l=-90, s=93.5, st=22 },
		["West Pelargir"] = { c=85, t=212, l=-90, s=93.5, st=19 },
		["Minas Tirith"] = { s=122, l=90, st=29 },
		["Dol Amroth"] = { l=90, s=122, st=24 },
		}, z="Central Gondor", r=3, a="Dor-en-ernil", l="80.8s,45.8w" },
	["Ost Anglebed"] = { t=4, ml=85, td="R36", ql=100, d={
		["Ethring"] = { c=85, t=437, l=-90, s=93.5, st=22 },
		["Linhir"] = { c=85, t=218, l=-90, s=93.5, st=22 },
		["West Pelargir"] = { c=85, t=165, l=-90, s=93.5, st=20 },
		["Minas Tirith"] = { s=122, l=90, st=26 },
		["Dol Amroth"] = { l=90, s=122, st=26 },
		}, z="Central Gondor", r=3, a="Lebennin", l="79.1s,39.0w" },
	["West Pelargir"] = { t=32, ml=85, td="R36", ql=100, d={
		["East Pelargir"] = { c=10, t=108, l=-90, s=50, st=26 },
		["Ethring"] = { c=85, t=426, l=-90, s=93.5, st=19 },
		["Linhir"] = { c=85, t=212, l=-90, s=93.5, st=19 },
		["Ost Anglebed"] = { c=85, t=165, l=-90, s=93.5, st=20 },
		["Minas Tirith"] = { s=122, l=90, st=25 },
		["Calembel"] = { l=90, s=122, st=22 },
		["Dol Amroth"] = { l=90, s=122, st=24 },
		["Morlad"] = { l=90, s=122, st=22 },
		["Tadrent"] = { l=90, s=122, st=25 },
		}, z="Central Gondor", r=3, a="Lebennin", l="83.0s,34.8w" },
	["East Pelargir"] = { t=65, ml=85, td="R36", ql=100, d={
		["West Pelargir"] = { c=10, t=108, l=-90, s=50, st=28 },
		["Arnach"] = { c=85, t=208, l=-90, s=93.5, st=22 },
		["Bar Hurin"] = { l=90, s=93.5, st=24 },
		["Faramir's Lookout"] = { l=90, s=93.5, st=23 },
		["Glaniath"] = { c=85, t=54, l=-90, s=93.5, st=20 },
		["Dol Amroth"] = { l=90, s=122, st=30 },
		["Minas Tirith"] = { l=90, s=122, st=30 },
		["North-Gate"] = { l=90, s=122, st=24 },
		}, z="Central Gondor", r=3, a="Lebennin", l="82.8s,31.6w" },
	-- East Gondor starts here
	["Arnach"] = { t=10, ml=85, td="R37", ql=100, d={
		["Dol Amroth"] = { l=90, s=122, st=26 },
		["East Pelargir"] = { c=85, t=208, l=-90, s=93.5, st=22 },
		["Bar Hurin"] = { l=90, s=93.5, st=25 },
		["Faramir's Lookout"] = { l=90, s=93.5, st=23 },
		["Glaniath"] = { c=85, t=174, l=-90, s=93.5, st=23 },
		["Minas Tirith"] = { l=90, s=122, st=26 },
		}, z="East Gondor", r=3, a="Upper Lebennin", l="76.3s,24.4w" },
	["Bar Hurin"] = { t=4, ml=85, td="R37", ql=100, d={
		["East Pelargir"] = { l=90, s=93.5, st=24 },
		["Arnach"] = { l=90, s=93.5, st=25 },
		["Faramir's Lookout"] = { c=85, t=260, l=-90, s=93.5, st=25 },
		["Glaniath"] = { l=90, s=93.5, st=24 },
		["Minas Tirith"] = { s=122, l=90, st=29 },
		["Dol Amroth"] = { l=90, s=122, st=28 },
		}, z="East Gondor", r=3, a="South Ithilien", l="73.5s,12.2w" },
	["Faramir's Lookout"] = { t=2, ml=85, td="R37", ql=100, d={
		["East Pelargir"] = { l=90, s=93.5, st=23 },
		["Arnach"] = { l=90, s=93.5, st=23 },
		["Bar Hurin"] = { c=85, t=260, l=-90, s=93.5, st=25 },
		["Glaniath"] = { l=90, s=93.5, st=22 },
		["Minas Tirith"] = { s=122, l=90, st=34 },
		["Dol Amroth"] = { l=90, s=122, st=26 },
		}, z="East Gondor", r=3, a="South Ithilien", l="65.0s,6.1w" },
	["Glaniath"] = { t=5, ml=85, td="R37", ql=100, d={
		["East Pelargir"] = { c=85, t=54, l=-90, s=93.5, st=20 },
		["Arnach"] = { c=85, t=174, l=-90, s=93.5, st=23 },
		["Bar Hurin"] = { l=90, s=93.5, st=24 },
		["Faramir's Lookout"] = { l=90, s=93.5, st=22 },
		["Minas Tirith"] = { s=122, l=90, st=30 },
		["Dol Amroth"] = { l=90, s=122, st=28 },
		}, z="East Gondor", r=3, a="Upper Lebennin", l="81.0s,29.8w" },
	-- Old Anorien starts here
	["Minas Tirith"] = { t=11, ml=85, td="R38", ql=100, d={
		["Minas Tirith(M)"] = { s=1, st=38, S0=true },
		["Osgiliath"] = { l=90, s=122, st=30 },
		["South Bree"] = { l=90, s=115, st=30 },
		["East Pelargir"] = { l=90, s=122, st=30 },
		["Ethring"] = { l=90, s=122, st=29 },
		["Linhir"] = { l=90, s=122, st=29 },
		["Ost Anglebed"] = { l=90, s=122, st=26 },
		["West Pelargir"] = { l=90, s=122, st=25 },
		["Arnach"] = { l=90, s=122, st=26 },
		["Bar Hurin"] = { l=90, s=122, st=29 },
		["Faramir's Lookout"] = { l=90, s=122, st=34 },
		["Glaniath"] = { l=90, s=122, st=29 },
		["Ost Rimmon"] = { l=90, s=122.5, st=40 },
		["the War-stead"] = { l=90, s=122, st=34 },
		["Magh Ashtu"] = { l=90, s=122, st=25 },
		["Twenty-first Hall"] = { l=90, s=115, st=30 },
		["Crithost"] = { c=85, t=221, l=-90, s=93.5, st=36 },
		["North-Gate"] = { c=85, t=128, l=-90, s=93.5, st=25 },
		["Aldburg"] = { l=90, s=115, st=30 },
		["Dale"] = { l=90, s=122, st=24 },
		["Calembel"] = { l=90, s=122, st=28 },
		["Dol Amroth"] = { l=90, s=122, st=30 },
		["Morlad"] = { l=90, s=122, st=29 },
		["Tadrent"] = { l=90, s=122, st=34 },
		["Field of Onslaught"] = { s=0, st=8, n="To the Field of Onslaught" },
		["Minas Tirith(AB)"] = { s=0, st=20, n="To Minas Tirith, After the Battle" },
		["Threshold of the City"] = { s=0, st=9, n="To the Threshold of the City" },
		}, z="Old Anorien", r=3, a="Pelennor", l="65.8s,16.8w" },
	["North-Gate"] = { td="R38", ql=100, d={
		["East Pelargir"] = { l=90, s=122, st=24 },
		["Crithost"] = { c=85, t=92, l=-90, s=93.5, st=38 },
		["Minas Tirith"] = { c=85, t=128, l=-90, s=93.5, st=25 },
		["Dol Amroth"] = { l=90, s=122, st=28 },
		}, z="Old Anorien", r=3, a="Pelennor", l="59.5s,17.5w" },
	["Crithost"] = { t=12, ml=85, td="R38", ql=100, d={
		["Minas Tirith"] = { c=85, t=221, l=-90, s=93.5, st=36 },
		["North-Gate"] = { c=85, t=92, l=-90, s=93.5, st=38 },
		}, z="Old Anorien", r=3, a="Pelennor", l="54.7s,16.1w" },
	["Minas Tirith(M)"] = { td="R38", d={ -- Midsummer
		["Minas Tirith(AB)"] = { l=100, s=96, st=28, S0=true },
		["South Bree"] = { s=1, st=31, S0=true },
		["Galtrev"] = { l=55, s=66, st=28, S0=true },
		["Osgiliath"] = { l=100, s=126, st=28, S0=true },
		["Annak-khurfu"] = { s=147.5, l=115, st=39, S0=true },
		["Thorin's Gate"] = { s=1, st=32, S0=true },
		["Zidir-nesad"] = { l=130, s=161.35, st=29 },
		["Caras Galadhon"] = { l=50, s=25, st=9, r="D14", S0=true },
		["Minas Tirith"] = { l=100, s=126, st=25, S0=true },
		["Edoras"] = { l=75, s=66, st=32, S0=true },
		["Erebor"] = { l=100, s=93.5, st=18, S0=true },
		["Felegoth"] = { l=100, s=93.5, st=25, S0=true },
		["Skarhald"] = { l=100, s=126, st=50, S0=true },
		["Michel Delving"] = { s=1, st=28, S0=true },
		["Rivendell Stables"] = { l=25, s=35, st=27 },
		["Beorninghus"] = { l=110, s=147.5, st=34, S0=true },
		}, z="Old Anorien", r=4, a="Pelennor", l="22.4n,53.7w" },
	["Field of Onslaught"] = { ql=105, d={ -- dawn
		["Kings End"] = { s=0, st=6, n="To Kings End" },
		["Minas Tirith"] = { s=0, st=20, n="To Minas Tirith, Before the Battle" },
		["Minas Tirith(AB)"] = { s=0, st=20, n="To Minas Tirith, After the Battle" },
		["Riders' Stand"] = { s=0, st=8, n="To Riders' Stand" },
		["Threshold of the City"] = { s=0, st=9, n="To the Threshold of the City" },
		}, z="Old Anorien", r=3, a="Pelennor Fields", l="27.2n,16.6w" },
	["Kings End"] = { ql=105, d={ -- early morning
		["Riders' Stand"] = { s=0, st=6, n="To Riders' Stand" },
		["Field of Onslaught"] = { s=0, st=8, n="To the Field of Onslaught" },
		}, z="Old Anorien", r=3, a="Pelennor Fields", l="22.3n,14.1w" },
	["Riders' Stand"] = { ql=105, d={ -- late morning
		["Field of Onslaught"] = { s=0, st=7, n="To the Field of Onslaught" },
		["Ruin of Pel Duven"] = { s=0, st=8, n="To the Ruin of Pel Duven" },
		}, z="Old Anorien", r=3, a="Pelennor Fields", l="18.6n,15.2w" },
	["Ruin of Pel Duven"] = { ql=105, d={ -- midday
		["Threshold of the City"] = { s=0, st=8, n="To the Threshold of the City" },
		["Field of Onslaught"] = { s=0, st=8, n="To the Field of Onslaught" },
		}, z="Old Anorien", r=3, a="Pelennor Fields", l="22.3n,14.1w" },
	["Threshold of the City"] = { ql=105, d={ -- afternoon
		["Minas Tirith"] = { s=0, st=20, n="To Minas Tirith, Before the Battle" },
		["Minas Tirith(AB)"] = { s=0, st=20, n="To Minas Tirith, After the Battle" },
		["Field of Onslaught"] = { s=0, st=7, n="To the Field of Onslaught" },
		}, z="Old Anorien", r=3, a="Pelennor Fields", l="22.4n,16.2w" },
	["the War-stead"] = { t=38, ml=85, td="R39", ql=101, d={
		["Ost Rimmon"] = { c=85, t=148, l=-90, s=93.5, st=45 },
		["Minas Tirith"] = { l=-90, s=93.5, st=34 },
		}, z="Far Anorien", r=3, a="Taur Druadan", l="45.1s,29.2w" },
	["Ost Rimmon"] = { t=34, ml=85, td="R39", ql=103, d={
		["the War-stead"] = { c=85, t=148, l=-90, s=93.5, st=45 },
		["Minas Tirith"] = { l=90, s=122, st=40 },
		["Aldburg"] = { l=85, s=115, st=36 },
		}, z="Far Anorien", r=3, a="Beacon Hills", l="46.8s,36.4w" },
	
	-- Mordor starts here --
	-- King's Gondor
	["The Harlond"] = { t=34, ml=85, td="R44", ql=140, d={
		["Minas Tirith"] = { c=95, t=167, l=-90, s=93.5, st=36 },
		["Aethir"] = { c=106, t=462, l=130, s=161.35, st=3 },
		["Arnach(KG)"] = { c=106, t=104, l=130, s=161.35, st=35 },
		["Erynos"] = { c=106, t=422, l=130, s=161.35, st=29 },
		["Furukzahar"] = { c=106, t=600, l=130, s=161.35, st=28 },
		["Glaniath(KG)"] = { c=106, t=231, l=130, s=161.35, st=32 },
		["Halach"] = { c=106, t=216, l=130, s=161.35, st=30 },
		["Imloth Melui"] = { c=106, t=107, l=130, s=161.35, st=30 },
		["Linhir(KG)"] = { c=106, t=534, l=130, s=161.35, st=38 },
		["Malbarth"] = { c=106, t=536, l=130, s=161.35, st=28 },
		["Ost Anglebed(KG)"] = { c=106, t=517, l=130, s=161.35, st=34 },
		["Pelargir East Gate"] = { c=106, t=266, l=130, s=161.35, st=25 },
		["Pelargir West Gate"] = { c=106, t=354, l=130, s=161.35, st=31 },
		["Tumladen"] = { c=106, t=223, l=130, s=161.35, st=38 },
		["Zarsatrad"] = { c=106, t=490, l=130, s=161.35, st=35 },
		}, z="King's Gondor", a="Lossarnach", r=4, l="72.6s,19.9w" },
	["The Harlond(B)"] = { d={
		["The Harlond"] = { mt=21 },
		}, z="King's Gondor", a="Lossarnach", r=4, l="73.3s,19.8w" },
	["Imloth Melui"] = { t=17, ml=115, td="R44", ql=140, d={
		["Aethir"] = { c=106, t=454, l=130, s=161.35, st=20 },
		["Arnach(KG)"] = { c=106, t=48, l=130, s=161.35, st=18 },
		["Erynos"] = { c=106, t=420, l=130, s=161.35, st=15 },
		["Furukzahar"] = { c=106, t=604, l=130, s=161.35, st=27 },
		["Glaniath(KG)"] = { c=106, t=223, l=130, s=161.35, st=18 },
		["Halach"] = { c=106, t=206, l=130, s=161.35, st=18 },
		["Linhir(KG)"] = { c=106, t=521, l=130, s=161.35, st=27 },
		["Malbarth"] = { c=106, t=520, l=130, s=161.35, st=15 },
		["Ost Anglebed(KG)"] = { c=106, t=518, l=130, s=161.35, st=20 },
		["Pelargir East Gate"] = { c=106, t=259, l=130, s=161.35, st=16 },
		["Pelargir West Gate"] = { c=106, t=348, l=130, s=161.35, st=20 },
		["The Harlond"] = { c=106, t=107, l=130, s=161.35, st=30 },
		["Tumladen"] = { c=106, t=167, l=130, s=161.35, st=23 },
		["Zarsatrad"] = { c=106, t=538, l=130, s=161.35, st=22 },
		}, z="King's Gondor", a="Lossarnach", r=4, l="74.0s,23.5w" },
	["Arnach(KG)"] = { t=7, ml=115, td="R44", ql=140, d={
		["Aethir"] = { c=106, t=402, l=130, s=161.35, st=19 },
		["Halach"] = { c=106, t=153, l=130, s=161.35, st=15 },
		["Erynos"] = { c=106, t=370, l=130, s=161.35, st=12 },
		["Furukzahar"] = { c=106, t=551, l=130, s=161.35, st=13 },
		["Glaniath(KG)"] = { c=106, t=190, l=130, s=161.35, st=14 },
		["Imloth Melui"] = { c=106, t=48, l=130, s=161.35, st=18 },
		["Linhir(KG)"] = { c=106, t=500, l=130, s=161.35, st=21 },
		["Malbarth"] = { c=106, t=472, l=130, s=161.35, st=15 },
		["Ost Anglebed(KG)"] = { c=106, t=461, l=130, s=161.35, st=16 },
		["Pelargir East Gate"] = { c=106, t=205, l=130, s=161.35, st=14 },
		["Pelargir West Gate"] = { c=106, t=294, l=130, s=161.35, st=16 },
		["The Harlond"] = { c=106, t=104, l=130, s=161.35, st=35 },
		["Tumladen"] = { c=106, t=121, l=130, s=161.35, st=20 },
		["Zarsatrad"] = { c=106, t=424, l=130, s=161.35, st=18 },
		}, z="King's Gondor", a="Lossarnach", r=4, l="76.3s,24.3w" },
	["Tumladen"] = { t=7, ml=115, td="R44", ql=140, d={
		["Aethir"] = { c=106, t=330, l=130, s=161.35, st=25 },
		["Arnach(KG)"] = { c=106, t=121, l=130, s=161.35, st=20 },
		["Erynos"] = { c=106, t=292, l=130, s=161.35, st=21 },
		["Furukzahar"] = { c=106, t=470, l=130, s=161.35, st=22 },
		["Glaniath(KG)"] = { c=106, t=101, l=130, s=161.35, st=37 },
		["Halach"] = { c=106, t=115, l=130, s=161.35, st=23 },
		["Imloth Melui"] = { c=106, t=167, l=130, s=161.35, st=23 },
		["Linhir(KG)"] = { c=106, t=395, l=130, s=161.35, st=37 },
		["Malbarth"] = { c=106, t=395, l=130, s=161.35, st=23 },
		["Ost Anglebed(KG)"] = { c=106, t=386, l=130, s=161.35, st=26 },
		["Pelargir East Gate"] = { c=106, t=127, l=130, s=161.35, st=24 },
		["Pelargir West Gate"] = { c=106, t=221, l=130, s=161.35, st=23 },
		["The Harlond"] = { c=106, t=223, l=130, s=161.35, st=38 },
		["Zarsatrad"] = { c=106, t=350, l=130, s=161.35, st=28 },
		}, z="King's Gondor", a="Upper Lebennin", r=4, l="77.3s,28.8w" },
	["Halach"] = { t=4, ml=115, td="R44", ql=140, d={
		["Aethir"] = { c=106, t=307, l=130, s=161.35, st=22 },
		["Arnach(KG)"] = { c=106, t=153, l=130, s=161.35, st=15 },
		["Erynos"] = { c=106, t=264, l=130, s=161.35, st=17 },
		["Furukzahar"] = { c=106, t=452, l=130, s=161.35, st=20 },
		["Glaniath(KG)"] = { c=106, t=72, l=130, s=161.35, st=19 },
		["Imloth Melui"] = { c=106, t=206, l=130, s=161.35, st=18 },
		["Linhir(KG)"] = { c=106, t=371, l=130, s=161.35, st=27 },
		["Malbarth"] = { c=106, t=374, l=130, s=161.35, st=18 },
		["Ost Anglebed(KG)"] = { c=106, t=358, l=130, s=161.35, st=22 },
		["Pelargir East Gate"] = { c=106, t=106, l=130, s=161.35, st=18 },
		["Pelargir West Gate"] = { c=106, t=196, l=130, s=161.35, st=19 },
		["The Harlond"] = { c=106, t=216, l=130, s=161.35, st=30 },
		["Tumladen"] = { c=106, t=115, l=130, s=161.35, st=23 },
		["Zarsatrad"] = { c=106, t=320, l=130, s=161.35, st=23 },
		}, z="King's Gondor", a="Upper Lebennin", r=4, l="81.6s,26.6w" },
	["Glaniath(KG)"] = { t=6, ml=115, td="R44", ql=140, d={
		["Aethir"] = { c=106, t=250, l=130, s=161.35, st=21 },
		["Arnach(KG)"] = { c=106, t=190, l=130, s=161.35, st=14 },
		["Erynos"] = { c=106, t=217, l=130, s=161.35, st=16 },
		["Furukzahar"] = { c=106, t=390, l=130, s=161.35, st=18 },
		["Halach"] = { c=106, t=72, l=130, s=161.35, st=19 },
		["Imloth Melui"] = { c=106, t=223, l=130, s=161.35, st=18 },
		["Linhir(KG)"] = { c=106, t=320, l=130, s=161.35, st=26 },
		["Malbarth"] = { c=106, t=316, l=130, s=161.35, st=18 },
		["Ost Anglebed(KG)"] = { c=106, t=306, l=130, s=161.35, st=20 },
		["Pelargir East Gate"] = { c=106, t=53, l=130, s=161.35, st=18 },
		["Pelargir West Gate"] = { c=106, t=143, l=130, s=161.35, st=22 },
		["The Harlond"] = { c=106, t=231, l=130, s=161.35, st=32 },
		["Tumladen"] = { c=106, t=101, l=130, s=161.35, st=37 },
		["Zarsatrad"] = { c=106, t=265, l=130, s=161.35, st=23 },
		}, z="King's Gondor", a="Upper Lebennin", r=4, l="80.9s,29.8w" },
	["Pelargir East Gate"] = { t=10, ml=5, td="R44", ql=140, d={
		["Minas Tirith"] = { l=95, s=93.5, st=24 },
		["South Bree"] = { s=5, st=18 },
		["Galtrev"] = { l=35, s=35, st=19 },
		["Aethir"] = { c=106, t=198, l=130, s=161.35, st=25 },
		["Arnach(KG)"] = { c=106, t=205, l=130, s=161.35, st=14 },
		["Erynos"] = { c=106, t=165, l=130, s=161.35, st=18 },
		["Furukzahar"] = { c=106, t=347, l=130, s=161.35, st=20 },
		["Glaniath(KG)"] = { c=106, t=53, l=130, s=161.35, st=18 },
		["Halach"] = { c=106, t=106, l=130, s=161.35, st=17 },
		["Imloth Melui"] = { c=106, t=259, l=130, s=161.35, st=16 },
		["Linhir(KG)"] = { c=106, t=265, l=130, s=161.35, st=28 },
		["Malbarth"] = { c=106, t=271, l=130, s=161.35, st=19 },
		["Ost Anglebed(KG)"] = { c=106, t=253, l=130, s=161.35, st=24 },
		["Pelargir West Gate"] = { c=106, t=91, l=130, s=161.35, st=19 },
		["The Harlond"] = { c=106, t=266, l=130, s=161.35, st=25 },
		["Tumladen"] = { c=106, t=127, l=130, s=161.35, st=24 },
		["Zarsatrad"] = { c=106, t=222, l=130, s=161.35, st=24 },
		["Twenty-first Hall"] = { l=40, s=45, st=17 },
		["Edoras"] = { l=75, s=66, st=19 },
		["Erebor"] = { l=105, s=93.5, st=15 },
		["Felegoth"] = { l=105, s=93.5, st=14 },
		["Rivendell Stables"] = { l=25, s=25, st=18 },
		}, z="King's Gondor", a="Pelargir", r=4, l="80.9s,29.8w" },
	["Pelargir West Gate"] = { t=8, ml=5, td="R44", ql=140, d={
		["Lond Cirion"] = { l=130, s=180, st=22 },
		["Minas Tirith"] = { l=95, s=93.5, st=22 },
		["South Bree"] = { s=5, st=18 },
		["Galtrev"] = { l=35, s=35, st=18 },
		["Aethir"] = { c=106, t=109, l=130, s=161.35, st=25 },
		["Arnach(KG)"] = { c=106, t=294, l=130, s=161.35, st=16 },
		["Erynos"] = { c=106, t=70, l=130, s=161.35, st=19 },
		["Furukzahar"] = { c=106, t=324, l=130, s=161.35, st=21 },
		["Glaniath(KG)"] = { c=106, t=143, l=130, s=161.35, st=22 },
		["Halach"] = { c=106, t=196, l=130, s=161.35, st=19 },
		["Imloth Melui"] = { c=106, t=348, l=130, s=161.35, st=20 },
		["Linhir(KG)"] = { c=106, t=172, l=130, s=161.35, st=29 },
		["Malbarth"] = { c=106, t=176, l=130, s=161.35, st=20 },
		["Ost Anglebed(KG)"] = { c=106, t=165, l=130, s=161.35, st=24 },
		["Pelargir East Gate"] = { c=106, t=91, l=130, s=161.35, st=19 },
		["The Harlond"] = { c=106, t=354, l=130, s=161.35, st=31 },
		["Tumladen"] = { c=106, t=221, l=130, s=161.35, st=23 },
		["Zarsatrad"] = { c=106, t=127, l=130, s=161.35, st=26 },
		["Twenty-first Hall"] = { l=40, s=45, st=15 },
		["Edoras"] = { l=75, s=66, st=18 },
		["Erebor"] = { l=105, s=93.5, st=14 },
		["Felegoth"] = { l=105, s=93.5, st=13 },
		["Rivendell Stables"] = { l=25, s=25, st=18 },
		["Pelargir(B)"] = { mt=46},
		}, z="King's Gondor", a="Pelargir", r=4, l="83.0s,34.8w" },
	["Pelargir(B)"] = { t=6, ml=115, td="R44", d={
		["Lond Cirion(B)"] = { l=135, s=180, st=6 },
		["Dol Amroth(B)"] = { l=135, s=180, st=6 },
		["Halrax(B)"] = { l=135, s=180, st=8 },
		["Umbar Baharbel(B)"] = { l=135, s=180, st=8 },
		["Pelargir West Gate"] = { mt=46},
		}, z="King's Gondor", a="Pelargir", r=4, l="20.5s,98.4w" },
	["Erynos"] = { t=7, ml=115, td="R44", ql=140, d={
		["Aethir"] = { c=106, t=158, l=130, s=161.35, st=19 },
		["Arnach(KG)"] = { c=106, t=370, l=130, s=161.35, st=12 },
		["Furukzahar"] = { c=106, t=189, l=130, s=161.35, st=15 },
		["Glaniath(KG)"] = { c=106, t=217, l=130, s=161.35, st=16 },
		["Halach"] = { c=106, t=264, l=130, s=161.35, st=17 },
		["Imloth Melui"] = { c=106, t=420, l=130, s=161.35, st=15 },
		["Linhir(KG)"] = { c=106, t=222, l=130, s=161.35, st=24 },
		["Malbarth"] = { c=106, t=222, l=130, s=161.35, st=14 },
		["Ost Anglebed(KG)"] = { c=106, t=210, l=130, s=161.35, st=19 },
		["Pelargir East Gate"] = { c=106, t=165, l=130, s=161.35, st=18 },
		["Pelargir West Gate"] = { c=106, t=70, l=130, s=161.35, st=19 },
		["The Harlond"] = { c=106, t=422, l=130, s=161.35, st=29 },
		["Tumladen"] = { c=106, t=292, l=130, s=161.35, st=21 },
		["Zarsatrad"] = { c=106, t=69, l=130, s=161.35, st=20 },
		}, z="King's Gondor", a="Lower Lebennin", r=4, l="80.3s,32.7w" },
	["Zarsatrad"] = { t=5, ml=115, td="R44", ql=140, d={
		["Aethir"] = { c=106, t=211, l=130, s=161.35, st=25 },
		["Arnach(KG)"] = { c=106, t=424, l=130, s=161.35, st=18 },
		["Erynos"] = { c=106, t=69, l=130, s=161.35, st=20 },
		["Furukzahar"] = { c=106, t=129, l=130, s=161.35, st=20 },
		["Glaniath(KG)"] = { c=106, t=265, l=130, s=161.35, st=23 },
		["Halach"] = { c=106, t=320, l=130, s=161.35, st=23 },
		["Imloth Melui"] = { c=106, t=538, l=130, s=161.35, st=22 },
		["Linhir(KG)"] = { c=106, t=276, l=130, s=161.35, st=29 },
		["Malbarth"] = { c=106, t=278, l=130, s=161.35, st=22 },
		["Ost Anglebed(KG)"] = { c=106, t=267, l=130, s=161.35, st=26 },
		["Pelargir East Gate"] = { c=106, t=222, l=130, s=161.35, st=24 },
		["Pelargir West Gate"] = { c=106, t=127, l=130, s=161.35, st=26 },
		["The Harlond"] = { c=106, t=490, l=130, s=161.35, st=35 },
		["Tumladen"] = { c=106, t=350, l=130, s=161.35, st=28 },
		}, z="King's Gondor", a="Lower Lebennin", r=4, l="77.8s,34.5w" },
	["Furukzahar"] = { t=3, ml=115, td="R44", ql=141, d={
		["Aethir"] = { c=106, t=333, l=130, s=161.35, st=20 },
		["Arnach(KG)"] = { c=106, t=551, l=130, s=161.35, st=13 },
		["Erynos"] = { c=106, t=189, l=130, s=161.35, st=15 },
		["Glaniath(KG)"] = { c=106, t=390, l=130, s=161.35, st=18 },
		["Halach"] = { c=106, t=452, l=130, s=161.35, st=20 },
		["Imloth Melui"] = { c=106, t=604, l=130, s=161.35, st=27 },
		["Linhir(KG)"] = { c=106, t=403, l=130, s=161.35, st=24 },
		["Malbarth"] = { c=106, t=401, l=130, s=161.35, st=16 },
		["Ost Anglebed(KG)"] = { c=106, t=388, l=130, s=161.35, st=20 },
		["Pelargir East Gate"] = { c=106, t=347, l=130, s=161.35, st=20 },
		["Pelargir West Gate"] = { c=106, t=324, l=130, s=161.35, st=21 },
		["The Harlond"] = { c=106, t=600, l=130, s=161.35, st=28 },
		["Tumladen"] = { c=106, t=470, l=130, s=161.35, st=22 },
		["Zarsatrad"] = { c=106, t=129, l=130, s=161.35, st=20 },
		}, z="King's Gondor", a="Lower Lebennin", r=4, l="70.9s,35.1w" },
	["Aethir"] = { t=5, ml=115, td="R44", ql=140, d={
		["Arnach(KG)"] = { c=106, t=402, l=130, s=161.35, st=19 },
		["Erynos"] = { c=106, t=158, l=130, s=161.35, st=19 },
		["Furukzahar"] = { c=106, t=333, l=130, s=161.35, st=20 },
		["Glaniath(KG)"] = { c=106, t=250, l=130, s=161.35, st=21 },
		["Halach"] = { c=106, t=307, l=130, s=161.35, st=22 },
		["Imloth Melui"] = { c=106, t=454, l=130, s=161.35, st=20 },
		["Linhir(KG)"] = { c=106, t=104, l=130, s=161.35, st=29 },
		["Malbarth"] = { c=106, t=104, l=130, s=161.35, st=20 },
		["Ost Anglebed(KG)"] = { c=106, t=118, l=130, s=161.35, st=24 },
		["Pelargir East Gate"] = { c=106, t=198, l=130, s=161.35, st=25 },
		["Pelargir West Gate"] = { c=106, t=109, l=130, s=161.35, st=25 },
		["The Harlond"] = { c=106, t=462, l=130, s=161.35, st=33 },
		["Tumladen"] = { c=106, t=330, l=130, s=161.35, st=25 },
		["Zarsatrad"] = { c=106, t=211, l=130, s=161.35, st=25 },
		}, z="King's Gondor", a="Lower Lebennin", r=4, l="83.6s,39.9w" },
	["Ost Anglebed(KG)"] = { t=3, ml=115, td="R44", ql=140, d={
		["Aethir"] = { c=106, t=118, l=130, s=161.35, st=24 },
		["Arnach(KG)"] = { c=106, t=461, l=130, s=161.35, st=16 },
		["Erynos"] = { c=106, t=210, l=130, s=161.35, st=19 },
		["Furukzahar"] = { c=106, t=388, l=130, s=161.35, st=20 },
		["Glaniath(KG)"] = { c=106, t=306, l=130, s=161.35, st=20 },
		["Halach"] = { c=106, t=358, l=130, s=161.35, st=22 },
		["Imloth Melui"] = { c=106, t=518, l=130, s=161.35, st=20 },
		["Linhir(KG)"] = { c=106, t=185, l=130, s=161.35, st=27 },
		["Malbarth"] = { c=106, t=185, l=130, s=161.35, st=18 },
		["Pelargir East Gate"] = { c=106, t=253, l=130, s=161.35, st=24 },
		["Pelargir West Gate"] = { c=106, t=165, l=130, s=161.35, st=24 },
		["The Harlond"] = { c=106, t=517, l=130, s=161.35, st=34 },
		["Tumladen"] = { c=106, t=386, l=130, s=161.35, st=26 },
		["Zarsatrad"] = { c=106, t=267, l=130, s=161.35, st=26 },
		}, z="King's Gondor", a="Lower Lebennin", r=4, l="79.1s,39.0w" },
	["Malbarth"] = { t=8, ml=115, td="R44", ql=140, d={
		["Aethir"] = { c=106, t=104, l=130, s=161.35, st=20 },
		["Arnach(KG)"] = { c=106, t=472, l=130, s=161.35, st=14 },
		["Erynos"] = { c=106, t=222, l=130, s=161.35, st=14 },
		["Furukzahar"] = { c=106, t=401, l=130, s=161.35, st=16 },
		["Glaniath(KG)"] = { c=106, t=316, l=130, s=161.35, st=18 },
		["Halach"] = { c=106, t=374, l=130, s=161.35, st=18 },
		["Imloth Melui"] = { c=106, t=520, l=130, s=161.35, st=15 },
		["Linhir(KG)"] = { c=106, t=80, l=130, s=161.35, st=25 },
		["Ost Anglebed(KG)"] = { c=106, t=185, l=130, s=161.35, st=20 },
		["Pelargir East Gate"] = { c=106, t=271, l=130, s=161.35, st=19 },
		["Pelargir West Gate"] = { c=106, t=176, l=130, s=161.35, st=20 },
		["The Harlond"] = { c=106, t=536, l=130, s=161.35, st=28 },
		["Tumladen"] = { c=106, t=395, l=130, s=161.35, st=23 },
		["Zarsatrad"] = { c=106, t=278, l=130, s=161.35, st=22 },
		}, z="King's Gondor", a="Lower Lebennin", r=4, l="80.0s,42.2w" },
	["Linhir(KG)"] = { t=1, ml=115, td="R44", ql=140, d={
		["Minas Tirith"] = { l=95, s=93.5, st=29 },
		["South Bree"] = { s=5, st=28 },
		["Galtrev"] = { l=35, s=35, st=28 },
		["Aethir"] = { c=106, t=104, l=130, s=161.35, st=29 },
		["Arnach(KG)"] = { c=106, t=500, l=130, s=161.35, st=21 },
		["Dol Amroth(KG)"] = { l=130, s=180, st=38 },
		["Erynos"] = { c=106, t=222, l=130, s=161.35, st=24 },
		["Furukzahar"] = { c=106, t=403, l=130, s=161.35, st=24 },
		["Glaniath(KG)"] =  { c=106, t=320, l=130, s=161.35, st=26 },
		["Halach"] = { c=106, t=371, l=130, s=161.35, st=27 },
		["Imloth Melui"] = { c=106, t=521, l=130, s=161.35, st=27 },
		["Malbarth"] = { c=106, t=80, l=130, s=161.35, st=25 },
		["Ost Anglebed(KG)"] = { c=106, t=185, l=130, s=161.35, st=25 },
		["Parth Rest"] = { c=120, t=142, l=130, s=180, st=28 },
		["Pelargir East Gate"] = { c=106, t=265, l=130, s=161.35, st=28 },
		["Pelargir West Gate"] = { c=106, t=172, l=130, s=161.35, st=29 },
		["The Harlond"] = { c=106, t=534, l=130, s=161.35, st=38 },
		["Tumladen"] = { c=106, t=395, l=130, s=161.35, st=37 },
		["Zarsatrad"] = { c=106, t=276, l=130, s=161.35, st=29 },
		["Twenty-first Hall"] = { l=40, s=45, st=24 },
		["Edoras"] = { l=75, s=66, st=28 },
		["Erebor"] = { l=105, s=93.5, st=23 },
		["Felegoth"] = { l=105, s=93.5, st=23 },
		["Rivendell Stables"] = { l=25, s=25, st=27 },
		}, z="King's Gondor", a="Lower Lebennin", r=4, l="81.9s,45.1w" },
	-- Umbar
	["Barad Rill"] = { t=7, ml=115, td="R44", ql=141, d={
		["Calembel(KG)"] = { c=120, t=408, l=130, s=180, st=38 },
		["Dinadab"] = { c=120, t=503, l=130, s=180, st=28 },
		["Dol Amroth(KG)"] = { c=120, t=562, l=130, s=180, st=50 },
		["Ethring(KG)"] = { c=120, t=269, l=130, s=180, st=34 },
		["Lancrath"] = { c=120, t=612, l=130, s=180, st=29 },
		["Lothgobel"] = { c=120, t=456, l=130, s=180, st=42 },
		["Morlad(KG)"] = { c=120, t=730, l=130, s=180, st=28 },
		["Ost Lontir"] = { c=120, t=439, l=130, s=180, st=25 },
		["Parth Rest"] = { c=120, t=114, l=130, s=180, st=28 },
		["Sardol"] = { c=120, t=634, l=130, s=180, st=23 },
		["Tadrent(KG)"] = { c=120, t=350, l=130, s=180, st=28 },
		}, z="King's Gondor", a="Dor-en-Emil", r=4, l="85.5s,50.4w" },
	["Calembel(KG)"] = { t=1, ml=115, td="R44", ql=141, d={
		["Barad Rill"] = { c=120, t=408, l=130, s=180, st=38 },
		["Dinadab"] = { c=120, t=120, l=130, s=180, st=24 },
		["Dol Amroth(KG)"] = { c=120, t=397, l=130, s=180, st=36 },
		["Ethring(KG)"] = { c=120, t=170, l=130, s=180, st=24 },
		["Lancrath"] = { c=120, t=230, l=130, s=180, st=29 },
		["Lothgobel"] = { c=120, t=72, l=130, s=180, st=31 },
		["Morlad(KG)"] = { c=120, t=308, l=130, s=180, st=24 },
		["Ost Lontir"] = { c=120, t=274, l=130, s=180, st=18 },
		["Parth Rest"] = { c=120, t=327, l=130, s=180, st=24 },
		["Sardol"] = { c=120, t=373, l=130, s=180, st=22 },
		["Tadrent(KG)"] = { c=120, t=182, l=130, s=180, st=22 },
		}, z="King's Gondor", a="Lamedon", r=4, l="67.2s,55.1w" },
	["Dinadab"] = { t=1, ml=115, td="R44", ql=141, d={
		["Barad Rill"] = { c=120, t=503, l=130, s=180, st=28 },
		["Calembel(KG)"] = { c=120, t=120, l=130, s=180, st=24 },
		["Dol Amroth(KG)"] = { c=120, t=492, l=130, s=180, st=33 },
		["Ethring(KG)"] = { c=120, t=267, l=130, s=180, st=24 },
		["Lancrath"] = { c=120, t=112, l=130, s=180, st=27 },
		["Lothgobel"] = { c=120, t=52, l=130, s=180, st=22 },
		["Morlad(KG)"] = { c=120, t=190, l=130, s=180, st=22 },
		["Ost Lontir"] = { c=120, t=372, l=130, s=180, st=17 },
		["Parth Rest"] = { c=120, t=420, l=130, s=180, st=23 },
		["Sardol"] = { c=120, t=256, l=130, s=180, st=20 },
		["Tadrent(KG)"] = { c=120, t=279, l=130, s=180, st=21 },
		}, z="King's Gondor", a="Lamedon", r=4, l="63.2s,59.4w" },
	["Dol Amroth(KG)"] = { t=1, ml=115, td="R44", ql=142, d={
		["Lond Cirion"] = { l=130, s=180, st=46 },
		["Melgobas"] = { c=120, t=458, l=130, s=180, st=31 },
		["Minas Tirith(AB)"] = { l=120, s=93.5, st=40 },
		["South Bree"] = { s=5, st=40 },
		["Galtrev"] = { l=55, s=35, st=44 },
		["Barad Rill"] = { c=120, t=562, l=130, s=180, st=50 },
		["Calembel(KG)"] = { c=120, t=397, l=130, s=180, st=36 },
		["Dinadab"] = { c=120, t=492, l=130, s=180, st=33 },
		["Ethring(KG)"] = { c=120, t=477, l=130, s=180, st=36 },
		["Lancrath"] = { c=120, t=630, l=130, s=180, st=39 },
		["Linhir(KG)"] = { l=130, s=180, st=38 },
		["Lothgobel"] = { c=120, t=443, l=130, s=180, st=47 },
		["Morlad(KG)"] = { c=120, t=535, l=130, s=180, st=38 },
		["Ost Lontir"] = { c=120, t=180, l=130, s=180, st=35 },
		["Parth Rest"] = { c=120, t=451, l=130, s=180, st=35 },
		["Pelargir West Gate"] = { l=130, s=161.35, st=37 },
		["Sardol"] = { c=120, t=443, l=130, s=180, st=30 },
		["Tadrent(KG)"] = { c=120, t=234, l=130, s=180, st=33 },
		["Twenty-first Hall"] = { l=45, s=45, st=29 },
		["Edoras"] = { l=100, s=66, st=34 },
		["Erebor"] = { l=100, s=93.5, st=31 },
		["Felegoth"] = { l=100, s=93.5, st=29 },
		["Rivendell Stables"] = { l=35, s=25, st=32 },
		["Dol Amroth(B)"] = { mt=84 },
		}, z="King's Gondor", a="Belfalas", r=4, l="75.4s,72.5w" },
	["Dol Amroth(B)"] = { t=1, ml=115, td="R44", d={
		["Lond Cirion(B)"] = { l=135, s=180, st=8 },
		["Pelargir(B)"] = { l=135, s=180, st=6 },
		["Halrax(B)"] = { l=135, s=180, st=14 },
		["Umbar Baharbel(B)"] = { l=135, s=180, st=4 },
		["Dol Amroth(KG)"] = { mt=84 },
		}, z="King's Gondor", a="Belfalas", r=4, l="74.9s,69.4w" },
	["Ethring(KG)"] = { t=6, ml=115, td="R44", ql=141, d={
		["Barad Rill"] = { c=120, t=269, l=130, s=180, st=34 },
		["Calembel(KG)"] = { c=120, t=170, l=130, s=180, st=224 },
		["Dinadab"] = { c=120, t=267, l=130, s=180, st=24 },
		["Dol Amroth(KG)"] = { c=120, t=477, l=130, s=180, st=36 },
		["Lancrath"] = { c=120, t=376, l=130, s=180, st=23 },
		["Lothgobel"] = { c=120, t=218, l=130, s=180, st=22 },
		["Morlad(KG)"] = { c=120, t=456, l=130, s=180, st=24 },
		["Ost Lontir"] = { c=120, t=355, l=130, s=180, st=21 },
		["Parth Rest"] = { c=120, t=150, l=130, s=180, st=25 },
		["Sardol"] = { c=120, t=525, l=130, s=180, st=24 },
		["Tadrent(KG)"] = { c=120, t=265, l=130, s=180, st=24 },
		}, z="King's Gondor", a="Ringlo Vale", r=4, l="72.2s,50.1w" },
	["Lancrath"] = { t=1, ml=115, td="R44", ql=142, d={
		["Barad Rill"] = { c=120, t=612, l=130, s=180, st=29 },
		["Calembel(KG)"] = { c=120, t=230, l=130, s=180, st=29 },
		["Dinadab"] = { c=120, t=112, l=130, s=180, st=27 },
		["Dol Amroth(KG)"] = { c=120, t=630, l=130, s=180, st=39 },
		["Ethring(KG)"] = { c=120, t=376, l=130, s=180, st=24 },
		["Lothgobel"] = { c=120, t=157, l=130, s=180, st=24 },
		["Morlad(KG)"] = { c=120, t=91, l=130, s=180, st=25 },
		["Ost Lontir"] = { c=120, t=467, l=130, s=180, st=24 },
		["Parth Rest"] = { c=120, t=519, l=130, s=180, st=24 },
		["Sardol"] = { c=120, t=155, l=130, s=180, st=25 },
		["Tadrent(KG)"] = { c=120, t=453, l=130, s=180, st=27 },
		}, z="King's Gondor", a="Blackroot Vale", r=4, l="58.1s,58.1w" },
	["Lothgobel"] = { t=1, ml=115, td="R44", ql=141, d={
		["Barad Rill"] = { c=120, t=456, l=130, s=180, st=42 },
		["Calembel(KG)"] = { c=120, t=72, l=130, s=180, st=31 },
		["Dinadab"] = { c=120, t=52, l=130, s=180, st=22 },
		["Dol Amroth(KG)"] = { c=120, t=442, l=130, s=180, st=47 },
		["Ethring(KG)"] = { c=120, t=218, l=130, s=180, st=22 },
		["Lancrath"] = { c=120, t=157, l=130, s=180, st=24 },
		["Morlad(KG)"] = { c=120, t=240, l=130, s=180, st=22 },
		["Ost Lontir"] = { c=120, t=325, l=130, s=180, st=20 },
		["Parth Rest"] = { c=120, t=364, l=130, s=180, st=22 },
		["Sardol"] = { c=120, t=304, l=130, s=180, st=23 },
		["Tadrent(KG)"] = { c=120, t=231, l=130, s=180, st=24 },
		}, z="King's Gondor", a="Lamedon", r=4, l="64.2s,56.9w" },
	["Morlad(KG)"] = { t=1, ml=115, td="R44", ql=142, d={
		["Barad Rill"] = { c=120, t=730, l=130, s=180, st=28 },
		["Calembel(KG)"] = { c=120, t=308, l=130, s=180, st=24 },
		["Dinadab"] = { c=120, t=190, l=130, s=180, st=22 },
		["Dol Amroth(KG)"] = { c=120, t=535, l=130, s=180, st=38 },
		["Ethring(KG)"] = { c=120, t=456, l=130, s=180, st24 },
		["Lancrath"] = { c=120, t=91, l=130, s=180, st=25 },
		["Lothgobel"] = { c=120, t=240, l=130, s=180, st=22 },
		["Ost Lontir"] = { c=120, t=415, l=130, s=180, st=19 },
		["Parth Rest"] = { c=120, t=618, l=130, s=180, st=22 },
		["Sardol"] = { c=120, t=104, l=130, s=180, st=21 },
		["Tadrent(KG)"] = { c=120, t=398, l=130, s=180, st=23 },
		}, z="King's Gondor", a="Blackroot Vale", r=4, l="56.9s,67.5w" },
	["Ost Lontir"] = { t=1, ml=115, td="R44", ql=142, d={
		["Barad Rill"] = { c=120, t=439, l=130, s=180, st=25 },
		["Calembel(KG)"] = { c=120, t=274, l=130, s=180, st=18 },
		["Dinadab"] = { c=120, t=372, l=130, s=180, st=17 },
		["Dol Amroth(KG)"] = { c=120, t=180, l=130, s=180, st=35 },
		["Ethring(KG)"] = { c=120, t=355, l=130, s=180, st=21 },
		["Lancrath"] = { c=120, t=467, l=130, s=180, st=24 },
		["Lothgobel"] = { c=120, t=325, l=130, s=180, st=20 },
		["Morlad(KG)"] = { c=120, t=415, l=130, s=180, st=19 },
		["Parth Rest"] = { c=120, t=327, l=130, s=180, st=19 },
		["Sardol"] = { c=120, t=320, l=130, s=180, st=14 },
		["Tadrent(KG)"] = { c=120, t=114, l=130, s=180, st=19 },
		}, z="King's Gondor", a="Belfalas", r=4, l="74.9s,65.8w" },
	["Parth Rest"] = { t=2, ml=115, td="R44", ql=141, d={
		["Barad Rill"] = { c=120, t=114, l=130, s=180, st=28 },
		["Calembel(KG)"] = { c=120, t=327, l=130, s=180, st=24 },
		["Dinadab"] = { c=120, t=420, l=130, s=180, st=23 },
		["Dol Amroth(KG)"] = { c=120, t=451, l=130, s=180, st=35 },
		["Ethring(KG)"] = { c=120, t=150, l=130, s=180, st=25 },
		["Lancrath"] = { c=120, t=519, l=130, s=180, st=24 },
		["Linhir(KG)"] = { c=120, t=142, l=130, s=180, st=28 },
		["Lothgobel"] = { c=120, t=364, l=130, s=180, st=22 },
		["Morlad(KG)"] = { c=120, t=618, l=130, s=180, st=22 },
		["Ost Lontir"] = { c=120, t=327, l=130, s=180, st=14 },
		["Sardol"] = { c=120, t=521, l=130, s=180, st=19 },
		["Tadrent(KG)"] = { c=120, t=240, l=130, s=180, st=24 },
		}, z="King's Gondor", a="Dor-en-Emil", r=4, l="90.2s,51.2w" },
	["Sardol"] = { t=2, ml=115, td="R44", ql=142, d={
		["Barad Rill"] = { c=120, t=634, l=130, s=180, st=23 },
		["Calembel(KG)"] = { c=120, t=373, l=130, s=180, st=22 },
		["Dinadab"] = { c=120, t=256, l=130, s=180, st=20 },
		["Dol Amroth(KG)"] = { c=120, t=443, l=130, s=180, st=30 },
		["Ethring(KG)"] = { c=120, t=525, l=130, s=180, st=24 },
		["Lancrath"] = { c=120, t=155, l=130, s=180, st=25 },
		["Lothgobel"] = { c=120, t=304, l=130, s=180, st=23 },
		["Morlad(KG)"] = { c=120, t=104, l=130, s=180, st=21 },
		["Ost Lontir"] = { c=120, t=320, l=130, s=180, st=14 },
		["Parth Rest"] = { c=120, t=521, l=130, s=180, st=19 },
		["Tadrent(KG)"] = { c=120, t=304, l=130, s=180, st=19 },
		}, z="King's Gondor", a="Blackroot Vale", r=4, l="61.0s,69.5w" },
	["Tadrent(KG)"] = { t=1, ml=115, td="R44", ql=142, d={
		["Barad Rill"] = { c=120, t=350, l=130, s=180, st=28 },
		["Calembel(KG)"] = { c=120, t=182, l=130, s=180, st=22 },
		["Dinadab"] = { c=120, t=279, l=130, s=180, st=21 },
		["Dol Amroth(KG)"] = { c=120, t=234, l=130, s=180, st=33 },
		["Ethring(KG)"] = { c=120, t=265, l=130, s=180, st=24 },
		["Lancrath"] = { c=120, t=453, l=130, s=180, st=27 },
		["Lothgobel"] = { c=120, t=231, l=130, s=180, st=24 },
		["Morlad(KG)"] = { c=120, t=398, l=130, s=180, st=23 },
		["Ost Lontir"] = { c=120, t=114, l=130, s=180, st=19 },
		["Parth Rest"] = { c=120, t=240, l=130, s=180, st=24 },
		["Sardol"] = { c=120, t=304, l=130, s=180, st=19 },
		}, z="King's Gondor", a="Belfalas", r=4, l="74.0s,62.4w" },
	-- Outer Gondor
	["Barad Faen"] = { t=2, ml=115, td="R44", ql=143, d={
		["Iaphel"] = { c=120, t=330, l=130, s=180, st=24 },
		["Lond Cirion"] = { c=120, t=147, l=130, s=180, st=28 },
		["Melgobas"] = { c=120, t=109, l=130, s=180, st=29 },
		["Mereham"] = { c=120, t=318, l=130, s=180, st=18 },
		["Ost Arndir"] = { c=120, t=424, l=130, s=180, st=027 },
		}, z="Outer Gondor", a="Anfalas", r=4, l="67.1s,81.5w" },
	["Iaphel"] = { t=6, ml=115, td="R44", ql=144, d={
		["Barad Faen"] = { c=120, t=330, l=130, s=180, st=24 },
		["Lond Cirion"] = { c=120, t=237, l=130, s=180, st=23 },
		["Melgobas"] = { c=120, t=436, l=130, s=180, st=20 },
		["Mereham"] = { c=120, t=323, l=130, s=180, st=20 },
		["Ost Arndir"] = { c=120, t=307, l=130, s=180, st=29 },
		}, z="Outer Gondor", a="Pinnath Gelin", r=4, l="60.2s,94.0w" },
	["Lond Cirion"] = { t=2, ml=115, td="R44", ql=143, d={
		["Barad Faen"] = { c=120, t=147, l=130, s=180, st=28 },
		["Melgobas"] = { c=120, t=247, l=130, s=180, st=24 },
		["Minas Tirith(AB)"] = { l=120, s=93.5, st=34 },
		["South Bree"] = { s=5, st=24 },
		["Galtrev"] = { l=55, s=35, st=31 },
		["Dol Amroth(KG)"] = { l=130, s=180, st=46 },
		["Pelargir West Gate"] = { l=130, s=106, st=22 },
		["Twenty-first Hall"] = { l=45, s=45, st=16 },
		["Iaphel"] = { c=120, t=237, l=130, s=180, st=24 },
		["Mereham"] = { c=120, t=262, l=130, s=180, st=16 },
		["Ost Arndir"] = { c=120, t=374, l=130, s=180, st=25 },
		["Edoras"] = { l=100, s=93.5, st=21 },
		["Erebor"] = { l=100, s=93.5, st=16 },
		["Felegoth"] = { l=100, s=93.5, st=15 },
		["Rivendell Stables"] = { l=35, s=25, st=19 },
		["Lond Cirion(B)"] = { mt=40 },
		}, z="Outer Gondor", a="Anfalas", r=4, l="69.0s,88.9w" },
	["Lond Cirion(B)"] = { t=6, ml=115, td="R44", d={
		["Dol Amroth(B)"] = { l=135, s=180, st=8 },
		["Pelargir(B)"] = { l=135, s=180, st=6 },
		["Halrax(B)"] = { l=135, s=180, st=20 },
		["Umbar Baharbel(B)"] = { l=135, s=180, st=10 },
		["Lond Cirion"] = { mt=40 },
		}, z="Outer Gondor", a="Pelargir", r=4, l="20.5s,98.4w" },
	["Melgobas"] = { t=2, ml=115, td="R44", ql=143, d={
		["Barad Faen"] = { c=120, t=109, l=130, s=180, st=29 },
		["Lond Cirion"] = { c=120, t=247, l=130, s=180, st=24 },
		["Dol Amroth(KG)"] = { c=120, t=458, l=130, s=180, st=31 },
		["Iaphel"] = { c=120, t=436, l=130, s=180, st=20 },
		["Mereham"] = { c=120, t=254, l=130, s=180, st=15 },
		["Ost Arndir"] = { c=120, t=712, l=130, s=180, st=22 },
		}, z="Outer Gondor", a="Anfalas", r=4, l="68.7s,77.0w" },
	["Mereham"] = { t=2, ml=115, td="R44", ql=144, d={
		["Barad Faen"] = { c=120, t=318, l=130, s=180, st=18 },
		["Lond Cirion"] = { c=120, t=262, l=130, s=180, st=16 },
		["Melgobas"] = { c=120, t=254, l=130, s=180, st=15 },
		["Iaphel"] = { c=120, t=323, l=130, s=180, st=20 },
		["Ost Arndir"] = { c=120, t=181, l=130, s=180, st=21 },
		}, z="Outer Gondor", a="Pinnath Gelin", r=4, l="57.7s,81.5w" },
	["Ost Arndir"] = { t=3, ml=115, td="R44", ql=144, d={
		["Barad Faen"] = { c=120, t=424, l=130, s=180, st=27 },
		["Lond Cirion"] = { c=120, t=374, l=130, s=180, st=25 },
		["Melgobas"] = { c=120, t=712, l=130, s=180, st=22 },
		["Iaphel"] = { c=120, t=307, l=130, s=180, st=29 },
		["Mereham"] = { c=120, t=181, l=130, s=180, st=21 },
		}, z="Outer Gondor", a="Pinnath Gelin", r=4, l="57.7s,81.5w" },
	
-- Haradwaith
	-- Cape of Umbar
	["Jax Phanal"] = { t=2, ml=115, td="R45", ql=147, d={
		["Khutra"] = { c=120, t=345, l=130, s=180, st=28 },
		["Rakhatab"] = { c=120, t=190, l=130, s=180, st=17 },
		["Umbar Baharbel(W)"] = { c=120, t=571, l=135, s=180, st=28 },
		["Jax Phanal(B)"] = { mt=15 },
		}, z="Cape of Umbar", r=5, l="14.4s,114.7w" },
	["Jax Phanal(B)"] = { t=9, ml=115, td="R45", d={
		["Bel Inzul(B)"] = { l=135, s=180, st=15 },
		["Halrax(B)"] = { l=135, s=180, st=10 },
		["Jax Phanal"] = { mt=15 },
		}, z="Cape of Umbar", r=5, l="14.4s,114.7w" },
	["Khutra"] = { t=6, ml=115, td="R45", ql=148, d={
		["Jax Phanal"] = { c=120, t=345, l=130, s=180, st=28 },
		["Rakhatab"] = { c=120, t=188, l=130, s=180, st=13 },
		["Umbar Baharbel(W)"] = { c=120, t=161, l=135, s=180, st=18 },
		}, z="Cape of Umbar", r=5, l="19.1s,108.2w" },
	["Rakhatab"] = { t=6, ml=115, td="R45", ql=147, d={
		["Jax Phanal"] = { c=120, t=190, l=130, s=180, st=17 },
		["Khutra"] = { c=120, t=188, l=130, s=180, st=13 },
		["Umbar Baharbel(W)"] = { c=120, t=337, l=135, s=180, st=21 },
		}, z="Cape of Umbar", r=5, l="25.3s,115.6w" },
	["Umbar Baharbel(W)"] = { t=6, ml=115, td="R45", ql=148, d={
		["Bloody Eagle Tavern"] = { l=135, s=180, st=14 },
		["Fleet-gate"] = { l=135, s=180, st=11 },
		["Gate of Sorrows"] = { l=135, s=180, st=16 },
		["Hunter's Camp"] = { l=135, s=180, st=13 },
		["Jax Phanal"] = { c=120, t=571, l=130, s=180, st=28 },
		["Khutra"] = { c=120, t=161, l=130, s=180, st=18 },
		["Rakhatab"] = { c=120, t=33, l=130, s=180, st=20 },
		["Swain's Guild-hall"] = { l=135, s=180, st=13 },
		["Umbar Baharbel(E)"] = { l=135, s=180, st=31 },
		["Umbar Baharbel(N)"] = { l=135, s=180, st=17 },
		["Umbar Baharbel(B)"] = { mt=90 },
		}, z="Cape of Umbar", r=5, l="18.5s,100.7w" },
	["Umbar Baharbel(E)"] = { t=6, ml=115, td="R45", ql=148, d={
		["Bloody Eagle Tavern"] = { l=135, s=180, st=14 },
		["Fleet-gate"] = { l=135, s=180, st=9 },
		["Gate of Sorrows"] = { l=135, s=180, st=12 },
		["Hunter's Camp"] = { c=180, t=78, l=135, s=180, st=21 },
		["Swain's Guild-hall"] = { l=135, s=180, st=12 },
		["Umbar Baharbel(N)"] = { l=135, s=180, st=22 },
		["Umbar Baharbel(W)"] = { l=135, s=180, st=31 },
		}, z="Cape of Umbar", r=5, l="20.5s,96.4w" },
	["Umbar Baharbel(N)"] = { t=6, ml=115, td="R45", ql=148, d={
		["Bloody Eagle Tavern"] = { l=135, s=180, st=13 },
		["Fleet-gate"] = { l=135, s=180, st=11 },
		["Gate of Sorrows"] = { l=135, s=180, st=14 },
		["Hunter's Camp"] = { l=135, s=180, st=13 },
		["Swain's Guild-hall"] = { l=135, s=180, st=17 },
		["Umbar Baharbel(E)"] = { l=135, s=180, st=22 },
		["Umbar Baharbel(W)"] = { l=135, s=180, st=17 },
		}, z="Cape of Umbar", r=5, l="17.4s,97.9w" },
	["Umbar Baharbel(B)"] = { t=6, ml=115, td="R45", ql=148, d={
		["Lond Cirion(B)"] = { l=135, s=180, st=10 },
		["Dol Amroth(B)"] = { l=135, s=180, st=4 },
		["Pelargir(B)"] = { l=135, s=180, st=8 },
		["Halrax(B)"] = { l=135, s=180, st=5 },
		["Umbar Baharbel(W)"] = { mt=90 },
		["Bloody Eagle Tavern"] = { mt=18 },
		}, z="Cape of Umbar", r=5, l="20.0s,98.4w" },
	["Bloody Eagle Tavern"] = { t=30, ml=5, ql=148, d={
		["Bloody Eagle Tavern(I)"] = { mt=12 },
		["Fleet-gate"] = { l=135, s=180, st=8 },
		["Gate of Sorrows"] = { l=135, s=180, st=12 },
		["Hunter's Camp"] = { c=180, t=46, l=135, s=180, st=11 },
		["Swain's Guild-hall"] = { l=135, s=180, st=12 },
		["Umbar Baharbel(E)"] = { l=135, s=180, st=14 },
		["Umbar Baharbel(N)"] = { l=135, s=180, st=13 },
		["Umbar Baharbel(W)"] = { l=135, s=180, st=14 },
		["Umbar Baharbel(B)"] = { mt=18 },
		}, z="Cape of Umbar", r=5, l="19.7s,97.6w" },
	["Bloody Eagle Tavern(I)"] = { d={
		["Bloody Eagle Tavern"] = { mt=12 },
		}, z="Cape of Umbar", r=5, l="19.7s,97.6w" },
	["Fleet-gate"] = { t=2, ml=125, td="R45", ql=148, d={
		["Bloody Eagle Tavern"] = { l=135, s=180, st=8 },
		["Gate of Sorrows"] = { l=135, s=180, st=8 },
		["Hunter's Camp"] = { c=180, t=46, l=135, s=180, st=9 },
		["Swain's Guild-hall"] = { l=135, s=180, st=8 },
		["Umbar Baharbel(E)"] = { l=135, s=180, st=9 },
		["Umbar Baharbel(N)"] = { l=135, s=180, st=11 },
		["Umbar Baharbel(W)"] = { l=135, s=180, st=11 },
		}, z="Cape of Umbar", r=5, l="23.9s,97.1w" },
	["Gate of Sorrows"] = { t=2, ml=125, td="R45", ql=148, d={
		["Bloody Eagle Tavern"] = { l=135, s=180, st=12 },
		["Fleet-gate"] = { l=135, s=180, st=8 },
		["Hunter's Camp"] = { l=135, s=180, st=9 },
		["Swain's Guild-hall"] = { l=135, s=180, st=12 },
		["Umbar Baharbel(E)"] = { l=135, s=180, st=12 },
		["Umbar Baharbel(N)"] = { l=135, s=180, st=14 },
		["Umbar Baharbel(W)"] = { l=135, s=180, st=15 },
		}, z="Cape of Umbar", r=5, l="21.8s,97.9w" },
	["Hunter's Camp"] = { t=2, ml=125, td="R45", ql=149, d={
		["Bloody Eagle Tavern"] = { l=135, s=180, st=11 },
		["Fleet-gate"] = { c=180, t=46, l=135, s=180, st=8 },
		["Gate of Sorrows"] = { l=135, s=180, st=9 },
		["Swain's Guild-hall"] = { l=135, s=180, st=10 },
		["Umbar Baharbel(E)"] = { c=180, t=78, l=135, s=180, st=21 },
		["Umbar Baharbel(N)"] = { l=135, s=180, st=13 },
		["Umbar Baharbel(W)"] = { l=135, s=180, st=13 },
		}, z="Cape of Umbar", r=5, l="23.2s,94.6w" },
	["Swain's Guild-hall"] = { t=15, ml=5, ql=148, d={
		["Bloody Eagle Tavern"] = { l=135, s=180, st=12 },
		["Fleet-gate"] = { l=135, s=180, st=8 },
		["Gate of Sorrows"] = { l=135, s=180, st=12 },
		["Hunter's Camp"] = { l=135, s=180, st=10 },
		["Umbar Baharbel(E)"] = { l=135, s=180, st=12 },
		["Umbar Baharbel(N)"] = { l=135, s=180, st=17 },
		["Umbar Baharbel(W)"] = { l=135, s=180, st=13 },
		}, z="Cape of Umbar", r=5, l="21.2s,97.6w" },

	-- Shield Islands (Zirer Tarka)
	["Bel Inzul(B)"] = { t=2, ml=115, td="R45", ql=146, d={
		["Halrax(B)"] = { c=120, t=4, l=135 },
		["Jax Phanal(B)"] = { l=135, s=180, st=15 },
		["Kafagar(B)"] = { l=135, s=180, st=6 },
		["Mar Naphra(B)"] = { c=120, t=8, l=135 },
		["Voyage's End(B)"] = { l=135, s=180, st=4 },
		}, z="Zirer Tarka", r=5, l="9.8s,126.8w" },
	["Halrax(B)"] = { t=1, ml=115, td="R45", ql=146, d={
		["Lond Cirion(B)"] = { l=135, s=180, st=20 },
		["Dol Amroth(B)"] = { l=135, s=180, st=13 },
		["Pelargir(B)"] = { l=135, s=180, st=6 },
		["Bel Inzul(B)"] = { c=120, t=11, l=135 },
		["Kafagar(B)"] = { l=135, s=180, st=9 },
		["Mar Naphra(B)"] = { c=120, t=4, l=135 },
		["Voyage's End(B)"] = { l=135, s=180, st=4 },
		["Jax Phanal(B)"] = { l=135, s=180, st=10 },
		["Umbar Baharbel(B)"] = { l=135, s=180, st=5 },
		}, z="Zirer Tarka", r=5, l="9.8s,126.8w" },
	["Kafagar(B)"] = { t=6, ml=115, td="R45", ql=146, d={
		["Bel Inzul(B)"] = { l=135, s=180, st=6 },
		["Halrax(B)"] = { l=135, s=180, st=9 },
		["Mar Naphra(B)"] = { c=120, t=4, l=135 },
		["Voyage's End(B)"] = { l=135, s=180, st=4 },
		}, z="Zirer Tarka", r=5, l="0.1n,133.5w" },
	["Mar Naphra(B)"] = { t=6, ml=115, td="R45", ql=145, d={
		["Bel Inzul(B)"] = { l=135, s=180, st=8 },
		["Halrax(B)"] = { c=120, t=4, l=135 },
		["Kafagar(B)"] = { c=120, t=4, l=135 },
		["Voyage's End(B)"] = { c=120, t=4, l=135 },
		}, z="Zirer Tarka", r=5, l="4.0s,130.7w" },
	["Voyage's End(B)"] = { t=2, ml=115, td="R45", ql=145, d={
		["Bel Inzul(B)"] = { l=135, s=180, st=4 },
		["Halrax(B)"] = { c=120, t=4, l=135 },
		["Kafagar(B)"] = { l=135, s=180, st=4 },
		["Mar Naphra(B)"] = { c=120, t=4, l=135 },
		}, z="Zirer Tarka", r=5, l="0.8s,130.4w" },

	-- March of the King
	["Osgiliath"] = { t=16, ml=85, td="R40", ql=100, d={
		["Aragorn's Pavilion"] = { c=85, t=170, l=90, s=93.5, st=21 },
		["Minas Tirith(M)"] = { s=1, st=28 },
		["Minas Tirith(AB)"] = { c=85, t=185, l=90, s=93.5, st=22 },
		["South Bree"] = { l=90, s=122, st=18 },
		["Galtrev"] = { l=90, s=122, st=22 },
		["Camp of the Host"] = { c=85, t=475, l=90, s=93.5, st=19 },
		["Henneth Annun"] = { c=85, t=307, l=90, s=93.5, st=26 },
		["Estolad Lan"] = { c=95, t=85, l=-110, s=147.5, st=24 },
		["Twenty-first Hall"] = { l=90, s=122, st=19 },
		["Minas Tirith"] = { l=90, s=122, st=30 },
		["Aldburg"] = { l=90, s=122, st=22 },
		["Hultvis"] = { l=90, s=122, st=25 },
		["Dol Amroth"] = { l=90, s=122, st=22 },
		}, z="March of the King", r=4, a="Osgiliath", l="63.0s,6.5w" },
	["Minas Tirith(AB)"] = { t=3, ml=35, td="R40", ql=105, d={
		["Lond Cirion"] = { l=130, s=180, st=34 },
		["Aragorn's Pavilion"] = { c=85, t=68, l=90, s=93.5, st=22 },
		["Minas Tirith(M)"] = { s=1, st=38 },
		["Osgiliath"] = { c=85, t=185, l=90, s=93.5, st=22 },
		["Zidir-nesad"] = { l=130, s=161.35, st=24 },
		["Camp of the Host"] = { c=85, t=654, l=90, s=93.5, st=24 },
		["Henneth Annun"] = { c=85, t=489, l=90, s=93.5, st=30 },
		["Linhir(KG)"] = { l=130, s=161.35, st=29 },
		["Pelargir East Gate"] = { l=130, s=161.35, st=24 },
		["Pelargir West Gate"] = { l=130, s=161.35, st=22 },
		["The Harlond"] = { c=106, t=167, l=130, s=161.35, st=36 },
		["Minas Tirith"] = { s=1, st=26, n="To Mins Tirith, Before the Battle" },
		["Threshold of the City"] = { s=1, st=8, n="To the Threshold of the City" },
		}, z="March of the King", r=4, a="Pelennor", l="65.6s,16.9w" },
	["Aragorn's Pavilion"] = { t=35, ml=85, td="R40", ql=105, d={
		["Henneth Annun"] = { c=85, t=473, l=90, s=93.5, st=22 },
		["Minas Tirith(AB)"] = { c=85, t=68, l=90, s=93.5, st=22 },
		["Osgiliath"] = { c=85, t=170, l=90, s=93.5, st=21 },
		["Camp of the Host"] = { c=85, t=638, l=90, s=93.5, st=15 },
		}, z="March of the King", r=4, a="Pelennor", l="65.6s,14.8w" },
	["Henneth Annun"] = { t=35, ml=85, td="R40", ql=105, d={
		["Aragorn's Pavilion"] = { c=85, t=473, l=90, s=93.5, st=22 },
		["Minas Tirith(AB)"] = { c=85, t=489, l=90, s=93.5, st=30 },
		["Osgiliath"] = { c=85, t=307, l=90, s=93.5, st=26 },
		["Camp of the Host"] = { c=85, t=195, l=90, s=93.5, st=22 },
		["Estolad Lan"] = { c=95, t=338, l=-110, s=147.5, st=25 },
		}, z="March of the King", r=4, a="North Ithilien", l="48.3s,6.9w" },
	["Camp of the Host"] = { t=3, ml=85, td="R50", ql=105, d={
		["Aragorn's Pavilion"] = { c=85, t=638, l=90, s=93.5, st=15 },
		["Minas Tirith(AB)"] = { c=85, t=654, l=90, s=93.5, st=24 },
		["Osgiliath"] = { c=85, t=475, l=90, s=93.5, st=19 },
		["Henneth Annun"] = { c=85, t=195, l=90, s=93.5, st=22 },
		["The Slag-hills"] = { c=85, t=215, l=90, s=93.5, st=24 },
		}, z="The Wastes", r=4, l="41.0s,10.5w" },
	["Haerondir"] = { z="The Wastes", r=1, l="36.6s,9.2w" },
	["The Slag-hills"] = { t=1, ml=90, td="R50", ql=105, d={
		["Camp of the Host"] = { c=85, t=215, l=90, s=93.5, st=24 },
		["Osgiliath"] = { c=85, t=685, l=90, s=93.5, st=23 },
		["Udun Foothold"] = { c=85, t=190, l=-90, s=93.5, st=21, r=",Q7" },
		}, z="The Wastes", r=4, l="34.4s,3.5w" },
-- Gorgoroth starts here
	["Udun Foothold"] = { t=1, ml=90, td="R51", ql=106, d={
		["Agarnaith Ranger Camp"] = { c=85, t=692, l=-90, s=93.5, st=23 },
		["Magh Ashtu"] = { c=85, t=302, l=-90, s=93.5, st=16 },
		["Ruins of Dingarth"] = { c=85, t=209, l=-90, s=93.5, st=18 },
		["The Slag-hills"] = { c=85, t=190, l=-90, s=93.5, st=21, r=",Q7" },
		}, z="Gorgoroth", r=4, l="41.2s,0.5w" },
	["Ruins of Dingarth"] = { t=12, ml=85, td="R51", ql=107, d={
		["Agarnaith Ranger Camp"] = { c=85, t=480, l=-90, s=93.5, st=17 },
		["Magh Ashtu"] = { c=85, t=96, l=-90, s=93.5, st=15 },
		["Udun Foothold"] = { c=85, t=209, l=-90, s=93.5, st=18 },
		["Díngarth"] = { s=0, st=8, n="Blazon of the Last Alliance" },
		}, z="Gorgoroth", r=4, l="48.0s,8.7e" },
	["Magh Ashtu"] = { t=12, ml=85, td="R51", d={
		["South Bree"] = { l=90, s=122, st=25 },
		["Galtrev"] = { l=90, s=122, st=30 },
		["Agarnaith Ranger Camp"] = { c=85, t=406, l=-90, s=93.5, st=19 },
		["Estolad Lan"] = { l=-110, s=147.5, st=16 },
		["Echad Uial"] = { c=95, t=380, l=-110, s=147.5, st=17 },
		["Ruins of Dingarth"] = { c=85, t=96, l=-90, s=93.5, st=15 },
		["Udun Foothold"] = { c=85, t=302, l=-90, s=93.5, st=16 },
		["Twenty-first Hall"] = { l=90, s=122, st=26 },
		["Minas Tirith"] = { l=90, s=122, st=35 },
		["Aldburg"] = { l=90, s=122, st=35 },
		["Hultvis"] = { l=90, s=122, st=28 },
		["Dol Amroth"] = { l=90, s=122, st=32 },
		}, z="Gorgoroth", r=4, l="53.1s,10.5e" },
	["Agarnaith Ranger Camp"] = { t=12, ml=85, td="R51", ql=114, d={
		["Magh Ashtu"] = { c=85, t=406, l=-90, s=93.5, st=19 },
		["Ruins of Dingarth"] = { c=85, t=480, l=-90, s=93.5, st=17 },
		["Udun Foothold"] = { c=85, t=692, l=-90, s=93.5, st=23 },
		}, z="Gorgoroth", r=4, l="56.6s,26.9e" },
-- Mordor Besieged starts here
	["Adambel"] = { t=5, ml=105, td="Q8", ql=120, d={
		["Barthost"] = { c=95, t=183, l=-90, s=147.5, st=26 },
		["Díngarth"] = { c=95, t=120, l=-90, s=147.5, st=17 },
		["Echad-in-Edhil"] = { c=95, t=84, l=-90, s=147.5, st=14 },
		["Echad Uial"] = { s=0, st=6, n="Blazon of the Great Alliance", nl="98.7s,126.4w" },
		}, z="Mordor Besieged", r=4, l="98.9s,126.3w" },
	["Barthost"] = { t=1, ml=105, td="Q8", ql=122, d={
		["Adambel"] = { c=95, t=183, l=-90, s=147.5, st=26 },
		["Díngarth"] = { c=95, t=255, l=-90, s=147.5, st=27 },
		["Echad-in-Edhil"] = { c=95, t=222, l=-90, s=147.5, st=24 },
		}, z="Mordor Besieged", r=4, l="95.3s,119.9w" },
	["Díngarth"] = { t=4, ml=105, td="Q8", ql=120, d={
		["Adambel"] = { c=95, t=120, l=-90, s=147.5, st=17 },
		["Barthost"] = { c=95, t=255, l=-90, s=147.5, st=27 },
		["Echad-in-Edhil"] = { c=95, t=111, l=-90, s=147.5, st=13 },
		["Ruins of Dingarth"] = { s=0, st=6, n="Blazon of the Great Alliance" },
		}, z="Mordor Besieged", r=4, l="97.7s,131.3w" },
	["Echad-in-Edhil"] = { t=1, ml=105, td="Q8", ql=121, d={
		["Adambel"] = { c=95, t=84, l=-90, s=147.5, st=14 },
		["Barthost"] = { c=95, t=222, l=-90, s=147.5, st=24 },
		["Díngarth"] = { c=95, t=111, l=-90, s=147.5, st=13 },
		}, z="Mordor Besieged", r=4, l="96.3s,127.6w" },
-- Vales of Anduin starts here
	["Arhaim"] = { t=2, ml=105, td="R43", ql=120, d={
		["Caras Galadhon"] = { c=85, t=288, l=-90, s=122, st=30, r="D14" },
		["Beorninghus"] = { c=85, t=480, l=-90, s=122, st=38 },
		["Blomgard"] = { c=85, t=148, l=-90, s=122, st=32 },
		["Hultvis"] = { c=85, t=262, l=-90, s=122, st=28 },
		["Vegbar"] = { c=85, t=388, l=-90, s=122, st=18 },
		}, z="Vales of Anduin", r=2, l="5.9s,61.2w" },
	["Beorninghus"] = { t=2, td="R43", ql=120, d={
		["Minas Tirith(M)"] = { s=1, st=35 },
		["South Bree"] = { l=90, s=1, st=38 },
		["Felegoth"] = { c=85, t=448, l=-90, s=122, st=28 },
		["Arhaim"] = { c=85, t=480, l=-90, s=122, st=38 },
		["Blomgard"] = { c=85, t=362, l=-90, s=122, st=37 },
		["Hultvis"] = { c=85, t=230, l=-90, s=122, st=25 },
		["Vegbar"] = { c=85, t=262, l=-90, s=122, st=24 },
		["Limlok"] = { c=95, t=262, l=-90, s=147.5, st=24 },
		}, z="Vales of Anduin", r=2, l="13.5n,53.3w" },
	["Blomgard"] = { t=12, ml=105, td="R43", ql=120, d={
		["Arhaim"] = { c=85, t=148, l=-90, s=122, st=32 },
		["Beorninghus"] = { c=85, t=362, l=-90, s=122, st=37 },
		["Hultvis"] = { c=85, t=139, l=-90, s=122, st=40 },
		["Vegbar"] = { c=85, t=268, l=-90, s=122, st=30 },
		}, z="Vales of Anduin", r=2, l="1.6s,55.6w" },
	["Hultvis"] = { t=8, ml=105, td="R43", ql=120, d={
		["Osgiliath"] = { l=90, s=122, st=30 },
		["South Bree"] = { l=90, s=122, st=22 },
		["Galtrev"] = { l=90, s=122, st=30 },
		["Estolad Lan"] = { l=-110, s=147.5, st=26 },
		["Magh Ashtu"] = { l=90, s=122, st=28 },
		["Twenty-first Hall"] = { l=90, s=122, st=27 },
		["Snowbourn"] = { l=90, s=122, st=28 },
		["Erebor"] = { l=90, s=122, st=22 },
		["Skarhald"] = { l=90, s=122, st=22 },
		["Arhaim"] = { c=85, t=262, l=-90, s=122, st=28 },
		["Beorninghus"] = { c=85, t=230, l=-90, s=122, st=25 },
		["Blomgard"] = { c=85, t=139, l=-90, s=122, st=40 },
		["Vegbar"] = { c=85, t=135, l=-90, s=122, st=17 },
		}, z="Vales of Anduin", r=2, l="5.4n,54.6w" },
	["Vegbar"] = { t=6, ml=105, td="R43", ql=120, d={
		["Hrimbarg"] = { c=85, t=275, l=-90, s=122, st=23 },
		["Rivendell Stables"] = { l=-90, s=122, st=30 },
		["Arhaim"] = { c=85, t=388, l=-90, s=122, st=18 },
		["Beorninghus"] = { c=85, t=262, l=-90, s=122, st=24 },
		["Blomgard"] = { c=85, t=268, l=-90, s=122, st=30 },
		["Hultvis"] = { c=85, t=135, l=-90, s=122, st=17 },
		}, z="Vales of Anduin", r=2, l="7.9n,58.5w" },
	["The Carrock - Eagle"] = { td="R43", d={
		["The Eyrie - Eagle"] = { l=90, s=85, st=2 },
		}, z="Vales of Anduin", r=2, l="13.1n,58.4w" },
	["The Eyrie - Eagle"] = { td="R43", d={
		["The Carrock - Eagle"] = { l=90, s=85, st=2 },
		}, z="Vales of Anduin", r=2, l="14.6n,61.0w" },
	-- Boat travel on Gladdenmere
	["Northern Shore(B)"] = { d={
		["Southern Shore(B)"] = { c=85, t=6 },
		}, z="Vales of Anduin", r=-2, l="3.1n,65.8w" },
	["Southern Shore(B)"] = { d={
		["Northern Shore(B)"] = { c=85, t=6 },
		}, z="Vales of Anduin", r=-2, l="0.5n,65.2w" },
-- Morgul Vale starts here
	["Echad Taerdim"] = { t=2, ml=105, td="R49", ql=124, d={
		["Echad Uial"] = { c=95, t=218, l=-110, s=147.5, st=16 },
		["Estolad Lan"] = { c=95, t=74, l=-110, s=147.5, st=12 },
		["Minas Morgul"] = { c=95, t=300, l=-110, s=147.5, st=14 },
		["Taen Orwath"] = { c=95, t=311, l=-110, s=147.5, st=14 },
		}, z="Morgul Vale", r=4, l="61.9s,0.4w" },
	["Echad Uial"] = { t=2, ml=105, td="R49", ql=123, d={
		["Echad Taerdim"] = { c=95, t=218, l=-110, s=147.5, st=16 },
		["Estolad Lan"] = { c=95, t=178, l=-110, s=147.5, st=14 },
		["Magh Ashtu"] = { c=95, t=380, l=-110, s=147.5, st=17 },
		["Minas Morgul"] = { c=95, t=211, l=-110, s=147.5, st=22 },
		["Taen Orwath"] = { c=95, t=93, l=-110, s=147.5, st=16 },
		["Adambel"] = { s=0, st=8, n="Blazon of the Last Alliance" },
		}, z="Morgul Vale", r=4, l="65.1s,4.2e" },
	["Estolad Lan"] = { t=2, ml=105, td="R49", ql=123, d={
		["Osgiliath"] = { c=95, t=85, l=-110, s=147.5, st=24 },
		["Henneth Annun"] = { c=95, t=338, l=-110, s=147.5, st=25 },
		["Echad Taerdim"] = { c=95, t=74, l=-110, s=147.5, st=12 },
		["Echad Uial"] = { c=95, t=178, l=-110, s=147.5, st=14 },
		["Magh Ashtu"] = { l=-110, s=147.5, st=16 },
		["Minas Morgul"] = { c=95, t=250, l=-110, s=147.5, st=19 },
		["Taen Orwath"] = { c=95, t=276, l=-110, s=147.5, st=16 },
		["Hultvis"] = { l=-110, s=147.5, st=26 },
		}, z="Morgul Vale", r=4, l="65.4s,0.7e" },
	["Minas Morgul"] = { td="R49", ql=125, d={
		["Echad Uial"] = { c=95, t=211, l=-110, s=147.5, st=22 },
		["Estolad Lan"] = { c=95, t=250, l=-110, s=147.5, st=19 },
		["Echad Taerdim"] = { c=95, t=300, l=-110, s=147.5, st=14 },
		["Taen Orwath"] = { c=95, t=230, l=-110, s=147.5, st=15 },
		}, z="Morgul Vale", r=4, l="64.5s,2.2w" },
	["Taen Orwath"] = { t=1, ml=105, td="R49", d={
		["Echad Uial"] = { c=95, t=93, l=-110, s=147.5, st=16 },
		["Estolad Lan"] = { c=95, t=276, l=-110, s=147.5, st=16 },
		["Echad Taerdim"] = { c=95, t=311, l=-110, s=147.5, st=14 },
		["Minas Morgul"] = { c=95, t=230, l=-110, s=147.5, st=15 },
		}, z="Morgul Vale", r=4, l="66.9s,5.9e" },
-- Wells of Langflood starts here
	["Limlok"] = { t=2, ml=105, td="R48", ql=130, d={
		["Beorninghus"] = { c=95, t=262, l=-115, s=147.5, st=24 },
		["Hlithseld"] = { c=95, t=316, l=-115, s=147.5, st=25 },
		["Lyndelby"] = { l=115, s=147.5, st=34, r="Q9" },
		["Thokvist"] = { c=95, t=228, l=-115, s=147.5, st=15 },
		}, z="Wells of Langflood", r=2, l="20.7n,55.9w" },
	["Hlithseld"] = { t=2, ml=105, td="R48", ql=130, d={
		["Annak-khurfu"] = { c=95, t=240, l=-115, s=147.5, st=41 },
		["Skarhald"] = { c=95, t=395, l=-115, s=147.5, st=32 },
		["Limlok"] = { c=95, t=316, l=-115, s=147.5, st=25 },
		["Lyndelby"] = { l=115, s=147.5, st=45, r="Q9" },
		["Thokvist"] = { c=95, t=97, l=-115, s=147.5, st=15 },
		}, z="Wells of Langflood", r=2, l="30.6n,59.3w" },
	["Lyndelby"] = { t=22, ml=105, vr="Q9", td="R48", ql=130, d={
		["Hlithseld"] = { l=115, s=147.5, st=45 },
		["Limlok"] = { l=115, s=147.5, st=34 },
		["Thokvist"] = { l=115, s=147.5, st=38 },
		}, z="Wells of Langflood", r=2, l="27.1n,65.7w" },
	["Thokvist"] = { t=1, ml=105, td="R48", ql=130, d={
		["Hlithseld"] = { c=95, t=98, l=-115, s=147.5, st=25 },
		["Limlok"] = { c=95, t=228, l=-115, s=147.5, st=15 },
		["Lyndelby"] = { l=115, s=147.5, st=38, r="Q9" },
		}, z="Wells of Langflood", r=2, l="26.0n,58.4w" },
-- Minas Morgul tower  stables
-- Barad Angarth, the Gate-wardens' Keep
-- Barad Orhant, the Tower of the Treegarth
-- Elderslade starts here
	["Annak-khurfu"] = { t=11, td="R46" , ql=130, d={
		["Minas Tirith(M)"] = { s=1, st=39 },
		["Osgiliath"] = { l=100, s=122, st=22 },
		["South Bree"] = { s=1, st=32 },
		["Galtrev"] = { l=65, s=122, st=32 },
		["Drenghol"] = { c=96, t=183, l=-115, s=147.5, st=28 },
		["The War of Three Peaks"] = { l=120, s=147.5, st=36 },
		["Zudramdan"] = { c=95, t=165, l=-115, s=147.5, st=38 },
		["Thorin's Gate"] = { s=1, st=34 },
		["Caras Galadhon"] = { l=50, s=122, st=29, r="D14" },
		["Twenty-first Hall"] = { l=45, s=45, st=30 },
		["Erebor"] = { l=100, s=122, st=28 },
		["Felegoth"] = { l=100, s=122, st=29 },
		["Skarhald"] = { c=93.5, t=358, l=-115, s=122, st=37 },
		["Rivendell Stables"] = { l=35, s=5, st=32 },
		["Hlithseld"] = { c=95, t=240, l=-115, s=147.5, st=39 },
		}, z="Elderslade", r=2, l="32.7n,60.9w" },
	["Annak-khurfu(I)"] = { td="R46" , d={
		["Annak-khurfu"] = { mt=34 },
		["South Bree"] = { s=1, st=5 },
		["Akraz-zahar(I)"] = { l=20, s=1, st=1 },
		["Celondim"] = { s=1, st=3 },
		["Thorin's Gate"] = { s=1, st=3 },
		["Steepset"] = { l=20, s=1, st=3 },
		["Trestlebridge"] = { l=20, s=1, st=3 },
		["Michel Delving"] = { s=1, st=5 },
		}, z="Elderslade", r=2, l="32.8n,61.2w"},
	["Drenghol"] = { td="R46" , ql=130, d={
		["Annak-khurfu"] = { c=96, t=183, l=-115, s=147.5, st=28 },
		["Zudramdan"] = { c=96, t=45, l=-115, s=147.5, st=21 },
		["Maergrind"] = { c=106, t=80, l=-130, s=161.35, st=15 },
		}, z="Elderslade", r=2, l="38.7n,65.4w" },
	["Zudramdan"] = { td="R46" , ql=130, d={
		["Annak-khurfu"] = { c=96, t=165, l=-115, s=147.5, st=38 },
		["Drenghol"] = { c=96, t=45, l=-115, s=147.5, st=21 },
		["Leitstath"] = { c=106, t=192, l=-130, s=161.35, st=20 },
		}, z="Elderslade", r=2, l="36.8n,64.5w" },
	["The War of Three Peaks"] = { t=11, td="R46" , ql=130, d={
		["Annak-khurfu"] = { l=120, s=147.5, st=36 },
		}, z="Elderslade", a="The War of Three Peaks", r=2, l="100.8s,17.3w" },
-- Azanulbizar starts here
	["Gabilthurkhu"] = { t=18, ml=115, td="R47", ql=130, d={
		["Amdan"] = { mt=29 },
		["Akraz-zahar(I)"] = { mt=3 },
		}, z="Azanulbizar", r=2, l="62.6n,135.2w" },
	["Amdan"] = { t=18, ml=115, td="R47", ql=130, d={
		["Akraz-zahar(I)"] = { mt=35 },
		["Ashmargathal"] = { c=96, t=200, l=-125, s=147.5, st=24 },
		["Khur Azan"] = { c=96, t=67, l=-125, s=147.5, st=25 },
		["Zirakazhar"] = { c=96, t=84, l=-125, s=147.5, st=20 },
		}, z="Azanulbizar", r=2, l="63.8n,135.0w" },
	["Ashmargathal"] = { td="R47", ql=130, d={
		["Amdan"] = { c=96, t=200, l=-125, s=147.5, st=24 },
		["Khur Azan"] = { c=96, t=135, l=-125, s=147.5, st=18 },
		["Zirakazhar"] = { c=96, t=256, l=-125, s=147.5, st=15 },
		}, z="Azanulbizar", r=2, l="65.9n,133.1w" },
	["Khur Azan"] = { td="R47", ql=130, d={
		["Amdan"] = { c=96, t=67, l=-125, s=147.5, st=25 },
		["Ashmargathal"] = { c=96, t=135, l=-125, s=147.5, st=18 },
		["Zirakazhar"] = { c=96, t=117, l=-125, s=147.5, st=17 },
		}, z="Azanulbizar", r=2, l="64.4n,133.0w" },
	["Zirakazhar"] = { td="R47", ql=130, d={
		["Amdan"] = { c=96, t=84, l=-125, s=147.5, st=20 },
		["Ashmargathal"] = { c=96, t=256, l=-125, s=147.5, st=15 },
		["Khur Azan"] = { c=96, t=117, l=-125, s=147.5, st=17 },
		}, z="Azanulbizar", r=2, l="66.2n,136.7w" },
-- Gundabad starts here
	["Asbaj-khirfin"] = { t=4, ml=105, td="R52", ql=131, d={
		["Aslíf"] = { c=106, t=248, l=-130, s=161.35, st=31 },
		["Bargstad"] = { c=106, t=56, l=-130, s=161.35, st=14 },
		["Bazanmanar"] = { c=106, t=577, l=-130, s=161.35, st=23 },
		["Fellgat"] = { c=106, t=332, l=-130, s=161.35, st=16 },
		["Grumachath"] = { c=106, t=254, l=-130, s=161.35, st=14 },
		["Hagbuth"] = { c=106, t=520, l=-130, s=161.35, st=16 },
		["Ibdekh-buzru"] = { c=106, t=444, l=-130, s=161.35, st=17 },
		["Imrekh-guthlu"] = { c=106, t=162, l=-130, s=161.35, st=13 },
		["Leitstath"] = { c=106, t=345, l=-130, s=161.35, st=14 },
		["Maergrind"] = { c=106, t=81, l=-130, s=161.35, st=15 },
		["Watchers' Roost"] = { c=106, t=335, l=-130, s=161.35, st=15 },
		["Zidir-nesad"] = { c=106, t=61, l=-130, s=161.35, st=16 },
		}, z="Gundabad", a="Mattugard", r=2, l="46.2s,112.2w" },
	["Aslíf"] = { t=1, ml=105, td="R52", ql=133, d={
		["Asbaj-khirfin"] = { c=106, t=248, l=-130, s=161.35, st=31 },
		["Bargstad"] = { c=106, t=220, l=-130, s=161.35, st=25 },
		["Bazanmanar"] = { c=106, t=363, l=-130, s=161.35, st=35 },
		["Fellgat"] = { c=106, t=458, l=-130, s=161.35, st=28 },
		["Grumachath"] = { c=106, t=416, l=-130, s=161.35, st=24 },
		["Hagbuth"] = { c=106, t=286, l=-130, s=161.35, st=23 },
		["Ibdekh-buzru"] = { c=106, t=468, l=-130, s=161.35, st=29 },
		["Imrekh-guthlu"] = { c=106, t=91, l=-130, s=161.35, st=25 },
		["Leitstath"] = { c=106, t=517, l=-130, s=161.35, st=21 },
		["Maergrind"] = { c=106, t=185, l=-130, s=161.35, st=14 },
		["Watchers' Roost"] = { c=106, t=126, l=-130, s=161.35, st=25 },
		["Zidir-nesad"] = { c=106, t=144, l=-130, s=161.35, st=25 },
		}, z="Gundabad", a="Deepscrave", r=2, l="50.0s,117.1w" },
	["Bargstad"] = { t=2, ml=105, td="R52", ql=134, d={
		["Asbaj-khirfin"] = { c=106, t=56, l=-130, s=161.35, st=14 },
		["Aslíf"] = { c=106, t=220, l=-130, s=161.35, st=25 },
		["Bazanmanar"] = { c=106, t=363, l=-130, s=161.35, st=23 },
		["Fellgat"] = { c=106, t=288, l=-130, s=161.35, st=15 },
		["Grumachath"] = { c=106, t=206, l=-130, s=161.35, st=12 },
		["Hagbuth"] = { c=106, t=473, l=-130, s=161.35, st=13 },
		["Ibdekh-buzru"] = { c=106, t=395, l=-130, s=161.35, st=13 },
		["Imrekh-guthlu"] = { c=106, t=200, l=-130, s=161.35, st=12 },
		["Leitstath"] = { c=106, t=293, l=-130, s=161.35, st=10 },
		["Maergrind"] = { c=106, t=114, l=-130, s=161.35, st=15 },
		["Watchers' Roost"] = { c=106, t=303, l=-130, s=161.35, st=15 },
		["Zidir-nesad"] = { c=106, t=66, l=-130, s=161.35, st=14 },
		}, z="Gundabad", a="Pit of Stonejaws", r=2, l="44.1s,113.8w" },
	["Bazanmanar"] = { t=3, ml=105, td="R52", ql=138, d={
		["Asbaj-khirfin"] = { c=106, t=577, l=-130, s=161.35, st=23 },
		["Aslíf"] = { c=106, t=363, l=-130, s=161.35, st=26 },
		["Bargstad"] = { c=106, t=363, l=-130, s=161.35, st=23 },
		["Fellgat"] = { c=106, t=98, l=-130, s=161.35, st=26 },
		["Grumachath"] = { c=106, t=236, l=-130, s=161.35, st=23 },
		["Hagbuth"] = { c=106, t=80, l=-130, s=161.35, st=21 },
		["Ibdekh-buzru"] = { c=106, t=93, l=-130, s=161.35, st=26 },
		["Imrekh-guthlu"] = { c=106, t=424, l=-130, s=161.35, st=20 },
		["Leitstath"] = { c=106, t=327, l=-130, s=161.35, st=22 },
		["Maergrind"] = { c=106, t=516, l=-130, s=161.35, st=26 },
		["Watchers' Roost"] = { c=106, t=255, l=-130, s=161.35, st=20 },
		["Zidir-nesad"] = { c=106, t=486, l=-130, s=161.35, st=26 },
		}, z="Gundabad", a="Clovengap", r=2, l="36.9s,120.3w" },
	["Fellgat"] = { t=1, ml=105, td="R52", ql=139, d={
		["Asbaj-khirfin"] = { c=106, t=332, l=-130, s=161.35, st=16 },
		["Aslíf"] = { c=106, t=458, l=-130, s=161.35, st=28 },
		["Bargstad"] = { c=106, t=288, l=-130, s=161.35, st=15 },
		["Bazanmanar"] = { c=106, t=98, l=-130, s=161.35, st=26 },
		["Grumachath"] = { c=106, t=152, l=-130, s=161.35, st=16 },
		["Hagbuth"] = { c=106, t=179, l=-130, s=161.35, st=15 },
		["Ibdekh-buzru"] = { c=106, t=128, l=-130, s=161.35, st=15 },
		["Imrekh-guthlu"] = { c=106, t=521, l=-130, s=161.35, st=14 },
		["Leitstath"] = { c=106, t=404, l=-130, s=161.35, st=13 },
		["Maergrind"] = { c=106, t=400, l=-130, s=161.35, st=17 },
		["Watchers' Roost"] = { c=106, t=347, l=-130, s=161.35, st=16 },
		["Zidir-nesad"] = { c=106, t=554, l=-130, s=161.35, st=16 },
		}, z="Gundabad", a="Welkin-Lofts", r=2, l="49.4n,74.4w" },
	["Grumachath"] = { t=3, ml=105, td="R52", ql=135, d={
		["Asbaj-khirfin"] = { c=106, t=254, l=-130, s=161.35, st=14 },
		["Aslíf"] = { c=106, t=416, l=-130, s=161.35, st=24 },
		["Bargstad"] = { c=106, t=206, l=-130, s=161.35, st=12 },
		["Bazanmanar"] = { c=106, t=236, l=-130, s=161.35, st=23 },
		["Fellgat"] = { c=106, t=152, l=-130, s=161.35, st=16 },
		["Hagbuth"] = { c=106, t=315, l=-130, s=161.35, st=14 },
		["Ibdekh-buzru"] = { c=106, t=263, l=-130, s=161.35, st=15 },
		["Imrekh-guthlu"] = { c=106, t=365, l=-130, s=161.35, st=12 },
		["Leitstath"] = { c=106, t=96, l=-130, s=161.35, st=9 },
		["Maergrind"] = { c=106, t=323, l=-130, s=161.35, st=13 },
		["Watchers' Roost"] = { c=106, t=492, l=-130, s=161.35, st=13 },
		["Zidir-nesad"] = { c=106, t=280, l=-130, s=161.35, st=12 },
		}, z="Gundabad", a="Car Bronach", r=2, l="50.1n,68.4w" },
	["Hagbuth"] = { t=4, ml=105, td="R52", ql=138, d={
		["Asbaj-khirfin"] = { c=106, t=520, l=-130, s=161.35, st=16 },
		["Aslíf"] = { c=106, t=286, l=-130, s=161.35, st=23 },
		["Bargstad"] = { c=106, t=473, l=-130, s=161.35, st=13 },
		["Bazanmanar"] = { c=106, t=80, l=-130, s=161.35, st=21 },
		["Fellgat"] = { c=106, t=179, l=-130, s=161.35, st=15 },
		["Grumachath"] = { c=106, t=315, l=-130, s=161.35, st=14 },
		["Ibdekh-buzru"] = { c=106, t=174, l=-130, s=161.35, st=15 },
		["Imrekh-guthlu"] = { c=106, t=353, l=-130, s=161.35, st=12 },
		["Leitstath"] = { c=106, t=407, l=-130, s=161.35, st=16 },
		["Maergrind"] = { c=106, t=438, l=-130, s=161.35, st=14 },
		["Watchers' Roost"] = { c=106, t=185, l=-130, s=161.35, st=13 },
		["Zidir-nesad"] = { c=106, t=405, l=-130, s=161.35, st=14 },
		}, z="Gundabad", a="Clovengap", r=2, l="40.9s,120.0w" },
	["Ibdekh-buzru"] = { t=3, ml=105, td="R52", ql=139, d={
		["Asbaj-khirfin"] = { c=106, t=444, l=-130, s=161.35, st=16 },
		["Aslíf"] = { c=106, t=468, l=-130, s=161.35, st=29 },
		["Bargstad"] = { c=106, t=395, l=-130, s=161.35, st=13 },
		["Bazanmanar"] = { c=106, t=93, l=-130, s=161.35, st=26 },
		["Fellgat"] = { c=106, t=128, l=-130, s=161.35, st=15 },
		["Grumachath"] = { c=106, t=263, l=-130, s=161.35, st=15 },
		["Hagbuth"] = { c=106, t=174, l=-130, s=161.35, st=15 },
		["Imrekh-guthlu"] = { c=106, t=549, l=-130, s=161.35, st=14 },
		["Leitstath"] = { c=106, t=356, l=-130, s=161.35, st=12 },
		["Maergrind"] = { c=106, t=508, l=-130, s=161.35, st=16 },
		["Watchers' Roost"] = { c=106, t=341, l=-130, s=161.35, st=15 },
		["Zidir-nesad"] = { c=106, t=458, l=-130, s=161.35, st=15 },
		}, z="Gundabad", a="Welkin-Lofts", r=2, l="45.6n,73.0w" },
	["Imrekh-guthlu"] = { t=2, ml=105, td="R52", ql=131, d={
		["Asbaj-khirfin"] = { c=106, t=162, l=-130, s=161.35, st=13 },
		["Aslíf"] = { c=106, t=91, l=-130, s=161.35, st=25 },
		["Bargstad"] = { c=106, t=200, l=-130, s=161.35, st=12 },
		["Bazanmanar"] = { c=106, t=888, l=-130, s=161.35, st=20 },
		["Fellgat"] = { c=106, t=521, l=-130, s=161.35, st=14 },
		["Grumachath"] = { c=106, t=365, l=-130, s=161.35, st=12 },
		["Hagbuth"] = { c=106, t=353, l=-130, s=161.35, st=12 },
		["Ibdekh-buzru"] = { c=106, t=549, l=-130, s=161.35, st=14 },
		["Leitstath"] = { c=106, t=449, l=-130, s=161.35, st=9 },
		["Maergrind"] = { c=106, t=97, l=-130, s=161.35, st=13 },
		["Watchers' Roost"] = { c=106, t=184, l=-130, s=161.35, st=13 },
		["Zidir-nesad"] = { c=106, t=92, l=-130, s=161.35, st=12 },
		}, z="Gundabad", a="Mattugard", r=2, l="48.9s,115.0w" },
	["Leitstath"] = { t=1, ml=105, td="R52", ql=135, d={
		["Asbaj-khirfin"] = { c=106, t=345, l=-130, s=161.35, st=14 },
		["Aslíf"] = { c=106, t=517, l=-130, s=161.35, st=21 },
		["Bargstad"] = { c=106, t=293, l=-130, s=161.35, st=10 },
		["Bazanmanar"] = { c=106, t=327, l=-130, s=161.35, st=22 },
		["Fellgat"] = { c=106, t=404, l=-130, s=161.35, st=13 },
		["Grumachath"] = { c=106, t=96, l=-130, s=161.35, st=9 },
		["Hagbuth"] = { c=106, t=407, l=-130, s=161.35, st=16 },
		["Ibdekh-buzru"] = { c=106, t=356, l=-130, s=161.35, st=12 },
		["Imrekh-guthlu"] = { c=106, t=449, l=-130, s=161.35, st=9 },
		["Maergrind"] = { c=106, t=408, l=-130, s=161.35, st=13 },
		["Watchers' Roost"] = { c=106, t=578, l=-130, s=161.35, st=10 },
		["Zidir-nesad"] = { c=106, t=362, l=-130, s=161.35, st=12 },
		["Zudramdan"] = { c=106, t=192, l=-130, s=161.35, st=20 },
		}, z="Gundabad", a="Car Bronach", r=2, l="47.0n,64.9w" },
	["Maergrind"] = { t=4, ml=105, td="R52", ql=130, d={
		["Drenghol"] = { c=106, t=80, l=-130, s=161.35, st=15 },
		["Asbaj-khirfin"] = { c=106, t=81, l=-130, s=161.35, st=15 },
		["Aslíf"] = { c=106, t=185, l=-130, s=161.35, st=14 },
		["Bargstad"] = { c=106, t=114, l=-130, s=161.35, st=15 },
		["Bazanmanar"] = { c=106, t=516, l=-130, s=161.35, st=26 },
		["Fellgat"] = { c=106, t=400, l=-130, s=161.35, st=17 },
		["Grumachath"] = { c=106, t=323, l=-130, s=161.35, st=13 },
		["Hagbuth"] = { c=106, t=438, l=-130, s=161.35, st=14 },
		["Ibdekh-buzru"] = { c=106, t=508, l=-130, s=161.35, st=16 },
		["Imrekh-guthlu"] = { c=106, t=97, l=-130, s=161.35, st=13 },
		["Leitstath"] = { c=106, t=408, l=-130, s=161.35, st=13 },
		["Watchers' Roost"] = { c=106, t=273, l=-130, s=161.35, st=15 },
		["Zidir-nesad"] = { c=106, t=125, l=-130, s=161.35, st=15 },
		}, z="Gundabad", a="Mattugard", r=2, l="49.4s,112.0w" },
	["Watchers' Roost"] = { t=1, ml=105, td="R52", ql=137, d={
		["Asbaj-khirfin"] = { c=106, t=335, l=-130, s=161.35, st=17 },
		["Aslíf"] = { c=106, t=126, l=-130, s=161.35, st=15 },
		["Bargstad"] = { c=106, t=303, l=-130, s=161.35, st=15 },
		["Bazanmanar"] = { c=106, t=255, l=-130, s=161.35, st=20 },
		["Fellgat"] = { c=106, t=347, l=-130, s=161.35, st=16 },
		["Grumachath"] = { c=106, t=492, l=-130, s=161.35, st=13 },
		["Hagbuth"] = { c=106, t=185, l=-130, s=161.35, st=13 },
		["Ibdekh-buzru"] = { c=106, t=341, l=-130, s=161.35, st=15 },
		["Imrekh-guthlu"] = { c=106, t=184, l=-130, s=161.35, st=13 },
		["Leitstath"] = { c=106, t=578, l=-130, s=161.35, st=10 },
		["Maergrind"] = { c=106, t=273, l=-130, s=161.35, st=15 },
		["Zidir-nesad"] = { c=106, t=244, l=-130, s=161.35, st=16 },
		}, z="Gundabad", a="Gloomingtard", r=2, l="47.7s,121.8w" },
	["Zidir-nesad"] = { t=3, ml=105, td="R52", ql=132, d={
		["Minas Tirith(M)"] = { l=130, s=161.35, st=29 },
		["Minas Tirith(AB)"] = { l=130, s=161.35, st=24 },
		["South Bree"] = { l=130, s=161.35, st=18 },
		["Galtrev"] = { l=130, s=161.35, st=19 },
		["Asbaj-khirfin"] = { c=106, t=61, l=-130, s=161.35, st=16 },
		["Aslíf"] = { c=106, t=144, l=-130, s=161.35, st=25 },
		["Bargstad"] = { c=106, t=66, l=-130, s=161.35, st=14 },
		["Bazanmanar"] = { c=106, t=486, l=-130, s=161.35, st=26 },
		["Fellgat"] = { c=106, t=554, l=-130, s=161.35, st=16 },
		["Grumachath"] = { c=106, t=280, l=-130, s=161.35, st=12 },
		["Hagbuth"] = { c=106, t=405, l=-130, s=161.35, st=14 },
		["Ibdekh-buzru"] = { c=106, t=458, l=-130, s=161.35, st=15 },
		["Imrekh-guthlu"] = { c=106, t=92, l=-130, s=161.35, st=12 },
		["Leitstath"] = { c=106, t=362, l=-130, s=161.35, st=12 },
		["Maergrind"] = { c=106, t=125, l=-130, s=161.35, st=15 },
		["Watchers' Roost"] = { c=106, t=244, l=-130, s=161.35, st=16 },
		["Caras Galadhon"] = { l=130, s=161.35, st=16, r="D14" },
		["Edoras"] = { l=130, s=161.35, st=21 },
		["Erebor"] = { l=130, s=161.35, st=17 },
		["Felegoth"] = { l=130, s=161.35, st=16 },
		["Skarhald"] = { l=130, s=161.35, st=22 },
		["Rivendell Stables"] = { l=130, s=161.35, st=20 },
		}, z="Gundabad", a="Mattugard", r=2, l="45.6s,114.6w" },
	["Steepset"] = { td="R52", d={
		["Annak-khurfu(I)"] = { l=20, s=1, st=5, S0=true },
		["Akraz-zahar(I)"] = { l=20, s=1, st=1, S0=true },
		["Trestlebridge"] = { l=20, s=1, st=3, S0=true },
		["Zidir-nesad"] = { mt=22 },
		}, z="Gundabad", a="Mattugard", r=2, l="45.4s,115.0w"},
	}
rType = { D="Deed", Q="Quest", R="Rep", S="Req" }
Reqs = {
	D1 = "Silent and Restless",
	D2 = "Silent and Restless (Intermediate)",
	D3 = "Silent and Restless (Advanced)",
	D4 = "Silent and Restless (Final)",
	D5 = "Mysteries of Enedwaith",
	D6 = "Mysteries of Enedwaith (Intermediate)",
	D7 = "Mysteries of Enedwaith (Advanced)",
--	D8 = "Defender of the Upper Levels",
	D12= "Mirkwood Landing",
	D13= "Ally of Lothlorien",
	D14= "Defender of Lothlorien",
	D15= "Warrior of Lothlorien",
	D16= "Into the Black and Twisted Forest",
	D17= "Into the Black and Twisted Forest (Int.)",
	D18= "Into the Black and Twisted Forest (Adv.)",
	Q1 = "V1;B6;Ch 6: Challenging the Stone",
	Q2 = "The Frozen War",
	Q3 = "The Paths of Caras Galadhon",
	Q4 = "V2;B4;Ch 5: Into the Fire",
	Q5 = "V2;B2;Ch 8: The Twenty-first Hall",
	Q6 = "The Stable: Rebuild",
	Q7 = "V4;B9;Ch 2: The Eagles are Coming",
	Q8 = "BBM;Ch 11.2: The Same as You",
	Q9 = "Welcome to Lyndelby",
	R1 = "Acq. with Men of Bree",
	R2 = "Acq. with Elves of Rivendell",
	R3 = "Acq. with Lossoth of Forochel",
	R4 = "Acq. with Council of the North",
	R5 = "Acq. with Rangers of Esteldin",
	R6 = "Friend to Wardens of Annuminas",
	R7 = "Friend to Elves of Rivendell",
	R8 = "Friend to Galadhrim",
	R9 = "Friend to Thorin's Hall",
	R10= "Friend to Mathom Society",
	R11= "Friend to Men of Bree",
	R44= "Friend to Yonder-watch",
	R12= "Friend to Rangers of Esteldin",
	R13= "Friend to The Eglain",
	R14= "Friend to Lossoth",
	R15= "Friend to Council of the North",
	R16= "Friend to The Grey Company",
	R17= "Friend to Iron Garrison Guards",
	R18= "Friend to Iron Garrison Miners",
	R19= "Friend to Malledhrim",
	R20= "Friend to Men of Dunland",
	R21= "Friend to Algraig",
	R22= "Friend to Theodred's Riders",
	R23= "Friend to the Wold",
	R24= "Friend to the Norcrofts",
	R25= "Friend to the Sutcrofts",
	R26= "Friend to Riders of Stangard",
	R27= "Friend to Entwash Vale",
	R28= "Ally with Men of the Wold",
	R29= "Ally with Men of the Norcrofts",
	R30= "Ally with Men of the Sutcrofts",
	R31= "Ally with Men of Entwash Vale",
	R32= "Friend to People of Wildermore",
	R33= "Ally with The Eorlingas",
	R34= "Ally with The Helmingas",
	R35= "Ally with Dol Amroth",
	R36= "Ally with Pelargir",
	R37= "Ally with Rangers of Ithilien",
	R38= "Ally with Minas Tirith",
	R39= "Ally with Riders of Rohan",
	R40= "Ally with Host of the West",
	R41= "Kindred to Dwarves of Erebor",
	R42= "Kindred to Grey Mountains Exp.",
	R43 = "Kindred to Wilderfolk",
	R44 = "Kindred to Renewal of Gondor",
	R45 = "Kindred to Citizens of Umbar Baharbel",
	R46 = "Kindred to March on Gundabad",
	R47 = "Fabaral of Habanakka of Thrain",
	R48 = "Kindred to Protectors of Wilderland",
	R49 = "Respected in White Company",
	R50 = "Esteemed in Host of the West",
	R51 = "Kindred to Conquest of Gorgoroth",
	R52 = "Kindred to Reclaimers of the Mtn-Hold",
	S0 = "Current or past subscriber",
	S1 = "Requires VIP account",
	S2 = "Writ of Passage/Founder's discount",
	}
Reqs_list = {
	"S0","S2","R4","R2","R3","R1","R5","R7","R6","R8","R28","R29",
	"R31","R30","Q1","Q2","Q3","Q4","Q5","Q6","Q7","Q8","Q9","D1",
	"D2","D3","D4","D5","D6","D7","D13","D14","D15","D16","D17","D18" }
-- TD_list = { "R0","R9","R10","R11","R12","R13","R7","R6","R14","R15",
-- 	"R17","R18","R8","R16","R21","R19","R20","R22","R26","R23","R24",
-- 	"R25","R27","R32","R33","R34","R35","R36","R37","R38","R39",
-- 	"R40","R41","R42","R43","R44","R45" }
TD_list = { R6=.9,R7=.9,R8=.9,R9=.9,R10=.9,R11=.9,R12=.9,R13=.9,R14=.9,
	R15=.9,R16=.9,R17=.9,R18=.9,R19=.9,R20=.9,R21=.9,R22=.9,R23=.75,
	R24=.75,R25=.75,R26=.9,R27=.75,R32=.75,R33=.75,R34=.75,R35=.75,
	R36=.75,R37=.75,R38=.75,R39=.75,R40=.75,R41=.75,R42=.75,R43=.75,R44=.75,
	R45=.75,R46=.75,R47=.75,R48=.75,R49=.75,R50=.75,R51=.75,R52=.75 }

-- "Return to" list, d=action, id=purchase
Return = { nm = "Return to", tb="RT",
	["Thorin's Gate"] = { r=Turbine.Gameplay.Race.Dwarf, rd="06346",
					t=45, d="1BF91", tl=10, id="1BF8D" },
	["Michel Delving"] = { r=Turbine.Gameplay.Race.Hobbit, rd="062C8",
					t=20, d="23262", tl=10, n="The Shire" },
	["West Bree"] = { r=Turbine.Gameplay.Race.Man, rd="062F6",
					t=12, d="1BF90", tl=10, id="1BF8C", n="Bree" },
	["Lalia's Market"] = { t=13, d="364B1", tl=5, id="364B0" },
	["Last Homely House"] = { r=Turbine.Gameplay.Race.Elf, rd="0631F", 
					t=50, d="23263", tl=10, n="Rivendell" },
	["Tracery Archives"] = { t=2, d="634A5", tl=20, id="634A9" },
	["Ost Guruth"] = { t=7, d="20441", tl=10 },
	["Nobottle"] = { t=2, d="61340", tl=20, id="61341" },
	["Andrath"] = { t=2, d="6323D", tl=20, id="6323A" },
	["Clegur"] = { t=2, d="64F47", tl=20, id="64F4B" },
	["Herne"] = { t=2, d="634AE", tl=20, id="634AF", n="Cardolan" },
	["Lhan Garan"] = { t=2, d="634A4", tl=20, id="634A8", n="Swanfleet" },
	["Caras Galadhon"] = { r=Turbine.Gameplay.Race.HighElf, rd="303DF",
        			t=24, tl=32 }, -- ***
--	["Zidir-nesad"] = { t=9, d="686FE", tl=20, id="68729", n="Hall of Vérnozal" },
	["Tornhad"] = { t=2, d="60EA8", tl=38, id="60EAA" },
	["Trestlebridge(R)"] = { t=6, d="59D12", tl=40, id="59D05", n="Trestlebridge" },
	["Trader's Wharf(B)"] = { t=2, d="59D0E", tl=40, id="59D03", n="Trader's Wharf" },
	["Ost Galadh"] = { t=20, d="1F374", tl=51, id="1F372", n="Mirkwood" },
	["Lhanuch"] = { t=14, d="21FA2", tl=50, id="2238E", n="Enedwaith" },
	["Galtrev"] = { t=17, d="2C647", tl=70, id="2C64A" },
	["Stangard"] = { t=29, d="2C65D", tl=70, id="2C65E" },
	["Snowbourn"] = { t=22, d="31A46", tl=80, id="31A42" },
	["Forlaw"] = { t=14, d="36B5E", tl=85, id="36B4A" },
	["Aldburg"] = { t=5, d="3DC81", tl=85, id="3DC7B" },
	["Helm's Deep"] = { t=1, d="3DC82", tl=85, id="3DC7E" },
	["Derndingle"] = { t=26, d="4128F", tl=85, id="41290" },
	["Dol Amroth"] = { t=34, d="411AC", tl=95, id="411AD" },
	["Arnach"] = { t=17, d="43A6A", tl=100, id="43A6B" },
	["Minas Tirith"] = { t=9, d="4497E", tl=100, id="4497F" },
	["the War-stead"] = { t=9, d="459A9", tl=100, id="459A6" },
	["Minas Tirith(AB)"] = { t=9, d="46CC0", tl=100, id="46CBA", n="a-b Minas Tirith" },
	["Osgiliath"] = { t=9, d="4707D", tl=100, id="47092", n="a-b Osgiliath" },
	["Henneth Annun"] = { t=9, d="47080", tl=100, id="47091" },
	["Camp of the Host"] = { t=9, d="47BF4", tl=100, id="47BF7" },
	["Haerondir"] = { t=9, d="47C1B", tl=100, id="47C22" },
	["Udun Foothold"] = { t=9, d="4AE1D", tl=100, id="4AE22" },
	--	["Minas Tirith(AB)"] = { t=9, d="686FE", tl=110, id="68729", n="Hall of the King" },
	["Dale"] = { t=6, d="4D738", tl=115, id="4D73E" },
	["Jarnfast"] = { t=9, d="4FAC3", tl=115, id="4FACF" },
	["Skarhald"] = { t=9, d="4FAC5", tl=115, id="4FAD4" },
	["Hultvis"] = { t=22, d="52F04", tl=116, id="52F0F" },
	["Beorninghus"] = { r=Turbine.Gameplay.Race.Beorning, rd="41A22",
					t=9, d="52F12", tl=116, id="52F0D" },
	["Estolad Lan"] = { t=9, d="551F8", tl=121, id="551F6" },
	["Limlok"] = { t=9, d="57629", tl=130, id="5762A" },
	["Lyndelby"] = { r=Turbine.Gameplay.Race.RiverHobbit, rd="57629",
					t=20, tl=125 },
	["Annak-khurfu"] = { t=9, d="5856F", tl=130, id="58575" },
	["Akraz-zahar(I)"] = { t=2, d="5AA90", tl=130, id="5AAA3", n="Akraz-zahar" },
	["Amdan"] = { t=24, d="5AA92", tl=130, id="5AAA1", n="Azanulbizar" },
	["Maergrind"] = { t=19, d="5D47C", tl=131, id="5D483", n="Noble Gate" },
	["Leitstath"] = { t=9, d="5D484", tl=135, id="5D479" },
	["Pelargir West Gate"] = { t=9, d="658EB", tl=135, id="658F0", n="Pelargir" },
	["Dol Amroth(KG)"] = { t=9, d="68700", tl=135, id="6872A" },
	["Lond Cirion"] = { t=9, d="68703", tl=135, id="68722" },
	["Jax Phanal(B)"] = { t=9, d="68701", tl=135, id="6871F", n="Jax Phanal" },
	["Halrax(B)"] = { t=9, d="68702", tl=135, id="68727", n="Halrax" },
	-- Journey to the Order of the Eagle @ 20.1s,96.5w
	["Umbar Baharbel(E)"] = { t=28, d="686FE", tl=135, id="68729",
	 n="Order of the Eagle", j=true },
	["Umbar Baharbel(W)"] = { t=1, d="686FF", tl=135, id="6871D", n="Umbar" },
	["Bloody Eagle Tavern(I)"] = { t=30, d="697F2", tl=140, id="697F1", n="Bloody Eagle Tavern" },
	["Umbar Baharbel(N)"] = { t=15, d="68704", tl=140, id="6871A",
	 n="Ledger-keepers", j=true },--
	}

-- "Guide to" list, Q=quest, L=level
Guide = { nm = "Guide to", tb="GT",
	["Michel Delving"] = { t=20, d="0A2C3", tl=22, id="L" },
	["Thorin's Gate"] = { t=45, d="03F41", tl=24, id="L", n="Thorin's Hall" },
	["West Bree"] = { t=9, d="03F42", tl=32, id="L", n="Bree" },
	["Nobottle"] = { t=2, d="6133F", tl=20, id="61343" },
	["Andrath"] = { t=2, d="6323C", tl=20, id="6323E" },
	["Clegur"] = { t=2, d="64F4C", tl=20, id="64F46" },
	["Herne"] = { t=2, d="634A7", tl=20, id="634B7", n="Cardolan" },
	["Lhan Garan"] = { t=2, d="634AA", tl=20, id="634B2", n="Swanfleet" },
	["Ost Guruth"] = { t=23, d="0A2C2", tl=26, id="Q", q="22405" },
	["Esteldin"] = { t=15, d="03F43", tl=34, id="L" },
	["Tinnudir"] = { t=20, d="0A2C4", tl=36, id="Q", q="22408", n="Evendim" },
	["Tornhad"] = { t=2, d="60EA6", tl=38, id="60EA9" },
	["Last Homely House"] = { t=24, d="03F44", tl=46, id="L", n="Rivendell" },
	["Trestlebridge(R)"] = { t=6, d="59D16", tl=40, id="59D15", n="Trestlebridge" },
	["Trader's Wharf(B)"] = { t=2, d="59D0C", tl=40, id="59D0B", n="Trader's Wharf" },
	["Hrimbarg"] = { t=13, d="2E756", tl=40, id="2E757", n="Misty Mountains" },
	["Aughaire"] = { t=40, d="0A2C5", tl=44, id="Q", q="2240B", n="West Angmar" },
	["Gath Forthnir"] = { t=15, d="0A2C6", tl=48, id="Q", q="2240A", n="East Angmar" },
	["Suri-kyla"] = { t=27, d="17C82", tl=48, id="17C7C" },
	["Echad Dunnan"] = { t=17, d="17C81", tl=50, id="Q", q="17C7B" },
	["Twenty-first Hall"] = { t=17, d="17C7A", tl=56, id="17C7D" },
	["Inner Caras Galadhon"] = { t=51, d="2E754", tl=60, id="2E755", n="Caras Galadhon" },
	["Echad Sirion"] = { t=14, d="1F459", tl=62, id="1F45B", n="Mirk-eaves" },
	["Harndirion"] = { t=36, d="235EF", tl=62, id="235F0" },
	["Galtrev"] = { t=20, d="2A93F", tl=70, id="2A93E" },
	["Stangard"] = { t=25, d="2C62C", tl=75, id="2C648" },
	["Snowbourn"] = { t=14, d="3198E", tl=80, id="31A43" },
	["Forlaw"] = { t=14, d="36B5D", tl=85, id="36B4B" },
	["Aldburg"] = { t=5, d="3DC71", tl=95, id="3DC7C" },
	["Helm's Deep"] = { t=1, d="3DC72", tl=95, id="3DC80" },
	["Dol Amroth"] = { t=34, d="41197", tl=95, id="41194" },
	["Arnach"] = { t=17, d="43A63", tl=100, id="43A65" },
	["Minas Tirith"] = { t=8, d="44985", tl=100, id="44986" },
	["the War-stead"] = { t=8, d="459AF", tl=100, id="459AE" },
	["Minas Tirith(AB)"] = { t=8, d="46CBB", tl=100, id="46CC9", n="a-b Minas Tirith" },
	["Osgiliath"] = { t=8, d="47074", tl=100, id="4707E", n="a-b Osgiliath" },
	["Henneth Annun"] = { t=8, d="47077", tl=100, id="4707F" },
	["Camp of the Host"] = { t=8, d="47BFA", tl=100, id="47BF5" },
	["Haerondir"] = { t=8, d="47C1D", tl=100, id="47C20" },
	["Udun Foothold"] = { t=8, d="4AE1E", tl=100, id="4AE20" },
	["Dale"] = { t=6, d="4D73B", tl=115, id="4D73F" },
	["Jarnfast"] = { t=8, d="4FACC", tl=115, id="4FAD3" },
	["Skarhald"] = { t=8, d="4FACB", tl=115, id="4FAD1" },
	["Hultvis"] = { t=22, d="52F08", tl=116, id="52F14" },
	["Beorninghus"] = { t=8, d="52F07", tl=116, id="52F13" },
	["Estolad Lan"] = { t=8, d="551F4", tl=121, id="551F1" },
	["Limlok"] = { t=8, d="5762D", tl=130, id="57633" },
	["Annak-khurfu"] = { t=9, d="58571", tl=130, id="58576" },
	["Akraz-zahar(I)"] = { t=12, d="5AA91", tl=130, id="5AAA4", n="Akraz-zahar" },
	["Amdan"] = { t=24, d="5AA95", tl=130, id="5AAA0", n="Azanulbizar" },
	["Maergrind"] = { t=19, d="5D487", tl=131, id="5D47F", n="Noble Gate" },
	["Leitstath"] = { t=14, d="5D47D", tl=135, id="5D47B" },
	["Pelargir West Gate"] = { t=12, d="658EA", tl=135, id="658EC", n="Pelargir" },
	["Dol Amroth(KG)"] = { t=14, d="68711", tl=135, id="6872B" },
	["Lond Cirion"] = { t=14, d="68717", tl=135, id="6872E" },
	["Jax Phanal(B)"] = { t=14, d="68719", tl=135, id="68723", n="Jax Phanal" },
	["Halrax(B)"] = { t=17, d="68713", tl=135, id="68724", n="Halrax" },
	["Umbar Baharbel(W)"] = { t=14, d="68718", tl=135, id="6871E", n="Umbar" },
	["Bloody Eagle Tavern(I)"] = { t=30, d="697EF", tl=140, id="697ED", n="Bloody Eagle Tavern" },
--	["Upper Ward"] = { t=9, d="68704", tl=135, id="68729", n="Ledger-keepers" },
	}

-- "Muster in" list
Muster = { nm = "Muster in", tb="MT",
	["Nobottle"] = { t=2, d="6133E", tl=20, id="61342" },
	["Andrath"] = { t=2, d="63242", tl=20, id="6323B" },
	["Clegur"] = { t=2, d="64F4D", tl=20, id="64F48" },
	["Herne"] = { t=2, d="634AD", tl=20, id="634B3", n="Cardolan" },
	["Lhan Garan"] = { t=2, d="634B6", tl=20, id="634AC", n="Swanfleet" },
	["Ost Guruth"] = { t=2, d="14786", tl=23, id="L" },
	["Esteldin"] = { t=15, d="14798", tl=32, id="L" },
	["Tornhad"] = { t=2, d="60EA5", tl=38, id="60EAB" },
	["Tinnudir"] = { t=20, d="1478E", tl=38, n="Evendim", id="L" },
	["Last Homely House"] = { t=24, d="14791", tl=44, id="L", n="Rivendell" },
	["Trestlebridge(R)"] = { t=6, d="59D10", tl=40, id="59D14", n="Trestlebridge" },
	["Trader's Wharf(B)"] = { t=2, d="59D09", tl=40, id="59D11", n="Trader's Wharf" },
	["Hrimbarg"] = { t=13, d="303DD", tl=40, id="303DB", n="Misty Mountains" },
	["Suri-kyla"] = { t=27, d="237D4", tl=48, id="237D5" },
	["Twenty-first Hall"] = { t=17, d="1819E", tl=56, id="1819F" },
	["Caras Galadhon"] = { t=51, d="303DF", tl=60, id="303E0" },
	["Echad Sirion"] = { t=14, d="1F45C", tl=62, id="1F45D", n="Mirk-eaves" },
	["Harndirion"] = { t=36, d="235EB", tl=62, id="235EE" },
	["Galtrev"] = { t=20, d="2A90A", tl=70, id="2A90B" },
	["Stangard"] = { t=25, d="2C646", tl=75, id="2C649" },
	["Snowbourn"] = { t=14, d="3198D", tl=80, id="31A44" },
	["Forlaw"] = { t=14, d="36B5B", tl=85, id="36B60" },
	["Aldburg"] = { t=5, d="3DC7A", tl=95, id="3DC7D" },
	["Helm's Deep"] = { t=1, d="3DC79", tl=95, id="3DC7F" },
	["Dol Amroth"] = { t=34, d="41198", tl=95, id="41195" },
	["Arnach"] = { t=17, d="43A66", tl=100, id="43A64" },
	["Minas Tirith"] = { t=9, d="44982", tl=100, id="44987" },
	["Minas Tirith(AB)"] = { t=9, d="46CBF", tl=100, id="46CC6", n="a-b Minas Tirith" },
	["the War-stead"] = { t=9, d="459AA", tl=100, id="459AD" },
	["Osgiliath"] = { t=9, d="47076", tl=100, id="47083", n="a-b Osgiliath" },
	["Henneth Annun"] = { t=9, d="47075", tl=100, id="47082" },
	["Camp of the Host"] = { t=9, d="47BFC", tl=100, id="47BF8" },
	["Haerondir"] = { t=9, d="47C23", tl=100, id="47C1C" },
	["Udun Foothold"] = { t=8, d="4AE1F", tl=100, id="4AE23" },
	["Dale"] = { t=6, d="4D73A", tl=115, id="4D73D" },
	["Jarnfast"] = { t=8, d="4FACA", tl=115, id="4FAD0" },
	["Skarhald"] = { t=8, d="4FACD", tl=115, id="4FAD2" },
	["Hultvis"] = { t=22, d="52F06", tl=116, id="52F09" },
	["Beorninghus"] = { t=8, d="52F0A", tl=116, id="52F05" },
	["Estolad Lan"] = { t=8, d="551F2", tl=121, id="551F5" },
	["Limlok"] = { t=8, d="57635", tl=130, id="57624" },
	["Annak-khurfu"] = { t=14, d="58572", tl=130, id="58577" },
	["Akraz-zahar(I)"] = { t=12, d="5AA8F", tl=130, id="5AAA5", n="Akraz-zahar" },
	["Amdan"] = { t=24, d="5AA8C", tl=130, id="5AAA2", n="Azanulbizar" },
	["Maergrind"] = { t=19, d="5D48A", tl=131, id="5D482", n="Noble Gate" },
	["Leitstath"] = { t=14, d="5D488", tl=135, id="5D48B" },
	["Pelargir West Gate"] = { t=12, d="658E8", tl=135, id="658E9", n="Pelargir" },
	["Dol Amroth(KG)"] = { t=14, d="68712", tl=135, id="68725" },
	["Lond Cirion"] = { t=14, d="68715", tl=135, id="68726" },
	["Jax Phanal(B)"] = { t=14, d="6870C", tl=135, id="6871C", n="Jax Phanal" },
	["Halrax(B)"] = { t=17, d="68710", tl=135, id="6871B", n="Halrax" },
	["Umbar Baharbel(W)"] = { t=14, d="6870F", tl=135, id="68720", n="Umbar" },
	["Bloody Eagle Tavern(I)"] = { t=30, d="697F3", tl=140, id="697EC", n="Bloody Eagle Tavern" },
	}

-- "Sail to" list
Sail = { nm = "Sail to", tb="ST",
	["Celondim"] = { t=25, d="66100", tl=7, id="L" },
	["Tharbad"] = { t=14, d="66120", tl=7, id="L" },
	["Buckland(B)"] = { t=14, d="6611A", tl=15, id="L", n="Buckland" },
	["Tinnudir(B)"] = { t=13, d="6610F", tl=35, id="L", n="Tinnudir" },
	["Suri-kyla"] = { t=27, d="6611C", tl=35, id="674A4" },
	["Trader's Wharf(B)"] = { t=13, d="66105", tl=38, id="674AA", n="Trader's Wharf" },
	["Lothlorien(B)"] = { t=3, d="6611E", tl=60, id="L", n="Lothlorien" },
	["Echad Sirion"] = { t=12, d="6610E", tl=60, id="674A6", n="Mirk-eaves" },
	["Brown Lands"] = { t=25, d="66101", tl=65, id="674A9" },
	["Snowbourn"] = { t=13, d="66121", tl=70, id="674A8" },
	["Dol Amroth(D)"] = { t=14, d="66117", tl=90, id="674A1", n="Dol Amroth" },
	["Osgiliath"] = { t=14, d="66109", tl=100, id="674A7", n="a-b Osgiliath" },
	["Lake-town"] = { t=24, d="6610C", tl=110, id="674A5" },
	["Pelargir(B)"] = { t=14, d="6611B", tl=135, id="674A2", n="Pelargir" },
	["Dol Amroth(B)"] = { t=18, d="687C1", tl=135, id="687C2" },
	["Lond Cirion(B)"] = { t=15, d="687BD", tl=135, id="687BC", n="Pelargir" },
	["Jax Phanal(B)"] = { t=14, d="687C0", tl=140, id="687BF", n="Lond Cirion" },
	["Halrax(B)"] = { t=17, d="687C3", tl=140, id="687BE", n="Halrax" },
	["Umbar Baharbel(B)"] = { t=15, d="687BD", tl=140, id="687BA", n="Umbar" },
	}

Coin = {
	["0AC2B"] = "Dourhand Crest",
	["0AC5F"] = "Barrow-treasure",
	["18E34"] = "Lothlórien Silver Branch",
	["1F098"] = "Malledhrim Gold Star Emblem",
	["1F099"] = "Malledhrim Bronze Feather",
	["20A7C"] = "Silver Token of the Wilds",
	["20A7E"] = "Golden Token of the Wilds",
	["2C4ED"] = "Silver Token of the Anduin",
	["2E28D"] = "Silver Token of the Riddermark",
	["32BB7"] = "Mithril Coin",
	["3391C"] = "Wildermore Coin",
	["366C8"] = "Westemnet Iron Coin",
	["3E365"] = "Fangorn Leaf",
	["3EF49"] = "Amroth Silver Piece",
	["3EF4A"] = "East Gondor Silver Piece",
--	["411F5"] = "Central Gondor Silver Pieces",
	["440D9"] = "Minas Tirith Silver Piece",
	["44EEC"] = "Polished Marble Trinket",
	["45BED"] = "Host of the West Silver Piece",
	["487E5"] = "Silver Signet of the Thandrim",
	["4CB62"] = "Token of the Lake and Rivers",
	["4E31F"] = "Mark of the Longbeards",
	["5278D"] = "Gúlmark",
	["52993"] = "Vales - Beorning Token",
	["53682"] = "Sigil of Imlad Ithil",
	["56D17"] = "Northern Gúlmark",
	["57CBA"] = "Copper Coin of Gundabad",
	["591B8"] = "Mark of the Wilds",
	["59346"] = "Zakaf-beshek",
	["59FCB"] = "Silver Coin of Gundabad",
	["5A640"] = "Token of the Kharum-ubnâr",
	["605CE"] = "Copper Bounder's Coin",
	["60759"] = "Mark of the Angle",
	["61B80"] = "Iron Coin of Cardolan",
	["6330C"] = "Greyflood Mark",
	["65032"] = "Marks of Renewal",
	["65F33"] = "Umbari Tâm",
	["67CC3"] = "Ledger-keeper Mark",
	["67CC0"] = "Small gift of Ûr",
	}

B1 = { n="Baglan", l="37.6s,49.8w", c=25, id="6330C" }
B2 = { n="Ordlaf", l="25.5s,63.3w", c=5, id="2C4ED" }
B3 = { l="74.9s,71.4w", c=25, id="3EF49" }
B4 = { l="63.1s,7.2w", c=20, id="45BED" }
B5 = { l="40.9s,10.4w", c=40, id="45BED" }
B6 = { l="34.7n,45.4w", c=5, id="4E31F" }
B7 = { l="49.4s,111.9w", c=20, id="59FCB" }
B8 = { l="83.0s,34.7w", c=10, id="65032" }
B9 = { l="17.4s,98.4w", c=10, id="65F33" }

Barter = { 
	["Thorin's Gate"] = { n="Torth", l="13.7s,103.2w", c=100, id="0AC2B" },
	["Lhan Garan"] = { l="45.2s,39.5w", c=10, id="61B80" },
	["Nobottle"] = { l="27.0s,78.9w", c=10, id="605CE" },
	["West Bree"] = { n="Tad Leafcuter", l="31.8s,51.4w", c=100, id="0AC5F" },
	["Lalia's Market"] = { n="Lalia", l="30.2s,51.3w", c=3, id="32BB7" },
	["Herne"] = { l="45.2s,39.5w", c=10, id="61B80" },
	["Andrath"] = B1,
	["Clegur"] = B1,
	["Ost Guruth"] = { n="Frideric the Elder", l="31.5s,29.5w" },
	["Tornhad"] = { l="42.5s,23.3w", c=15, id="60759" },
	["Tinnudir"] = { n="Horace Roxhythe", l="12.5s,67.3w" },
	["Trestlebridge(R)"] = { l="17.7s,54.4w", c=25, id="591B8" },
	["Trader's Wharf(B)"] = { l="21.4s,61.4w", c=25, id="591B8" },
	["Hrimbarg"] = { n="Afwald", l="24.5s,7.0e", c=128 },
	["Aughaire"] = { n="Torcal", l="0.1n,39.2w" },
	["Gath Forthnir"] = { n="Maerchiniath", l="10.9n,23.9w" },
	["Suri-kyla"] = { n="Rusu", l="19.5n,72.0w", c=130.72 },
	["Tracery Archives"] = { n="Loot" },
	["Echad Dunnan"] = { n="Tinúriel", l="50.5s,7.9w" },
	["Twenty-first Hall"] = { n="Kettil", l="5.9s,105.0w", c=153.6 },
	["Inner Caras Galadhon"] = { n="Malenfileg", l="15.6s,67.7w", c=20, id="18E34" },
	["Echad Sirion"] = { n="Estellien", l="15.1d,61.5w", c=1, id="1F099" },
	["Ost Galadh"] = { n="Millaesil", l="12.6s,46.4w", c=10, id="1F098" },
	["Lhanuch"] = { n="Mabon", l="66.5s,17.2w", c=20, id="20A7E" },
	["Harndirion"] = { n="Legrindavor", l="69.4s,13.8w", c=5, id="20A7C" },
	["Galtrev"] = { n="Dunlending Qm", l="80.4s,16.8w", c=167.2 },
	["Stangard"] = B2,
	["Brown Lands"] = B2,
	["Snowbourn"] = { l="60.4s,62.2w", c=50, id="2E28D" },
	["Forlaw"] = { n="Ethelmund", l="39.4s,60.7w", c=50, id="3391C" },
	["Aldburg"] = { l="69.3s,64.6w", c=100, id="366C8" },
	["Helm's Deep"] = { l="69.3s,64.6w", c=125, id="366C8" },
	["Derndingle"] = { n="Quickbeam", l="42.1s,79.1w", c=10, id="3E365" },
	["Dol Amroth"] = B3,
	["Dol Amroth(D)"] = B3,
	["Arnach"] = { l="77.4s,24.6w", c=10, id="3EF4A" },
	["Minas Tirith"] = { l="65.9s,16.8w", c=30, id="440D9" },
	["Minas Tirith(AB)"] = { l="65.7s,16.9w", c=30, id="440D9" },
	["the War-stead"] = { l="45.5s,27.3w", c=3, id="44EEC" },
	["Osgiliath"] = B4,
	["Henneth Annun"] = B4,
	["Camp of the Host"] = B5,
	["Haerondir"] = B5,
	["Udun Foothold"] = { l="41.5s,0.7w", c=10, id="487E5" },
	["Dale"] = { l="25.0n,25.1w", c=10, id="4CB62" },
	["Lake-town"] = { l="25.0n,25.1w", c=10, id="4CB62" },
	["Skarhald"] = B6,
	["Jarnfast"] = B6,
	["Hultvis"] = { l="7.9n,58.5w", c=20, id="5278D" },
	["Beorninghus"] = { l="7.9n,58.5w", c=20, id="52993" },
	["Estolad Lan"] = { l="64.5s,2.0w", c=20, id="53682" },
	["Limlok"] = { l="20.9n,55.9w", c=20, id="56D17" },
	["Annak-khurfu"] = { l="32.8n,61.2w", c=25, id="57CBA" },
	["Akraz-zahar(I)"] = { n="Vorthur Smokebreath", l="14.7n,136.1w", c=10, id="5A640" },
	["Amdan"] = { l="63.5n,135.0w", c=7, id="59346" },
	["Maergrind"] = B7,
	["Leitstath"] = B7,
	["Pelargir West Gate"] = B8,
	["Pelargir(B)"] = B8,
	["Dol Amroth(KG)"] = B8,
	["Dol Amroth(B)"] = B8,
	["Lond Cirion"] = B8,
	["Lond Cirion(B)"] = B8,
	["Jax Phanal(B)"] = B9,
	["Halrax(B)"] = B9,
	["Umbar Baharbel(W)"] = B9,
	["Umbar Baharbel(B)"] = B9,
	["Bloody Eagle Tavern(I)"] = { l="19.7s,97.6w", c=10, id="67CC3" },
	["Umbar Baharbel(N)"] = { n="Aphamâr", l="17.4s,98.4w", c=160, id="67CC0" },
	}
-- Travel to house
House = {
	["Personal"] = "0D046",
	["Kinship"] = "0D047",
	["Premium"] = "46EE4",
	["Kinship Member's"] = "57C36",
	}
None = "<none>"
house = { None }
for name in pairs(House) do
	table.insert(house,name)
end
table.sort(house)

-- Milestone action codes
Miles = {"256BA","25792","25793","25794","25795","25796",
	"2FF5E","2FF5F","2FF60","2FF61","2FF62","2FF63"}

-- Zone minimum levels
Zlvl = {["Angmar"]=35, ["Azanulbizar"]=123, ["Bree-Land"]=-1, ["Cape of Umbar"]=140, 
	["Cardolan"]=10, ["Central Gondor"]=93, ["Dunland"]=58, ["Dwarf-holds"]=109, 
	["East Gondor"]=93, ["East Rohan"]=69, ["Elderslade"]=123, ["Enedwaith"]=54, 
	["Ered Luin"]=-3, ["Eregion"]=41, ["Evendim"]=23, ["Far Anorien"]=94, 
	["Forochel"]=38, ["Gorgoroth"]=99, ["Great River"]=63, ["Gundabad"]=124, 
	["King's Gondor"]=133, ["Lone-lands"]=16, ["Lothlorien"]=52, ["March of the King"]=98, 
	["Mirkwood"]=54, ["Misty Mountains"]=33, ["Mordor Besieged"]=114, ["Morgul Vale"]=116, 
	["Moria"]=44, ["North Downs"]=17, ["Old Anorien"]=93, ["Outer Gondor"]=136, 
	["Strongholds"]=108, ["Swanfleet"]=-3, ["Trollshaws"]=28, ["Vales of Anduin"]=113, 
	["Wells of Langflood"]=123, ["West Gondor"]=88, ["West Rohan"]=78, ["Wildermore"]=78, 
	["Yondershire"]=15, ["Zirer Tarka"]=138, ["The Shire"]=-3, ["The Wastes"]=98,
}

Vaults = { 
	Eriador = {
		{l="28.0s,92.9w", z="Ered Luin", n="Celondim"},
		{l="25.9s,90.7w", z="Ered Luin", n="Falathlorn Homesteads"},
		{l="13.7s,103.2w", z="Ered Luin", n="Thorin's Hall"},
		{l="15.1s,107.7w", z="Ered Luin", n="Thorin's Hall Homesteads"},
		{l="33.3s,75.0w", z="The Shire", n="Michel Delving"},
		{l="34.6s,75.5w", z="The Shire", n="Michel Delving Crafting"},
		{l="36.9s,73.7w", z="The Shire", n="Shire Homesteads"},
		{l="49.6s,45.2w", z="Cardolan", n="Herne Auction"},
		{l="54.6s,27.6w", z="Swanfleet", n="Lhan Garan"},
		{l="29.6s,52.6w", z="Bree-Land", n="Bree Vault"},
		{l="30.0s,51.3w", z="Bree-Land", n="Lalia's Market"},
		{l="30.5s,51.0w", z="Bree-Land", n="Bree Crafting"},
		{l="31.9s,50.6w", z="Bree-Land", n="Bree Auction"},
		{l="35.9s,47.1w", z="Bree-Land", n="Bree-Land Homesteads"},
		{l="20.9s,13.4w", z="Ettenmoors", n="Glan Vraig"},
		{l="9.7s,40.5w", z="North Downs", n="Esteldin"},
		{l="29.8s,3.4w", z="Trollshaws", n="Rivendell"},
		{l="12.5s,67.3w", z="Evendim", n="Tinnudir"},
		{l="19.5n,72.0w", z="Forochel", n="Suri-kyla"},
		{l="66.5s,17.2w", z="Enedwaith", n="Lhanuch"},
		{l="79.9s,17.0w", z="Dunland", n="Galtrev Crafting"},
		{l="80.1s,17.1w", z="Dunland", n="Galtrev Auction"},
	},
	Rhovanion = {
		{l="6.5s,104.9w", z="Moria", n="Twenty-first Hall"},
		{l="15.6s,67.8w", z="Lothlorien", n="Caras Galadhon"},
		{l="14.2s,51.5w", z="Mirkwood", n="Ost Galadh"},
		{l="14.5s,51.1w", z="Mirkwood", n="Ost Galadh Crafting"},
		{l="26.5s,63.5w", z="Great River", n="Stangard"},
		{l="40.1s,52.0w", z="East Rohan", n="Harwick"},
		{l="39.4s,53.1w", z="East Rohan", n="Harwick Crafting"},
		{l="61.3s,61.6w", z="East Rohan", n="Snowbourn Auction"},
		{l="60.9s,62.0w", z="East Rohan", n="Snowbourn Crafting"},
		{l="39.3s,60.8w", z="Wildermore", n="Forlaw"},
		{l="38.8s,60.6w", z="Wildermore", n="Forlaw Crafting"},
		{l="14.6n,135.8w", z="Strongholds", n="Erebor"},
		{l="69.1s,64.3w", z="West Rohan", n="Aldburg Auction"},
		{l="69.3s,64.9w", z="West Rohan", n="Aldburg Crafting"},
		{l="64.4s,89.3w", z="West Rohan", n="Helm's Deep"},
		{l="14.7n,135.2w", z="Strongholds", n="Hall Under the Mountain"},
		{l="24.9n,25.7w", z="Strongholds", n="Dale"},
		{l="17.1n,27.2w", z="Strongholds", n="Lake-town"},
		{l="36.5n,46.4w", z="Dwarf-holds", n="Skarhald"},
		{l="28.5n,3.5w", z="Dwarf-holds", n="Jarnfast"},
		{l="45.6s,114.6w", z="Gundabad", n="Zidir-nesad"},
	},
	Gondor = {
		{l="74.6s,71.1w", z="West Gondor", n="Dol Amroth"},
		{l="88.8s,66.3w", z="West Gondor", n="Cape of Belfalas West"},
		{l="92.5s,62.2w", z="West Gondor", n="Cape of Belfalas South"},
		{l="91.6s,60.9w", z="West Gondor", n="Cape of Belfalas East"},
		{l="67.0s,55.8w", z="West Gondor", n="Calembel"},
		{l="77.4s,24.6w", z="East Gondor", n="Arnach"},
		{l="65.2s,17.8w", z="Old Anorien", n="Minas Tirith"},
	},
	Mordor = {
		{l="65.2s,17.8w", z="March of the King", n="Minas Tirith(AB)"},
		{l="63.2s,7.1w", z="March of the King", n="Osgiliath"},
		{l="40.9s,10.4w", z="The Wastes", n="Camp of the Host"},
		{l="77.4s,24.6w", z="King's Gondor", n="Arnach"},
		{l="83.8s,34.3w", z="King's Gondor", n="Pelargir"},
		{l="67.0s,55.8w", z="King's Gondor", n="Calembel"},
		{l="74.6s,71.1w", z="King's Gondor", n="Dol Amroth"},
		{l="68.6s,89.0w", z="Outer Gondor", n="Lond Cirion"},
	},
	Haradwaith = {
		{l="20.4s,97.8w", z="Cape of Umbar", n="Umbar Baharbel"},
		{l="17.9s,98.3w", z="Cape of Umbar", n="Umbar Baharbel North"},
		{l="9.7s,125.9w", z="Zirer Tarka", n="Halrax"},
	}
}

Zones = { }
for n,t in pairs(Locs) do
	if t.d and t.r then
		local z = t.z
		if Zones[z] then Zones[z] = Zones[z]+1
		else Zones[z] = 1 end
	end
end
zones = { }
for name in pairs(Zones) do
    table.insert(zones,name)
end
table.sort(zones)

Areas = { }
for n,t in pairs(Locs) do
	if t.a then Areas[t.a] = t.z end
end
